(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define gerbil/tools/gxtags#main
    (lambda _args1147_
      (letrec* ((_gopt1149_
                 (std/getopt#getopt
                  (std/getopt#flag__%__0
                   '#f
                   '"append to existing tag file"
                   'append
                   '"-a")
                  (std/getopt#option__%__0
                   '#f
                   '"explicit name of file for tag table"
                   absent-value
                   '"TAGS"
                   'output
                   '"-o")
                  (std/getopt#flag__%__%
                   '#f
                   '"display help"
                   'help
                   '"-h"
                   '"--help")
                  (std/getopt#rest-arguments__%
                   '#f
                   '"source file or directory"
                   absent-value
                   'input)))
                (_help1150_
                 (lambda (_what1166_)
                   (std/getopt#getopt-display-help__0 _what1166_ '"gxtags"))))
        (with-exception-catcher
         (lambda (_g11511153_)
           (if ((lambda (_$obj1156_)
                  (let ()
                    (declare (not safe))
                    (##structure-instance-of?
                     _$obj1156_
                     'std/getopt#getopt-error::t)))
                _g11511153_)
               (let ((_exn1159_ _g11511153_)) (_help1150_ _exn1159_) (exit '1))
               (raise _g11511153_)))
         (lambda ()
           (let ((_opt1162_ (std/getopt#getopt-parse _gopt1149_ _args1147_)))
             (if (table-ref _opt1162_ 'help '#f)
                 (_help1150_ _gopt1149_)
                 (let ((_inputs1164_ (table-ref _opt1162_ 'input '#f)))
                   (if (null? _inputs1164_)
                       (begin (_help1150_ _gopt1149_) (exit '1))
                       (gerbil/tools/gxtags#run
                        (table-ref _opt1162_ 'input '#f)
                        (table-ref _opt1162_ 'output '#f)
                        (table-ref _opt1162_ 'append '#f)))))))))))
  (define gerbil/tools/gxtags#run
    (lambda (_inputs1143_ _tagfile1144_ _append?1145_)
      (_gx#load-expander!)
      (gerbil/tools/gxtags#make-tags__%
       _inputs1143_
       _tagfile1144_
       _append?1145_)))
  (define gerbil/tools/gxtags#current-tags-path (make-parameter '#f))
  (define gerbil/tools/gxtags#make-tags__%
    (lambda (_inputs1120_ _tagfile1121_ _append?1122_)
      (call-with-output-file
       (cons 'path:
             (cons _tagfile1121_ (cons 'append: (cons _append?1122_ '()))))
       (lambda (_output1124_)
         (call-with-parameters
          (lambda ()
            (for-each
             (lambda (_g11261128_)
               (gerbil/tools/gxtags#tag-input _g11261128_ _output1124_))
             _inputs1120_))
          gerbil/tools/gxtags#current-tags-path
          (path-normalize _tagfile1121_))))))
  (define gerbil/tools/gxtags#make-tags__0
    (lambda (_inputs1134_ _tagfile1135_)
      (let ((_append?1137_ '#f))
        (gerbil/tools/gxtags#make-tags__%
         _inputs1134_
         _tagfile1135_
         _append?1137_))))
  (define gerbil/tools/gxtags#make-tags
    (lambda _g7369_
      (let ((_g7368_ (let () (declare (not safe)) (##length _g7369_))))
        (cond ((let () (declare (not safe)) (##fx= _g7368_ 2))
               (apply gerbil/tools/gxtags#make-tags__0 _g7369_))
              ((let () (declare (not safe)) (##fx= _g7368_ 3))
               (apply gerbil/tools/gxtags#make-tags__% _g7369_))
              (else
               (##raise-wrong-number-of-arguments-exception
                gerbil/tools/gxtags#make-tags
                _g7369_))))))
  (define gerbil/tools/gxtags#file-directory?
    (lambda (_path1117_) (eq? (file-type _path1117_) 'directory)))
  (define gerbil/tools/gxtags#tag-input
    (lambda (_input1114_ _output1115_)
      (if (file-exists? _input1114_)
          (if (gerbil/tools/gxtags#file-directory? _input1114_)
              (gerbil/tools/gxtags#tag-directory _input1114_ _output1115_)
              (gerbil/tools/gxtags#tag-source-file _input1114_ _output1115_))
          (error '"No such file or directory" _input1114_))))
  (define gerbil/tools/gxtags#tag-directory
    (lambda (_dirname1102_ _output1103_)
      (let ((_files1105_
             (std/sort#sort (directory-files _dirname1102_) string<?)))
        (for-each
         (lambda (_file1107_)
           (let ((_path1109_ (path-expand _file1107_ _dirname1102_)))
             (if (or (gerbil/tools/gxtags#file-directory? _path1109_)
                     (member (path-extension _path1109_) '(".ss" ".ssi")))
                 (gerbil/tools/gxtags#tag-input _path1109_ _output1103_)
                 '#!void)))
         _files1105_))))
  (define gerbil/tools/gxtags#tag-source-file
    (lambda (_filename1084_ _output1085_)
      (let ((_$e1087_ (gerbil/tools/gxtags#try-import-module _filename1084_)))
        (if _$e1087_
            ((lambda (_ctx1090_)
               (displayln '"TAG " _filename1084_)
               (let ((_xtab1092_ (make-table 'test: eq?)))
                 (for-each
                  (lambda (_xport1094_)
                    (let ((_bind1096_
                           (gx#core-resolve-module-export _xport1094_)))
                      (hash-update!
                       _xtab1092_
                       (##structure-ref _bind1096_ '1 gx#binding::t '#f)
                       (lambda (_g10971099_)
                         (cons (##direct-structure-ref
                                _xport1094_
                                '4
                                gx#module-export::t
                                '#f)
                               _g10971099_))
                       '())))
                  (##structure-ref _ctx1090_ '9 gx#module-context::t '#f))
                 (gerbil/tools/gxtags#write-tags
                  (gerbil/tools/gxtags#module-tags _ctx1090_ _xtab1092_)
                  _filename1084_
                  _output1085_)))
             _$e1087_)
            (displayln '"SKIP " _filename1084_)))))
  (define gerbil/tools/gxtags#module-tags
    (lambda (_ctx336_ _xtab337_)
      (letrec* ((_tags339_ '())
                (_loc340_ '#f)
                (_tag!485_
                 (lambda (_eid1081_ _name1082_)
                   (set! _tags339_
                         (cons (cons _eid1081_
                                     (cons _name1082_ (cons _loc340_ '())))
                               _tags339_))))
                (_tag-e486_
                 (lambda (_stx595_)
                   (let* ((_K1072_ (lambda ()
                                     (let* ((___stx72157216_ _stx595_)
                                            (_g604695_
                                             (lambda ()
                                               (gx#raise-syntax-error
                                                '#f
                                                '"Bad syntax"
                                                ___stx72157216_))))
                                       (let ((___kont72177218_
                                              (lambda (_L1049_)
                                                (for-each
                                                 _tag-e486_
                                                 (foldr1 (lambda (_g10611064_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _g10621066_)
                   (cons _g10611064_ _g10621066_))
                 '()
                 _L1049_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                             (___kont72217222_
                                              (lambda (_L991_)
                                                (call-with-parameters
                                                 (lambda ()
                                                   (for-each
                                                    _tag-e486_
                                                    (foldr1 (lambda (_g10041007_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                             _g10051009_)
                      (cons _g10041007_ _g10051009_))
                    '()
                    _L991_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 gx#current-expander-phi
                                                 (fx+ (gx#current-expander-phi)
                                                      '1))))
                                             (___kont72257226_
                                              (lambda (_L930_)
                                                (for-each
                                                 _tag-def487_
                                                 (filter values
                                                         (foldr1 (lambda (_g946949_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                                  _g947951_)
                           (cons _g946949_ _g947951_))
                         '()
                         _L930_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                             (___kont72297230_
                                              (lambda (_L864_)
                                                (_tag-def487_ _L864_)))
                                             (___kont72317232_
                                              (lambda (_L815_)
                                                (for-each
                                                 _tag-decl488_
                                                 (foldr1 (lambda (_g827830_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _g828832_)
                   (cons _g827830_ _g828832_))
                 '()
                 _L815_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                             (___kont72357236_
                                              (lambda (_L747_ _L748_)
                                                (let ((_eid767_
                                                       (##structure-ref
                                                        (gx#resolve-identifier__0
                                                         _L748_)
                                                        '1
                                                        gx#binding::t
                                                        '#f))
                                                      (_ctx768_
                                                       (gx#syntax-local-e__0
                                                        _L748_)))
                                                  (call-with-parameters
                                                   (lambda ()
                                                     (_tag-name!489_ _eid767_)
                                                     (for-each
                                                      _tag-e486_
                                                      (foldr1 (lambda (_g770773_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                               _g771775_)
                        (cons _g770773_ _g771775_))
                      '()
                      _L747_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   gx#current-expander-context
                                                   _ctx768_))))
                                             (___kont72397240_
                                              (lambda () '#!void)))
                                         (let* ((___match73667367_
                                                 (lambda (_e676707_
                                                          _hd677710_
                                                          _tl678712_
                                                          _e679715_
                                                          _hd680718_
                                                          _tl681720_
                                                          ___splice72377238_
                                                          _target682723_
                                                          _tl684725_)
                                                   (letrec ((_loop685728_
                                                             (lambda (_hd683731_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              _expr689733_)
                       (if (gx#stx-pair? _hd683731_)
                           (let ((_e686736_ (gx#stx-e _hd683731_)))
                             (let ((_lp-tl688741_
                                    (let ()
                                      (declare (not safe))
                                      (##cdr _e686736_)))
                                   (_lp-hd687739_
                                    (let ()
                                      (declare (not safe))
                                      (##car _e686736_))))
                               (_loop685728_
                                _lp-tl688741_
                                (cons _lp-hd687739_ _expr689733_))))
                           (let ((_expr690744_ (reverse _expr689733_)))
                             (___kont72357236_ _expr690744_ _hd680718_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_loop685728_
                                                      _target682723_
                                                      '()))))
                                                (___match73427343_
                                                 (lambda (_e662783_
                                                          _hd663786_
                                                          _tl664788_
                                                          ___splice72337234_
                                                          _target665791_
                                                          _tl667793_)
                                                   (letrec ((_loop668796_
                                                             (lambda (_hd666799_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              _decl672801_)
                       (if (gx#stx-pair? _hd666799_)
                           (let ((_e669804_ (gx#stx-e _hd666799_)))
                             (let ((_lp-tl671809_
                                    (let ()
                                      (declare (not safe))
                                      (##cdr _e669804_)))
                                   (_lp-hd670807_
                                    (let ()
                                      (declare (not safe))
                                      (##car _e669804_))))
                               (_loop668796_
                                _lp-tl671809_
                                (cons _lp-hd670807_ _decl672801_))))
                           (let ((_decl673812_ (reverse _decl672801_)))
                             (___kont72317232_ _decl673812_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_loop668796_
                                                      _target665791_
                                                      '()))))
                                                (___match73007301_
                                                 (lambda (_e633882_
                                                          _hd634885_
                                                          _tl635887_
                                                          _e636890_
                                                          _hd637893_
                                                          _tl638895_
                                                          ___splice72277228_
                                                          _target639898_
                                                          _tl641900_)
                                                   (letrec ((_loop642903_
                                                             (lambda (_hd640906_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              _id646908_)
                       (if (gx#stx-pair? _hd640906_)
                           (let ((_e643911_ (gx#stx-e _hd640906_)))
                             (let ((_lp-tl645916_
                                    (let ()
                                      (declare (not safe))
                                      (##cdr _e643911_)))
                                   (_lp-hd644914_
                                    (let ()
                                      (declare (not safe))
                                      (##car _e643911_))))
                               (_loop642903_
                                _lp-tl645916_
                                (cons _lp-hd644914_ _id646908_))))
                           (let ((_id647919_ (reverse _id646908_)))
                             (if (gx#stx-pair? _tl638895_)
                                 (let ((_e648922_ (gx#stx-e _tl638895_)))
                                   (let ((_tl650927_
                                          (let ()
                                            (declare (not safe))
                                            (##cdr _e648922_)))
                                         (_hd649925_
                                          (let ()
                                            (declare (not safe))
                                            (##car _e648922_))))
                                     (if (gx#stx-null? _tl650927_)
                                         (___kont72257226_ _id647919_)
                                         (___kont72397240_))))
                                 (___kont72397240_)))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_loop642903_
                                                      _target639898_
                                                      '()))))
                                                (___match72767277_
                                                 (lambda (_e620959_
                                                          _hd621962_
                                                          _tl622964_
                                                          ___splice72237224_
                                                          _target623967_
                                                          _tl625969_)
                                                   (letrec ((_loop626972_
                                                             (lambda (_hd624975_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              _expr630977_)
                       (if (gx#stx-pair? _hd624975_)
                           (let ((_e627980_ (gx#stx-e _hd624975_)))
                             (let ((_lp-tl629985_
                                    (let ()
                                      (declare (not safe))
                                      (##cdr _e627980_)))
                                   (_lp-hd628983_
                                    (let ()
                                      (declare (not safe))
                                      (##car _e627980_))))
                               (_loop626972_
                                _lp-tl629985_
                                (cons _lp-hd628983_ _expr630977_))))
                           (let ((_expr631988_ (reverse _expr630977_)))
                             (___kont72217222_ _expr631988_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_loop626972_
                                                      _target623967_
                                                      '()))))
                                                (___match72587259_
                                                 (lambda (_e6071017_
                                                          _hd6081020_
                                                          _tl6091022_
                                                          ___splice72197220_
                                                          _target6101025_
                                                          _tl6121027_)
                                                   (letrec ((_loop6131030_
                                                             (lambda (_hd6111033_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              _expr6171035_)
                       (if (gx#stx-pair? _hd6111033_)
                           (let ((_e6141038_ (gx#stx-e _hd6111033_)))
                             (let ((_lp-tl6161043_
                                    (let ()
                                      (declare (not safe))
                                      (##cdr _e6141038_)))
                                   (_lp-hd6151041_
                                    (let ()
                                      (declare (not safe))
                                      (##car _e6141038_))))
                               (_loop6131030_
                                _lp-tl6161043_
                                (cons _lp-hd6151041_ _expr6171035_))))
                           (let ((_expr6181046_ (reverse _expr6171035_)))
                             (___kont72177218_ _expr6181046_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_loop6131030_
                                                      _target6101025_
                                                      '())))))
                                           (if (gx#stx-pair? ___stx72157216_)
                                               (let ((_e6071017_
                                                      (gx#stx-e
                                                       ___stx72157216_)))
                                                 (let ((_tl6091022_
                                                        (let ()
                                                          (declare (not safe))
                                                          (##cdr _e6071017_)))
                                                       (_hd6081020_
                                                        (let ()
                                                          (declare (not safe))
                                                          (##car _e6071017_))))
                                                   (if (gx#identifier?
                                                        _hd6081020_)
                                                       (if (gx#stx-eq?
                                                            '%#begin
                                                            _hd6081020_)
                                                           (if (gx#stx-pair/null?
                                                                _tl6091022_)
                                                               (let ((___splice72197220_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              (gx#syntax-split-splice _tl6091022_ '0)))
                         (let ((_tl6121027_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref ___splice72197220_ '1)))
                               (_target6101025_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref ___splice72197220_ '0))))
                           (if (gx#stx-null? _tl6121027_)
                               (___match72587259_
                                _e6071017_
                                _hd6081020_
                                _tl6091022_
                                ___splice72197220_
                                _target6101025_
                                _tl6121027_)
                               (___kont72397240_))))
                       (___kont72397240_))
                   (if (gx#stx-eq? '%#begin-syntax _hd6081020_)
                       (if (gx#stx-pair/null? _tl6091022_)
                           (let ((___splice72237224_
                                  (gx#syntax-split-splice _tl6091022_ '0)))
                             (let ((_tl625969_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref ___splice72237224_ '1)))
                                   (_target623967_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref ___splice72237224_ '0))))
                               (if (gx#stx-null? _tl625969_)
                                   (___match72767277_
                                    _e6071017_
                                    _hd6081020_
                                    _tl6091022_
                                    ___splice72237224_
                                    _target623967_
                                    _tl625969_)
                                   (___kont72397240_))))
                           (___kont72397240_))
                       (if (gx#stx-eq? '%#define-values _hd6081020_)
                           (if (gx#stx-pair? _tl6091022_)
                               (let ((_e636890_ (gx#stx-e _tl6091022_)))
                                 (let ((_tl638895_
                                        (let ()
                                          (declare (not safe))
                                          (##cdr _e636890_)))
                                       (_hd637893_
                                        (let ()
                                          (declare (not safe))
                                          (##car _e636890_))))
                                   (if (gx#stx-pair/null? _hd637893_)
                                       (let ((___splice72277228_
                                              (gx#syntax-split-splice
                                               _hd637893_
                                               '0)))
                                         (let ((_tl641900_
                                                (let ()
                                                  (declare (not safe))
                                                  (##vector-ref
                                                   ___splice72277228_
                                                   '1)))
                                               (_target639898_
                                                (let ()
                                                  (declare (not safe))
                                                  (##vector-ref
                                                   ___splice72277228_
                                                   '0))))
                                           (if (gx#stx-null? _tl641900_)
                                               (___match73007301_
                                                _e6071017_
                                                _hd6081020_
                                                _tl6091022_
                                                _e636890_
                                                _hd637893_
                                                _tl638895_
                                                ___splice72277228_
                                                _target639898_
                                                _tl641900_)
                                               (___kont72397240_))))
                                       (___kont72397240_))))
                               (___kont72397240_))
                           (if (gx#stx-eq? '%#define-syntax _hd6081020_)
                               (if (gx#stx-pair? _tl6091022_)
                                   (let ((_e655848_ (gx#stx-e _tl6091022_)))
                                     (let ((_tl657853_
                                            (let ()
                                              (declare (not safe))
                                              (##cdr _e655848_)))
                                           (_hd656851_
                                            (let ()
                                              (declare (not safe))
                                              (##car _e655848_))))
                                       (if (gx#stx-pair? _tl657853_)
                                           (let ((_e658856_
                                                  (gx#stx-e _tl657853_)))
                                             (let ((_tl660861_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##cdr _e658856_)))
                                                   (_hd659859_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##car _e658856_))))
                                               (if (gx#stx-null? _tl660861_)
                                                   (___kont72297230_
                                                    _hd656851_)
                                                   (___kont72397240_))))
                                           (___kont72397240_))))
                                   (___kont72397240_))
                               (if (gx#stx-eq? '%#extern _hd6081020_)
                                   (if (gx#stx-pair/null? _tl6091022_)
                                       (let ((___splice72337234_
                                              (gx#syntax-split-splice
                                               _tl6091022_
                                               '0)))
                                         (let ((_tl667793_
                                                (let ()
                                                  (declare (not safe))
                                                  (##vector-ref
                                                   ___splice72337234_
                                                   '1)))
                                               (_target665791_
                                                (let ()
                                                  (declare (not safe))
                                                  (##vector-ref
                                                   ___splice72337234_
                                                   '0))))
                                           (if (gx#stx-null? _tl667793_)
                                               (___match73427343_
                                                _e6071017_
                                                _hd6081020_
                                                _tl6091022_
                                                ___splice72337234_
                                                _target665791_
                                                _tl667793_)
                                               (___kont72397240_))))
                                       (___kont72397240_))
                                   (if (gx#stx-eq? '%#module _hd6081020_)
                                       (if (gx#stx-pair? _tl6091022_)
                                           (let ((_e679715_
                                                  (gx#stx-e _tl6091022_)))
                                             (let ((_tl681720_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##cdr _e679715_)))
                                                   (_hd680718_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##car _e679715_))))
                                               (if (gx#stx-pair/null?
                                                    _tl681720_)
                                                   (let ((___splice72377238_
                                                          (gx#syntax-split-splice
                                                           _tl681720_
                                                           '0)))
                                                     (let ((_tl684725_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##vector-ref
                                                               ___splice72377238_
                                                               '1)))
                                                           (_target682723_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##vector-ref
                                                               ___splice72377238_
                                                               '0))))
                                                       (if (gx#stx-null?
                                                            _tl684725_)
                                                           (___match73667367_
                                                            _e6071017_
                                                            _hd6081020_
                                                            _tl6091022_
                                                            _e679715_
                                                            _hd680718_
                                                            _tl681720_
                                                            ___splice72377238_
                                                            _target682723_
                                                            _tl684725_)
                                                           (___kont72397240_))))
                                                   (___kont72397240_))))
                                           (___kont72397240_))
                                       (___kont72397240_)))))))
               (___kont72397240_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                               (___kont72397240_)))))))
                          (_new-loc1075_ (gx#stx-source _stx595_)))
                     (if _new-loc1075_
                         (let ((_save-loc1078_ _loc340_))
                           (set! _loc340_ _new-loc1075_)
                           (_K1072_)
                           (set! _loc340_ _save-loc1078_))
                         (_K1072_)))))
                (_tag-def487_
                 (lambda (_id583_)
                   (let* ((_K586_ (lambda ()
                                    (_tag-name!489_
                                     (##structure-ref
                                      (gx#resolve-identifier__0 _id583_)
                                      '1
                                      gx#binding::t
                                      '#f))))
                          (_new-loc589_ (gx#stx-source _id583_)))
                     (if _new-loc589_
                         (let ((_save-loc592_ _loc340_))
                           (set! _loc340_ _new-loc589_)
                           (_K586_)
                           (set! _loc340_ _save-loc592_))
                         (_K586_)))))
                (_tag-decl488_
                 (lambda (_decl519_)
                   (let* ((_g521535_
                           (lambda (_g522532_)
                             (gx#raise-syntax-error
                              '#f
                              '"Bad syntax"
                              _g522532_)))
                          (_g520580_
                           (lambda (_g522538_)
                             (if (gx#stx-pair? _g522538_)
                                 (let ((_e525540_ (gx#stx-e _g522538_)))
                                   (let ((_hd526543_
                                          (let ()
                                            (declare (not safe))
                                            (##car _e525540_)))
                                         (_tl527545_
                                          (let ()
                                            (declare (not safe))
                                            (##cdr _e525540_))))
                                     (if (gx#stx-pair? _tl527545_)
                                         (let ((_e528548_
                                                (gx#stx-e _tl527545_)))
                                           (let ((_hd529551_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##car _e528548_)))
                                                 (_tl530553_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##cdr _e528548_))))
                                             (if (gx#stx-null? _tl530553_)
                                                 ((lambda (_L556_ _L557_)
                                                    (let* ((_K571_ (lambda ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                             (_tag-name!489_ (gx#stx-e _L556_))))
                   (_new-loc574_ (gx#stx-source _L557_)))
              (if _new-loc574_
                  (let ((_save-loc577_ _loc340_))
                    (set! _loc340_ _new-loc574_)
                    (_K571_)
                    (set! _loc340_ _save-loc577_))
                  (_K571_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                  _hd529551_
                                                  _hd526543_)
                                                 (_g521535_ _g522538_))))
                                         (_g521535_ _g522538_))))
                                 (_g521535_ _g522538_)))))
                     (_g520580_ _decl519_))))
                (_tag-name!489_
                 (lambda (_eid509_)
                   (let ((_names510512_ (table-ref _xtab337_ _eid509_ '#f)))
                     (if _names510512_
                         (let ((_names515_ _names510512_))
                           (for-each
                            (lambda (_name517_) (_tag!485_ _eid509_ _name517_))
                            (std/srfi/1#delete-duplicates _names515_ eq?)))
                         '#f)))))
        (let ((_stx491_
               (##structure-ref _ctx336_ '11 gx#module-context::t '#f)))
          (let* ((_id493_ (##structure-ref
                           _ctx336_
                           '1
                           gx#expander-context::t
                           '#f))
                 (_gid495_ (make-symbol '":" _id493_)))
            (let* ((_K499_ (lambda () (_tag!485_ 'module _gid495_)))
                   (_new-loc502_ (gx#stx-source _stx491_)))
              (if _new-loc502_
                  (let ((_save-loc505_ _loc340_))
                    (set! _loc340_ _new-loc502_)
                    (_K499_)
                    (set! _loc340_ _save-loc505_))
                  (_K499_))))
          (call-with-parameters
           (lambda () (_tag-e486_ _stx491_))
           gx#current-expander-context
           _ctx336_
           gx#current-expander-phi
           '0)
          (std/srfi/1#reverse! _tags339_)))))
  (define gerbil/tools/gxtags#write-tags
    (lambda (_tags251_ _filename252_ _output253_)
      (let* ((_lines255_
              (std/misc/ports#read-file-lines__%
               '#f
               absent-value
               _filename252_))
             (_lines257_
              (if (null? _lines255_) '#("") (list->vector _lines255_)))
             (_offsets259_
              (gerbil/tools/gxtags#file-line-offsets _filename252_))
             (_tmp261_ (open-output-string))
             (_filepath263_ (path-normalize _filename252_))
             (_rfilepath265_
              (path-normalize
               _filepath263_
               '#t
               (gerbil/tools/gxtags#current-tags-path)))
             (_out-of-file-tags267_ '()))
        (for-each
         (lambda (_tag270_)
           (let* ((_tag271282_ _tag270_)
                  (_E273286_
                   (lambda () (error '"No clause matching" _tag271282_)))
                  (_K274304_
                   (lambda (_loc289_ _name290_)
                     (let ((_path292_ (source-location-path _loc289_)))
                       (if (or (equal? _path292_ _filepath263_)
                               (not _path292_))
                           (let* ((_line297_
                                   (gerbil/tools/gxtags#source-location-line
                                    _loc289_))
                                  (_anchor299_
                                   (vector-ref _lines257_ (fx- _line297_ '1)))
                                  (_offset301_
                                   (vector-ref
                                    _offsets259_
                                    (fx- _line297_ '1))))
                             (gerbil/gambit/ports#write-string__%
                              _anchor299_
                              _tmp261_)
                             (write-char '#\delete _tmp261_)
                             (display _name290_ _tmp261_)
                             (write-char '#\x1 _tmp261_)
                             (display _line297_ _tmp261_)
                             (write-char '#\, _tmp261_)
                             (display _offset301_ _tmp261_)
                             (newline _tmp261_))
                           (set! _out-of-file-tags267_
                                 (cons _tag270_ _out-of-file-tags267_)))))))
             (if (let () (declare (not safe)) (##pair? _tag271282_))
                 (let ((_tl276307_
                        (let () (declare (not safe)) (##cdr _tag271282_))))
                   (if (let () (declare (not safe)) (##pair? _tl276307_))
                       (let ((_hd277310_
                              (let () (declare (not safe)) (##car _tl276307_)))
                             (_tl278312_
                              (let ()
                                (declare (not safe))
                                (##cdr _tl276307_))))
                         (let ((_name315_ _hd277310_))
                           (if (let ()
                                 (declare (not safe))
                                 (##pair? _tl278312_))
                               (let ((_hd279317_
                                      (let ()
                                        (declare (not safe))
                                        (##car _tl278312_)))
                                     (_tl280319_
                                      (let ()
                                        (declare (not safe))
                                        (##cdr _tl278312_))))
                                 (let ((_loc322_ _hd279317_))
                                   (if (let ()
                                         (declare (not safe))
                                         (##null? _tl280319_))
                                       (_K274304_ _loc322_ _name315_)
                                       (_E273286_))))
                               (_E273286_))))
                       (_E273286_)))
                 (_E273286_))))
         _tags251_)
        (let* ((_str324_ (get-output-string _tmp261_))
               (_len326_ (std/text/utf8#string-utf8-length__0 _str324_)))
          (write-char '#\page _output253_)
          (newline _output253_)
          (gerbil/gambit/ports#write-string__% _rfilepath265_ _output253_)
          (write-char '#\, _output253_)
          (display _len326_ _output253_)
          (newline _output253_)
          (gerbil/gambit/ports#write-string__% _str324_ _output253_)
          (if (null? _out-of-file-tags267_)
              '#!void
              (let* ((_tags329_ (std/srfi/1#reverse! _out-of-file-tags267_))
                     (_path331_ (source-location-path (caddar _tags329_)))
                     (_filename333_ (path-normalize _path331_ '#t)))
                (gerbil/tools/gxtags#write-tags
                 _tags329_
                 _filename333_
                 _output253_)))))))
  (define gerbil/tools/gxtags#+nl+ (char->integer '#\newline))
  (define gerbil/tools/gxtags#file-line-offsets
    (lambda (_filename238_)
      (call-with-input-file
       _filename238_
       (lambda (_inp240_)
         (let _lp242_ ((_i244_ '0) (_offs245_ (cons '0 '())))
           (let ((_next247_ (read-u8 _inp240_)))
             (if (eof-object? _next247_)
                 (list->vector (std/srfi/1#reverse! _offs245_))
                 (if (eq? _next247_ gerbil/tools/gxtags#+nl+)
                     (let ((_i+1249_ (fx+ _i244_ '1)))
                       (_lp242_ _i+1249_ (cons _i+1249_ _offs245_)))
                     (_lp242_ (fx+ _i244_ '1) _offs245_)))))))))
  (define gerbil/tools/gxtags#source-location-line
    (lambda (_locat234_)
      (if (let () (declare (not safe)) (##locat? _locat234_))
          (let ((_filepos236_
                 (let ((__tmp7370
                        (let ()
                          (declare (not safe))
                          (##locat-position _locat234_))))
                   (declare (not safe))
                   (##position->filepos __tmp7370))))
            (fx+ (let () (declare (not safe)) (##filepos-line _filepos236_))
                 '1))
          '1)))
  (define gerbil/tools/gxtags#try-import-module
    (lambda (_filename225_)
      (with-exception-catcher
       (lambda (_g226228_)
         (if '#t (let ((_e231_ _g226228_)) '#f) (raise _g226228_)))
       (lambda () (gx#import-module__0 _filename225_))))))
