(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define scheme/base-ports#input-port-open?
    (lambda (_port1288_)
      (if (not (input-port? _port1288_))
          (error '"Bad argument; expected input port" _port1288_)
          (if (macro-closed? (macro-port-roptions _port1288_))
              '#f
              (if (macro-device-port? _port1288_)
                  (scheme/base-ports#rdevice-open?
                   (macro-condvar-name
                    (macro-device-port-rdevice-condvar _port1288_)))
                  (if (macro-raw-device-port? _port1288_)
                      (scheme/base-ports#rdevice-open?
                       (macro-condvar-name
                        (macro-raw-device-port-rdevice-condvar _port1288_)))
                      '#t))))))
  (define scheme/base-ports#output-port-open?
    (lambda (_port1286_)
      (if (not (output-port? _port1286_))
          (error '"Bad argument; expected input port" _port1286_)
          (if (macro-closed? (macro-port-woptions _port1286_))
              '#f
              (if (macro-device-port? _port1286_)
                  (scheme/base-ports#wdevice-open?
                   (macro-condvar-name
                    (macro-device-port-wdevice-condvar _port1286_)))
                  (if (macro-raw-device-port? _port1286_)
                      (scheme/base-ports#wdevice-open?
                       (macro-condvar-name
                        (macro-raw-device-port-wdevice-condvar _port1286_)))
                      '#t))))))
  (namespace ("scheme/base-ports#" rdevice-open? wdevice-open?))
  (c-declare
   "#ifndef ___STAGE_OPEN\n#define ___STAGE_OPEN 0\n#endif\n#ifndef ___FFI_HAVE_DEVICE\n#define ___FFI_HAVE_DEVICE\ntypedef struct ___device_struct\n  {\n    void *vtbl;\n    int refcount;                  /* device structure is released when zero */\n    void *group;                   /* device group this device belongs to */\n    struct ___device_struct *prev; /* bidirectional list pointer to previous */\n    struct ___device_struct *next; /* bidirectional list pointer to next */\n    int direction;                 /* ___DIRECTION_RD and/or ___DIRECTION_WR */\n    int close_direction;           /* ___DIRECTION_RD and/or ___DIRECTION_WR */\n    int read_stage;                /* ___STAGE_OPEN ... ___STAGE_CLOSED */\n    int write_stage;               /* ___STAGE_OPEN ... ___STAGE_CLOSED */\n  } ___device;\n#endif\n\nstatic ___SCMOBJ ___rdevice_openp(___SCMOBJ dev)\n{\n ___device *d = ___CAST(___device*,___FIELD(dev,___FOREIGN_PTR));\n if (d->read_stage != ___STAGE_OPEN)\n {\n  return ___FAL;\n }\n else\n {\n  return ___TRU;\n }\n}\n\nstatic ___SCMOBJ ___wdevice_openp(___SCMOBJ dev)\n{\n ___device *d = ___CAST(___device*,___FIELD(dev,___FOREIGN_PTR));\n if (d->write_stage != ___STAGE_OPEN)\n {\n  return ___FAL;\n }\n else\n {\n  return ___TRU;\n }\n}")
  (define-macro (define-c-lambda id args ret #!optional (name #f))
    (let ((name (or name (##symbol->string id))))
      `(define ,id (c-lambda ,args ,ret ,name))))
  (define-c-lambda
   rdevice-open?
   (scheme-object)
   scheme-object
   "___rdevice_openp")
  (define-c-lambda
   wdevice-open?
   (scheme-object)
   scheme-object
   "___wdevice_openp")
  (define scheme/base-ports#port-buffered-chars?
    (lambda (_port1281_)
      (let ((_$e1283_
             (let ((__tmp9694 (macro-character-port-rlo _port1281_))
                   (__tmp9693 (macro-character-port-rhi _port1281_)))
               (declare (not safe))
               (##fx< __tmp9694 __tmp9693))))
        (if _$e1283_ _$e1283_ (macro-character-port-peek-eof? _port1281_)))))
  (define scheme/base-ports#check-byte-port/lock!
    (lambda (_port1278_ _proc1279_)
      (if (macro-byte-port? _port1278_)
          '#!void
          (error '"Illegal argument; expected byte-port" _port1278_))
      (macro-port-mutex-lock! _port1278_)
      (if (scheme/base-ports#port-buffered-chars? _port1278_)
          (begin
            (macro-port-mutex-unlock! _port1278_)
            (let ()
              (declare (not safe))
              (##raise-nonempty-input-port-character-buffer-exception
               _port1278_
               _proc1279_
               _port1278_)))
          '#!void)))
  (define scheme/base-ports#peek-u8
    (lambda (_port1266_)
      (scheme/base-ports#check-byte-port/lock!
       _port1266_
       scheme/base-ports#peek-u8)
      (let _lp1268_ ()
        (let ((_byte-rlo1271_ (macro-byte-port-rlo _port1266_))
              (_byte-rhi1272_ (macro-byte-port-rhi _port1266_)))
          (if (let ()
                (declare (not safe))
                (##fx< _byte-rlo1271_ _byte-rhi1272_))
              (let ((_byte1274_
                     (u8vector-ref
                      (macro-byte-port-rbuf _port1266_)
                      _byte-rlo1271_)))
                (macro-port-mutex-unlock! _port1266_)
                _byte1274_)
              (let ((_res1276_
                     ((macro-byte-port-rbuf-fill _port1266_)
                      _port1266_
                      '1
                      '#t)))
                (if (eq? _res1276_ ##err-code-EAGAIN)
                    (begin (macro-port-mutex-unlock! _port1266_) (eof-object))
                    (if (fixnum? _res1276_)
                        (begin
                          (macro-port-mutex-unlock! _port1266_)
                          (let ()
                            (declare (not safe))
                            (##raise-os-io-exception
                             _port1266_
                             '#f
                             _res1276_
                             scheme/base-ports#peek-u8
                             _port1266_)))
                        (if _res1276_
                            (_lp1268_)
                            (begin
                              (macro-port-mutex-unlock! _port1266_)
                              (eof-object))))))))))))
