(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/actor/rpc/connection#errorf
    (lambda (_fmt257177_ . _args257178_)
      (std/logger#log-message 'rpc '0 _fmt257177_ _args257178_)))
  (define std/actor/rpc/connection#warnf
    (lambda (_fmt257174_ . _args257175_)
      (std/logger#log-message 'rpc '1 _fmt257174_ _args257175_)))
  (define std/actor/rpc/connection#infof
    (lambda (_fmt257171_ . _args257172_)
      (std/logger#log-message 'rpc '2 _fmt257171_ _args257172_)))
  (define std/actor/rpc/connection#debugf
    (lambda (_fmt257168_ . _args257169_)
      (std/logger#log-message 'rpc '3 _fmt257168_ _args257169_)))
  (define std/actor/rpc/connection#verbosef
    (lambda (_fmt257163_ . _args257165_)
      (std/logger#log-message 'rpc '4 _fmt257163_ _args257165_)))
  (define std/actor/rpc/connection#rpc-server-connection
    (lambda (_rpc-server257149_
             _actors257150_
             _sock257151_
             _sa257152_
             _cliaddr257153_
             _proto-e257154_)
      (with-exception-catcher
       (lambda (_g257155257157_)
         (if '#t
             (let ((_e257160_ _g257155257157_))
               (std/actor/rpc/connection#rpc-connection-cleanup
                _rpc-server257149_
                _e257160_
                _sock257151_))
             (raise _g257155257157_)))
       (lambda ()
         (std/actor/rpc/connection#rpc-set-nodelay!
          _sock257151_
          (std/os/_socket#sockaddr_family _sa257152_))
         (std/actor/rpc/connection#rpc-connection-loop
          _rpc-server257149_
          _actors257150_
          _sock257151_
          _cliaddr257153_
          _proto-e257154_)))))
  (define std/actor/rpc/connection#rpc-client-connection
    (lambda (_rpc-server257132_ _actors257133_ _address257134_ _proto-e257135_)
      (with-exception-catcher
       (lambda (_g257136257138_)
         (if '#t
             (let ((_e257141_ _g257136257138_))
               (std/actor/rpc/connection#rpc-connection-cleanup
                _rpc-server257132_
                _e257141_
                '#f))
             (raise _g257136257138_)))
       (lambda ()
         (let* ((_sa257144_ (std/os/socket#socket-address _address257134_))
                (_cli257146_
                 (std/net/socket/api#ssocket-connect__0 _sa257144_)))
           (std/actor/rpc/connection#rpc-set-nodelay!
            _cli257146_
            (std/os/_socket#sockaddr_family _sa257144_))
           (std/actor/rpc/connection#rpc-connection-loop
            _rpc-server257132_
            _actors257133_
            _cli257146_
            _address257134_
            _proto-e257135_))))))
  (define std/actor/rpc/connection#rpc-set-nodelay!
    (lambda (_sock257126_ _safamily257127_)
      (if (or (eq? _safamily257127_ std/os/_socket#AF_INET)
              (eq? _safamily257127_ std/os/_socket#AF_INET6))
          (std/os/socket#socket-setsockopt
           (##direct-structure-ref
            _sock257126_
            '1
            std/net/socket/base#!socket::t
            '#f)
           std/os/_socket#IPPROTO_TCP
           std/os/_socket#TCP_NODELAY
           '1)
          '#!void)))
  (define std/actor/rpc/connection#rpc-keep-alive '60)
  (define std/actor/rpc/connection#set-rpc-keep-alive-interval!
    (lambda (_dt257121_)
      (if (or (not _dt257121_) (and (real? _dt257121_) (positive? _dt257121_)))
          (set! std/actor/rpc/connection#rpc-keep-alive _dt257121_)
          (error '"bad keep-alive; expected positive real or #f" _dt257121_))))
  (define std/actor/rpc/connection#rpc-idle-timeout '#f)
  (define std/actor/rpc/connection#set-rpc-idle-timeout!
    (lambda (_dt257116_)
      (if (or (not _dt257116_) (and (real? _dt257116_) (positive? _dt257116_)))
          (set! std/actor/rpc/connection#rpc-idle-timeout _dt257116_)
          (error '"bad idle interval; expected positive real or #f"
                 _dt257116_))))
  (define std/actor/rpc/connection#rpc-call-timeout '60)
  (define std/actor/rpc/connection#set-rpc-call-timeout!
    (lambda (_dt257114_)
      (if (and (real? _dt257114_) (positive? _dt257114_) (finite? _dt257114_))
          (set! std/actor/rpc/connection#rpc-call-timeout _dt257114_)
          (if (not _dt257114_)
              (set! std/actor/rpc/connection#rpc-call-timeout '#f)
              (error '"bad timeout; expected finite positive real or #f"
                     _dt257114_)))))
  (define std/actor/rpc/connection#continuation-table::t
    (make-struct-type
     'std/actor/rpc/connection#continuation-table::t
     '#f
     '6
     'continuation-table
     '((final: . #t))
     ':init!
     '(mx continuations
          stream-continuations
          stream-actors
          timeouts
          continuation-timeouts)))
  (define std/actor/rpc/connection#continuation-table?
    (make-struct-predicate std/actor/rpc/connection#continuation-table::t))
  (define std/actor/rpc/connection#make-continuation-table
    (lambda _$args257111_
      (apply make-struct-instance
             std/actor/rpc/connection#continuation-table::t
             _$args257111_)))
  (define std/actor/rpc/connection#continuation-table-mx
    (make-struct-field-accessor
     std/actor/rpc/connection#continuation-table::t
     '0))
  (define std/actor/rpc/connection#continuation-table-continuations
    (make-struct-field-accessor
     std/actor/rpc/connection#continuation-table::t
     '1))
  (define std/actor/rpc/connection#continuation-table-stream-continuations
    (make-struct-field-accessor
     std/actor/rpc/connection#continuation-table::t
     '2))
  (define std/actor/rpc/connection#continuation-table-stream-actors
    (make-struct-field-accessor
     std/actor/rpc/connection#continuation-table::t
     '3))
  (define std/actor/rpc/connection#continuation-table-timeouts
    (make-struct-field-accessor
     std/actor/rpc/connection#continuation-table::t
     '4))
  (define std/actor/rpc/connection#continuation-table-continuation-timeouts
    (make-struct-field-accessor
     std/actor/rpc/connection#continuation-table::t
     '5))
  (define std/actor/rpc/connection#continuation-table-mx-set!
    (make-struct-field-mutator
     std/actor/rpc/connection#continuation-table::t
     '0))
  (define std/actor/rpc/connection#continuation-table-continuations-set!
    (make-struct-field-mutator
     std/actor/rpc/connection#continuation-table::t
     '1))
  (define std/actor/rpc/connection#continuation-table-stream-continuations-set!
    (make-struct-field-mutator
     std/actor/rpc/connection#continuation-table::t
     '2))
  (define std/actor/rpc/connection#continuation-table-stream-actors-set!
    (make-struct-field-mutator
     std/actor/rpc/connection#continuation-table::t
     '3))
  (define std/actor/rpc/connection#continuation-table-timeouts-set!
    (make-struct-field-mutator
     std/actor/rpc/connection#continuation-table::t
     '4))
  (define std/actor/rpc/connection#continuation-table-continuation-timeouts-set!
    (make-struct-field-mutator
     std/actor/rpc/connection#continuation-table::t
     '5))
  (define std/actor/rpc/connection#&continuation-table-mx
    (make-struct-field-unchecked-accessor
     std/actor/rpc/connection#continuation-table::t
     '0))
  (define std/actor/rpc/connection#&continuation-table-continuations
    (make-struct-field-unchecked-accessor
     std/actor/rpc/connection#continuation-table::t
     '1))
  (define std/actor/rpc/connection#&continuation-table-stream-continuations
    (make-struct-field-unchecked-accessor
     std/actor/rpc/connection#continuation-table::t
     '2))
  (define std/actor/rpc/connection#&continuation-table-stream-actors
    (make-struct-field-unchecked-accessor
     std/actor/rpc/connection#continuation-table::t
     '3))
  (define std/actor/rpc/connection#&continuation-table-timeouts
    (make-struct-field-unchecked-accessor
     std/actor/rpc/connection#continuation-table::t
     '4))
  (define std/actor/rpc/connection#&continuation-table-continuation-timeouts
    (make-struct-field-unchecked-accessor
     std/actor/rpc/connection#continuation-table::t
     '5))
  (define std/actor/rpc/connection#&continuation-table-mx-set!
    (make-struct-field-unchecked-mutator
     std/actor/rpc/connection#continuation-table::t
     '0))
  (define std/actor/rpc/connection#&continuation-table-continuations-set!
    (make-struct-field-unchecked-mutator
     std/actor/rpc/connection#continuation-table::t
     '1))
  (define std/actor/rpc/connection#&continuation-table-stream-continuations-set!
    (make-struct-field-unchecked-mutator
     std/actor/rpc/connection#continuation-table::t
     '2))
  (define std/actor/rpc/connection#&continuation-table-stream-actors-set!
    (make-struct-field-unchecked-mutator
     std/actor/rpc/connection#continuation-table::t
     '3))
  (define std/actor/rpc/connection#&continuation-table-timeouts-set!
    (make-struct-field-unchecked-mutator
     std/actor/rpc/connection#continuation-table::t
     '4))
  (define std/actor/rpc/connection#&continuation-table-continuation-timeouts-set!
    (make-struct-field-unchecked-mutator
     std/actor/rpc/connection#continuation-table::t
     '5))
  (define std/actor/rpc/connection#continuation-table:::init!
    (lambda (_self257109_)
      (if (##fx< '6 (##vector-length _self257109_))
          (begin
            (##vector-set! _self257109_ '1 (make-mutex 'continuation-table))
            (##vector-set! _self257109_ '2 (make-table 'test: eqv?))
            (##vector-set! _self257109_ '3 (make-table 'test: eq?))
            (##vector-set! _self257109_ '4 (make-table 'test: eqv?))
            (##vector-set! _self257109_ '5 (make-table 'test: eq?))
            (##vector-set! _self257109_ '6 (make-table 'test: eqv?)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self257109_))))
  (bind-method!
   std/actor/rpc/connection#continuation-table::t
   ':init!
   std/actor/rpc/connection#continuation-table:::init!
   '#f)
  (define std/actor/rpc/connection#continuation-table-get
    (lambda (_cont-table256976_ _cont256977_)
      (let ((_mx256979_
             (##unchecked-structure-ref
              _cont-table256976_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256979_)
        (let ((_res256984_
               (let ((_ct256982_
                      (##unchecked-structure-ref
                       _cont-table256976_
                       '2
                       std/actor/rpc/connection#continuation-table::t
                       '#f)))
                 (table-ref _ct256982_ _cont256977_ '#f))))
          (mutex-unlock! _mx256979_)
          _res256984_))))
  (define std/actor/rpc/connection#continuation-table-remove!
    (lambda (_cont-table256914_ _cont256915_)
      (let ((_mx256917_
             (##unchecked-structure-ref
              _cont-table256914_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256917_)
        (let ((_res256973_
               (let* ((_ct256920_
                       (##unchecked-structure-ref
                        _cont-table256914_
                        '2
                        std/actor/rpc/connection#continuation-table::t
                        '#f))
                      (_continuation256921256923_
                       (table-ref _ct256920_ _cont256915_ '#f)))
                 (if _continuation256921256923_
                     (let ((_continuation256926_ _continuation256921256923_))
                       (table-set! _ct256920_ _cont256915_)
                       (let* ((_continuation256927256936_ _continuation256926_)
                              (_E256929256940_
                               (lambda ()
                                 (error '"No clause matching"
                                        _continuation256927256936_)))
                              (_K256930256946_
                               (lambda (_stream?256943_ _k256944_)
                                 (if _stream?256943_
                                     (table-set!
                                      (##unchecked-structure-ref
                                       _cont-table256914_
                                       '3
                                       std/actor/rpc/connection#continuation-table::t
                                       '#f)
                                      _k256944_)
                                     '#!void))))
                         (if (##fx= (if (##values? _continuation256927256936_)
                                        (##vector-length
                                         _continuation256927256936_)
                                        '1)
                                    '4)
                             (let* ((_e256931256949_
                                     (##vector-ref
                                      _continuation256927256936_
                                      '0))
                                    (_e256932256952_
                                     (##vector-ref
                                      _continuation256927256936_
                                      '1))
                                    (_e256933256955_
                                     (##vector-ref
                                      _continuation256927256936_
                                      '2))
                                    (_k256958_ _e256933256955_)
                                    (_e256934256960_
                                     (##vector-ref
                                      _continuation256927256936_
                                      '3))
                                    (_stream?256963_ _e256934256960_))
                               (_K256930256946_ _stream?256963_ _k256958_))
                             (_E256929256940_)))
                       (let* ((_tt256965_
                               (##unchecked-structure-ref
                                _cont-table256914_
                                '6
                                std/actor/rpc/connection#continuation-table::t
                                '#f))
                              (_timeo256966256968_
                               (table-ref _tt256965_ _cont256915_ '#f)))
                         (if _timeo256966256968_
                             (let ((_timeo256971_ _timeo256966256968_))
                               (table-set! _tt256965_ _cont256915_)
                               (table-set!
                                (##unchecked-structure-ref
                                 _cont-table256914_
                                 '5
                                 std/actor/rpc/connection#continuation-table::t
                                 '#f)
                                _timeo256971_))
                             '#f))
                       _continuation256926_)
                     '#f))))
          (mutex-unlock! _mx256917_)
          _res256973_))))
  (define std/actor/rpc/connection#continuation-table-get-stream-actor
    (lambda (_cont-table256903_ _cont256904_)
      (let ((_mx256906_
             (##unchecked-structure-ref
              _cont-table256903_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256906_)
        (let ((_res256911_
               (let ((_st256909_
                      (##unchecked-structure-ref
                       _cont-table256903_
                       '4
                       std/actor/rpc/connection#continuation-table::t
                       '#f)))
                 (table-ref _st256909_ _cont256904_ '#f))))
          (mutex-unlock! _mx256906_)
          _res256911_))))
  (define std/actor/rpc/connection#continuation-table-put-stream-actor!
    (lambda (_cont-table256891_ _cont256892_ _val256893_)
      (let ((_mx256895_
             (##unchecked-structure-ref
              _cont-table256891_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256895_)
        (let ((_res256900_
               (let ((_st256898_
                      (##unchecked-structure-ref
                       _cont-table256891_
                       '4
                       std/actor/rpc/connection#continuation-table::t
                       '#f)))
                 (table-set! _st256898_ _cont256892_ _val256893_))))
          (mutex-unlock! _mx256895_)
          _res256900_))))
  (define std/actor/rpc/connection#continuation-table-remove-stream-actor!
    (lambda (_cont-table256880_ _cont256881_)
      (let ((_mx256883_
             (##unchecked-structure-ref
              _cont-table256880_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256883_)
        (let ((_res256888_
               (let ((_st256886_
                      (##unchecked-structure-ref
                       _cont-table256880_
                       '4
                       std/actor/rpc/connection#continuation-table::t
                       '#f)))
                 (table-set! _st256886_ _cont256881_))))
          (mutex-unlock! _mx256883_)
          _res256888_))))
  (define std/actor/rpc/connection#continuation-table-get-stream-cont
    (lambda (_cont-table256869_ _k256870_)
      (let ((_mx256872_
             (##unchecked-structure-ref
              _cont-table256869_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256872_)
        (let ((_res256877_
               (let ((_sct256875_
                      (##unchecked-structure-ref
                       _cont-table256869_
                       '3
                       std/actor/rpc/connection#continuation-table::t
                       '#f)))
                 (table-ref _sct256875_ _k256870_ '#f))))
          (mutex-unlock! _mx256872_)
          _res256877_))))
  (define std/actor/rpc/connection#continuation-table-get-timeout
    (lambda (_cont-table256858_ _timeo256859_)
      (let ((_mx256861_
             (##unchecked-structure-ref
              _cont-table256858_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256861_)
        (let ((_res256866_
               (let ((_tt256864_
                      (##unchecked-structure-ref
                       _cont-table256858_
                       '5
                       std/actor/rpc/connection#continuation-table::t
                       '#f)))
                 (table-ref _tt256864_ _timeo256859_ '#f))))
          (mutex-unlock! _mx256861_)
          _res256866_))))
  (define std/actor/rpc/connection#continuation-table-dump!__%
    (lambda (_cont-table256732_ _port256733_)
      (call-with-parameters
       (lambda ()
         (let ((_mx256736_
                (##unchecked-structure-ref
                 _cont-table256732_
                 '1
                 std/actor/rpc/connection#continuation-table::t
                 '#f)))
           (mutex-lock! _mx256736_)
           (let* ((_cont-table256738256749_ _cont-table256732_)
                  (_E256740256753_
                   (lambda ()
                     (error '"No clause matching" _cont-table256738256749_)))
                  (_K256741256817_
                   (lambda (_ctmos256756_
                            _tmos256757_
                            _sactors256758_
                            _sconts256759_
                            _conts256760_)
                     (displayln
                      '"continuations: "
                      (table-length _conts256760_))
                     (table-for-each
                      (lambda (_wire-id256762_ _continuation256763_)
                        (let* ((_continuation256764256773_
                                _continuation256763_)
                               (_E256766256777_
                                (lambda ()
                                  (error '"No clause matching"
                                         _continuation256764256773_)))
                               (_K256767256785_
                                (lambda (_stream?256780_
                                         _k256781_
                                         _proto256782_
                                         _actor256783_)
                                  (displayln
                                   _wire-id256762_
                                   '" -> "
                                   (cons _actor256783_
                                         (cons _proto256782_
                                               (cons _k256781_
                                                     (cons _stream?256780_
                                                           '()))))))))
                          (if (##fx= (if (##values? _continuation256764256773_)
                                         (##vector-length
                                          _continuation256764256773_)
                                         '1)
                                     '4)
                              (let* ((_e256768256788_
                                      (##vector-ref
                                       _continuation256764256773_
                                       '0))
                                     (_actor256791_ _e256768256788_)
                                     (_e256769256793_
                                      (##vector-ref
                                       _continuation256764256773_
                                       '1))
                                     (_proto256796_ _e256769256793_)
                                     (_e256770256798_
                                      (##vector-ref
                                       _continuation256764256773_
                                       '2))
                                     (_k256801_ _e256770256798_)
                                     (_e256771256803_
                                      (##vector-ref
                                       _continuation256764256773_
                                       '3))
                                     (_stream?256806_ _e256771256803_))
                                (_K256767256785_
                                 _stream?256806_
                                 _k256801_
                                 _proto256796_
                                 _actor256791_))
                              (_E256766256777_))))
                      _conts256760_)
                     (displayln
                      '"stream-continuations: "
                      (table-length _sconts256759_))
                     (table-for-each
                      (lambda (_k256808_ _wire-id256809_)
                        (displayln _k256808_ '" -> " _wire-id256809_))
                      _sconts256759_)
                     (displayln
                      '"stream-actors: "
                      (table-length _sactors256758_))
                     (table-for-each
                      (lambda (_wire-id256811_ _sactor256812_)
                        (displayln _wire-id256811_ '" -> " _sactor256812_))
                      _sactors256758_)
                     (displayln '"timeouts: " (table-length _tmos256757_))
                     (table-for-each
                      (lambda (_tmo256814_ _wire-id256815_)
                        (displayln
                         (time->seconds _tmo256814_)
                         '" -> "
                         _wire-id256815_))
                      _tmos256757_))))
             (if (##structure-direct-instance-of?
                  _cont-table256738256749_
                  'std/actor/rpc/connection#continuation-table::t)
                 (let* ((_e256742256820_
                         (##vector-ref _cont-table256738256749_ '1))
                        (_e256743256823_
                         (##vector-ref _cont-table256738256749_ '2))
                        (_conts256826_ _e256743256823_)
                        (_e256744256828_
                         (##vector-ref _cont-table256738256749_ '3))
                        (_sconts256831_ _e256744256828_)
                        (_e256745256833_
                         (##vector-ref _cont-table256738256749_ '4))
                        (_sactors256836_ _e256745256833_)
                        (_e256746256838_
                         (##vector-ref _cont-table256738256749_ '5))
                        (_tmos256841_ _e256746256838_)
                        (_e256747256843_
                         (##vector-ref _cont-table256738256749_ '6))
                        (_ctmos256846_ _e256747256843_))
                   (_K256741256817_
                    _ctmos256846_
                    _tmos256841_
                    _sactors256836_
                    _sconts256831_
                    _conts256826_))
                 (_E256740256753_)))
           (mutex-unlock! _mx256736_)))
       current-output-port
       _port256733_)))
  (define std/actor/rpc/connection#continuation-table-dump!__0
    (lambda (_cont-table256851_)
      (let ((_port256853_ (current-error-port)))
        (std/actor/rpc/connection#continuation-table-dump!__%
         _cont-table256851_
         _port256853_))))
  (define std/actor/rpc/connection#continuation-table-dump!
    (lambda _g310931_
      (let ((_g310930_ (##length _g310931_)))
        (cond ((##fx= _g310930_ 1)
               (apply std/actor/rpc/connection#continuation-table-dump!__0
                      _g310931_))
              ((##fx= _g310930_ 2)
               (apply std/actor/rpc/connection#continuation-table-dump!__%
                      _g310931_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/rpc/connection#continuation-table-dump!
                _g310931_))))))
  (define std/actor/rpc/connection#rpc-connection-loop
    (lambda (_rpc-server255682_
             _actors255683_
             _sock255684_
             _peer-address255685_
             _proto-e255686_)
      (letrec* ((_input-buffer255688_
                 (std/net/socket/buffer#open-ssocket-input-buffer__0
                  _sock255684_))
                (_output-buffer255689_
                 (std/net/socket/buffer#open-ssocket-output-buffer__0
                  _sock255684_))
                (_g310932_
                 (let ((_g310933_
                        (_proto-e255686_
                         _input-buffer255688_
                         _output-buffer255689_)))
                   (let ((_g310934_
                          (if (##values? _g310933_)
                              (##vector-length _g310933_)
                              1)))
                     (if (not (##fx= _g310934_ 2))
                         (error "Context expects 2 values" _g310934_)))
                   _g310933_))
                (_read-e255690_ (##vector-ref _g310932_ 0))
                (_write-e255691_ (##vector-ref _g310932_ 1))
                (_cont-table255692_
                 (let ((__obj310927
                        (make-object
                         std/actor/rpc/connection#continuation-table::t
                         '6)))
                   (std/actor/rpc/connection#continuation-table:::init!
                    __obj310927)
                   __obj310927))
                (_next-timeout255693_ '#f)
                (_next-continuation-id255694_ '0)
                (_next-heartbeat255695_
                 (seconds->time (+ (##current-time-point) '60)))
                (_writer255696_
                 (gerbil/gambit/threads#spawn/name
                  'rpc-connection-writer
                  std/actor/rpc/connection#rpc-connection-writer
                  _output-buffer255689_
                  _write-e255691_))
                (_reader255697_
                 (gerbil/gambit/threads#spawn/name
                  'rpc-connection-reader
                  std/actor/rpc/connection#rpc-connection-reader
                  (current-thread)
                  _peer-address255685_
                  _input-buffer255688_
                  _actors255683_
                  _cont-table255692_
                  _writer255696_
                  _read-e255690_))
                (_close-connection255698_
                 (lambda ()
                   (std/net/socket/api#ssocket-close _sock255684_)
                   (thread-send _writer255696_ 'exit)
                   (let ((_mx256649_
                          (##unchecked-structure-ref
                           _cont-table255692_
                           '1
                           std/actor/rpc/connection#continuation-table::t
                           '#f)))
                     (mutex-lock! _mx256649_)
                     (table-for-each
                      (lambda (_wire-id256652_ _cont256653_)
                        (let* ((_cont256654256663_ _cont256653_)
                               (_E256656256667_
                                (lambda ()
                                  (error '"No clause matching"
                                         _cont256654256663_)))
                               (_K256657256675_
                                (lambda (_stream?256670_
                                         _k256671_
                                         _proto256672_
                                         _actor256673_)
                                  (std/actor/message#send-message__%
                                   _actor256673_
                                   (##structure
                                    std/actor/proto#!error::t
                                    (make-struct-instance
                                     std/actor/proto#rpc-error::t
                                     'rpc
                                     '"connection error")
                                    _k256671_)
                                   '#f
                                   '#f))))
                          (if (##fx= (if (##values? _cont256654256663_)
                                         (##vector-length _cont256654256663_)
                                         '1)
                                     '4)
                              (let* ((_e256658256678_
                                      (##vector-ref _cont256654256663_ '0))
                                     (_actor256681_ _e256658256678_)
                                     (_e256659256683_
                                      (##vector-ref _cont256654256663_ '1))
                                     (_proto256686_ _e256659256683_)
                                     (_e256660256688_
                                      (##vector-ref _cont256654256663_ '2))
                                     (_k256691_ _e256660256688_)
                                     (_e256661256693_
                                      (##vector-ref _cont256654256663_ '3))
                                     (_stream?256696_ _e256661256693_))
                                (_K256657256675_
                                 _stream?256696_
                                 _k256691_
                                 _proto256686_
                                 _actor256681_))
                              (_E256656256667_))))
                      (##unchecked-structure-ref
                       _cont-table255692_
                       '2
                       std/actor/rpc/connection#continuation-table::t
                       '#f))
                     (table-for-each
                      (lambda (_wire-id256698_ _stream256699_)
                        (let* ((_stream256700256707_ _stream256699_)
                               (_E256702256711_
                                (lambda ()
                                  (error '"No clause matching"
                                         _stream256700256707_)))
                               (_K256703256719_
                                (lambda (_dest256714_ _actor256715_)
                                  (let ((_abort256717_
                                         (##structure
                                          std/actor/message#message::t
                                          (##structure
                                           std/actor/proto#!abort::t
                                           _wire-id256698_)
                                          _dest256714_
                                          _actor256715_
                                          '#f)))
                                    (std/actor/message#send__0
                                     _actor256715_
                                     _abort256717_)))))
                          (if (##pair? _stream256700256707_)
                              (let ((_hd256704256722_
                                     (##car _stream256700256707_))
                                    (_tl256705256724_
                                     (##cdr _stream256700256707_)))
                                (let* ((_actor256727_ _hd256704256722_)
                                       (_dest256729_ _tl256705256724_))
                                  (_K256703256719_
                                   _dest256729_
                                   _actor256727_)))
                              (_E256702256711_))))
                      (##unchecked-structure-ref
                       _cont-table255692_
                       '4
                       std/actor/rpc/connection#continuation-table::t
                       '#f))
                     (mutex-unlock! _mx256649_))
                   (std/actor/rpc/connection#rpc-connection-shutdown
                    _rpc-server255682_)
                   (raise 'shutdown)))
                (_write-message255699_
                 (lambda (_msg256396_)
                   (let* ((_msg256397256406_ _msg256396_)
                          (_E256399256410_
                           (lambda ()
                             (error '"No clause matching" _msg256397256406_)))
                          (_K256400256625_
                           (lambda (_opts256413_
                                    _dest256414_
                                    _src256415_
                                    _content256416_)
                             (if (##structure-direct-instance-of?
                                  _dest256414_
                                  'std/actor/proto#remote::t)
                                 (let* ((_dest256417256426_ _dest256414_)
                                        (_E256419256430_
                                         (lambda ()
                                           (error '"No clause matching"
                                                  _dest256417256426_)))
                                        (_K256420256604_
                                         (lambda (_proto256433_
                                                  _address256434_
                                                  _uuid256435_)
                                           (##direct-structure-set!
                                            _msg256396_
                                            _uuid256435_
                                            '3
                                            std/actor/message#message::t
                                            '#f)
                                           (let* ((_content256436256462_
                                                   _content256416_)
                                                  (_else256444256470_
                                                   (lambda ()
                                                     (_marshal-and-write255701_
                                                      _msg256396_
                                                      _proto256433_
                                                      '#t))))
                                             (let ((_K256458256593_
                                                    (lambda (_k256580_)
                                                      (let ((_wire-id256582_
                                                             (_next-continuation-id!255700_)))
                                                        (let ((_mx256584_
                                                               (##unchecked-structure-ref
                                                                _cont-table255692_
                                                                '1
                                                                std/actor/rpc/connection#continuation-table::t
                                                                '#f)))
                                                          (mutex-lock!
                                                           _mx256584_)
                                                          (table-set!
                                                           (##unchecked-structure-ref
                                                            _cont-table255692_
                                                            '2
                                                            std/actor/rpc/connection#continuation-table::t
                                                            '#f)
                                                           _wire-id256582_
                                                           (values _src256415_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           _proto256433_
                           _k256580_
                           '#f))
                  (let ((_timeo256586256588_
                         (std/actor/rpc/connection#rpc-options-timeout
                          _opts256413_
                          std/actor/rpc/connection#rpc-call-timeout)))
                    (if _timeo256586256588_
                        (let ((_timeo256591_ _timeo256586256588_))
                          (table-set!
                           (##unchecked-structure-ref
                            _cont-table255692_
                            '5
                            std/actor/rpc/connection#continuation-table::t
                            '#f)
                           _timeo256591_
                           _wire-id256582_)
                          (table-set!
                           (##unchecked-structure-ref
                            _cont-table255692_
                            '6
                            std/actor/rpc/connection#continuation-table::t
                            '#f)
                           _wire-id256582_
                           _timeo256591_)
                          (_set-timeout!255706_ _timeo256591_))
                        '#f))
                  (mutex-unlock! _mx256584_))
                (##direct-structure-set!
                 _content256416_
                 _wire-id256582_
                 '2
                 std/actor/proto#!call::t
                 '#f)
                (_marshal-and-write255701_ _msg256396_ _proto256433_ '#t))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (_K256455256566_
                                                    (lambda (_k256553_)
                                                      (let ((_wire-id256555_
                                                             (_next-continuation-id!255700_)))
                                                        (let ((_mx256557_
                                                               (##unchecked-structure-ref
                                                                _cont-table255692_
                                                                '1
                                                                std/actor/rpc/connection#continuation-table::t
                                                                '#f)))
                                                          (mutex-lock!
                                                           _mx256557_)
                                                          (table-set!
                                                           (##unchecked-structure-ref
                                                            _cont-table255692_
                                                            '2
                                                            std/actor/rpc/connection#continuation-table::t
                                                            '#f)
                                                           _wire-id256555_
                                                           (values _src256415_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           _proto256433_
                           _k256553_
                           '#t))
                  (table-set!
                   (##unchecked-structure-ref
                    _cont-table255692_
                    '3
                    std/actor/rpc/connection#continuation-table::t
                    '#f)
                   _k256553_
                   _wire-id256555_)
                  (let ((_timeo256559256561_
                         (std/actor/rpc/connection#rpc-options-timeout
                          _opts256413_
                          '#f)))
                    (if _timeo256559256561_
                        (let ((_timeo256564_ _timeo256559256561_))
                          (table-set!
                           (##unchecked-structure-ref
                            _cont-table255692_
                            '5
                            std/actor/rpc/connection#continuation-table::t
                            '#f)
                           _timeo256564_
                           _wire-id256555_)
                          (table-set!
                           (##unchecked-structure-ref
                            _cont-table255692_
                            '6
                            std/actor/rpc/connection#continuation-table::t
                            '#f)
                           _wire-id256555_
                           _timeo256564_)
                          (_set-timeout!255706_ _timeo256564_))
                        '#f))
                  (mutex-unlock! _mx256557_))
                (##direct-structure-set!
                 _content256416_
                 _wire-id256555_
                 '2
                 std/actor/proto#!stream::t
                 '#f)
                (_marshal-and-write255701_ _msg256396_ _proto256433_ '#t))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (_K256454256537_
                                                    (lambda ()
                                                      (_marshal-and-write255701_
                                                       _msg256396_
                                                       _proto256433_
                                                       '#t)))
                                                   (_K256452256524_
                                                    (lambda (_wire-id256522_)
                                                      (std/actor/rpc/connection#continuation-table-put-stream-actor!
                                                       _cont-table255692_
                                                       _wire-id256522_
                                                       (cons _src256415_
                                                             _dest256414_))
                                                      (_marshal-and-write255701_
                                                       _msg256396_
                                                       _proto256433_
                                                       '#t)))
                                                   (_K256450256510_
                                                    (lambda (_k256506_)
                                                      (let ((_wire-id256508_
                                                             (std/actor/rpc/connection#continuation-table-get-stream-cont
                                                              _cont-table255692_
                                                              _k256506_)))
                                                        (if _wire-id256508_
                                                            (begin
                                                              (##direct-structure-set!
                                                               _content256416_
                                                               _wire-id256508_
                                                               '1
                                                               std/actor/proto#!continue::t
                                                               '#f)
                                                              (_marshal-and-write255701_
                                                               _msg256396_
                                                               _proto256433_
                                                               '#t))
                                                            (std/actor/rpc/connection#warnf
                                                             '"bad continue; unknown stream ~a"
                                                             _k256506_)))))
                                                   (_K256448256494_
                                                    (lambda (_k256490_)
                                                      (let ((_wire-id256492_
                                                             (std/actor/rpc/connection#continuation-table-get-stream-cont
                                                              _cont-table255692_
                                                              _k256490_)))
                                                        (if _wire-id256492_
                                                            (begin
                                                              (##direct-structure-set!
                                                               _content256416_
                                                               _wire-id256492_
                                                               '1
                                                               std/actor/proto#!close::t
                                                               '#f)
                                                              (_marshal-and-write255701_
                                                               _msg256396_
                                                               _proto256433_
                                                               '#t))
                                                            (std/actor/rpc/connection#warnf
                                                             '"bad close; unknown stream ~a"
                                                             _k256490_)))))
                                                   (_K256446256478_
                                                    (lambda (_k256474_)
                                                      (let ((_wire-id256476_
                                                             (std/actor/rpc/connection#continuation-table-get-stream-cont
                                                              _cont-table255692_
                                                              _k256474_)))
                                                        (if _wire-id256476_
                                                            (begin
                                                              (##direct-structure-set!
                                                               _content256416_
                                                               _wire-id256476_
                                                               '1
                                                               std/actor/proto#!abort::t
                                                               '#f)
                                                              (std/actor/rpc/connection#continuation-table-remove!
                                                               _cont-table255692_
                                                               _wire-id256476_)
                                                              (_marshal-and-write255701_
                                                               _msg256396_
                                                               _proto256433_
                                                               '#t))
                                                            (std/actor/rpc/connection#warnf
                                                             '"bad abort; unknown stream ~a"
                                                             _k256474_))))))
                                               (let* ((_try-match256443256486_
                                                       (lambda ()
                                                         (if (##structure-direct-instance-of?
                                                              _content256436256462_
                                                              'std/actor/proto#!abort::t)
                                                             (let* ((_e256447256481_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                             (##vector-ref _content256436256462_ '1))
                            (_k256484_ _e256447256481_))
                       (_K256446256478_ _k256484_))
                     (_else256444256470_))))
              (_try-match256442256502_
               (lambda ()
                 (if (##structure-direct-instance-of?
                      _content256436256462_
                      'std/actor/proto#!close::t)
                     (let* ((_e256449256497_
                             (##vector-ref _content256436256462_ '1))
                            (_k256500_ _e256449256497_))
                       (_K256448256494_ _k256500_))
                     (_try-match256443256486_))))
              (_try-match256441256518_
               (lambda ()
                 (if (##structure-direct-instance-of?
                      _content256436256462_
                      'std/actor/proto#!continue::t)
                     (let* ((_e256451256513_
                             (##vector-ref _content256436256462_ '1))
                            (_k256516_ _e256451256513_))
                       (_K256450256510_ _k256516_))
                     (_try-match256442256502_))))
              (_try-match256440256532_
               (lambda ()
                 (if (##structure-direct-instance-of?
                      _content256436256462_
                      'std/actor/proto#!sync::t)
                     (let* ((_e256453256527_
                             (##vector-ref _content256436256462_ '1))
                            (_wire-id256530_ _e256453256527_))
                       (_K256452256524_ _wire-id256530_))
                     (_try-match256441256518_))))
              (_try-match256439256549_
               (lambda ()
                 (if (or (##structure-direct-instance-of?
                          _content256436256462_
                          'std/actor/proto#!value::t)
                         (##structure-direct-instance-of?
                          _content256436256462_
                          'std/actor/proto#!yield::t)
                         (##structure-direct-instance-of?
                          _content256436256462_
                          'std/actor/proto#!error::t)
                         (##structure-direct-instance-of?
                          _content256436256462_
                          'std/actor/proto#!end::t))
                     (_K256454256537_)
                     (_try-match256440256532_))))
              (_try-match256438256577_
               (lambda ()
                 (if (##structure-direct-instance-of?
                      _content256436256462_
                      'std/actor/proto#!stream::t)
                     (let* ((_e256456256569_
                             (##vector-ref _content256436256462_ '1))
                            (_e256457256572_
                             (##vector-ref _content256436256462_ '2))
                            (_k256575_ _e256457256572_))
                       (_K256455256566_ _k256575_))
                     (_try-match256439256549_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (if (##structure-direct-instance-of?
                                                      _content256436256462_
                                                      'std/actor/proto#!call::t)
                                                     (let* ((_e256459256596_
                                                             (##vector-ref
                                                              _content256436256462_
                                                              '1))
                                                            (_e256460256599_
                                                             (##vector-ref
                                                              _content256436256462_
                                                              '2))
                                                            (_k256602_
                                                             _e256460256599_))
                                                       (_K256458256593_
                                                        _k256602_))
                                                     (_try-match256438256577_))))))))
                                   (if (##structure-direct-instance-of?
                                        _dest256417256426_
                                        'std/actor/proto#remote::t)
                                       (let* ((_e256421256607_
                                               (##vector-ref
                                                _dest256417256426_
                                                '1))
                                              (_e256422256610_
                                               (##vector-ref
                                                _dest256417256426_
                                                '2))
                                              (_uuid256613_ _e256422256610_)
                                              (_e256423256615_
                                               (##vector-ref
                                                _dest256417256426_
                                                '3))
                                              (_address256618_ _e256423256615_)
                                              (_e256424256620_
                                               (##vector-ref
                                                _dest256417256426_
                                                '4))
                                              (_proto256623_ _e256424256620_))
                                         (_K256420256604_
                                          _proto256623_
                                          _address256618_
                                          _uuid256613_))
                                       (_E256419256430_)))
                                 (std/actor/rpc/connection#warnf
                                  '"bad handle; no protocol ~a ~a"
                                  _dest256414_
                                  _msg256396_)))))
                     (if (##structure-direct-instance-of?
                          _msg256397256406_
                          'std/actor/message#message::t)
                         (let* ((_e256401256628_
                                 (##vector-ref _msg256397256406_ '1))
                                (_content256631_ _e256401256628_)
                                (_e256402256633_
                                 (##vector-ref _msg256397256406_ '2))
                                (_src256636_ _e256402256633_)
                                (_e256403256638_
                                 (##vector-ref _msg256397256406_ '3))
                                (_dest256641_ _e256403256638_)
                                (_e256404256643_
                                 (##vector-ref _msg256397256406_ '4))
                                (_opts256646_ _e256404256643_))
                           (_K256400256625_
                            _opts256646_
                            _dest256641_
                            _src256636_
                            _content256631_))
                         (_E256399256410_)))))
                (_next-continuation-id!255700_
                 (lambda ()
                   (let ((_next256394_ _next-continuation-id255694_))
                     (set! _next-continuation-id255694_ (+ _next256394_ '1))
                     _next256394_)))
                (_marshal-and-write255701_
                 (lambda (_msg256037_
                          _proto256038_
                          _dispatch-marshal-error?256039_)
                   (let ((_e256124_
                          (with-exception-catcher
                           (lambda (_g256113256115_)
                             (if ((lambda (_$obj256118_)
                                    (exception? _$obj256118_))
                                  _g256113256115_)
                                 (let ((_e256121_ _g256113256115_)) _e256121_)
                                 (raise _g256113256115_)))
                           (lambda ()
                             (std/actor/rpc/proto/message#rpc-proto-marshal-message
                              _msg256037_
                              _proto256038_)))))
                     (if (u8vector? _e256124_)
                         (if (fx<= (u8vector-length _e256124_)
                                   std/actor/rpc/proto/message#rpc-proto-message-max-length)
                             (thread-send _writer255696_ _e256124_)
                             (begin
                               (std/actor/rpc/connection#warnf
                                '"message too large; not sending %d bytes"
                                (u8vector-length _e256124_))
                               (let ((_content256126_
                                      (##direct-structure-ref
                                       _msg256037_
                                       '1
                                       std/actor/message#message::t
                                       '#f))
                                     (_dest256128_
                                      (##direct-structure-ref
                                       _msg256037_
                                       '3
                                       std/actor/message#message::t
                                       '#f)))
                                 (let* ((_content256130256146_ _content256126_)
                                        (_else256133256154_
                                         (lambda () '#!void)))
                                   (let ((_K256140256192_
                                          (lambda (_wire-id256189_ _e256190_)
                                            (_dispatch-error255702_
                                             _wire-id256189_
                                             '"message too large")))
                                         (_K256135256163_
                                          (lambda (_wire-id256158_ _e256160_)
                                            (if _dispatch-marshal-error?256039_
                                                (_dispatch-remote-error255703_
                                                 (##structure
                                                  std/actor/proto#!error::t
                                                  '"message too large"
                                                  _wire-id256158_)
                                                 _dest256128_)
                                                '#!void))))
                                     (let* ((___match310779310780_
                                             (lambda ()
                                               (if (##structure-direct-instance-of?
                                                    _content256130256146_
                                                    'std/actor/proto#!yield::t)
                                                   (let* ((_e256136256176_
                                                           (##vector-ref
                                                            _content256130256146_
                                                            '1))
                                                          (_e256137256181_
                                                           (##vector-ref
                                                            _content256130256146_
                                                            '2)))
                                                     (let ((_e256179_
                                                            _e256136256176_)
                                                           (_wire-id256184_
                                                            _e256137256181_))
                                                       (_K256135256163_
                                                        _wire-id256184_
                                                        _e256179_)))
                                                   '#!void)))
                                            (_try-match256132256186_
                                             (lambda ()
                                               (if (##structure-direct-instance-of?
                                                    _content256130256146_
                                                    'std/actor/proto#!error::t)
                                                   (let* ((_e256138256166_
                                                           (##vector-ref
                                                            _content256130256146_
                                                            '1))
                                                          (_e256139256171_
                                                           (##vector-ref
                                                            _content256130256146_
                                                            '2)))
                                                     (let ((_e256169_
                                                            _e256138256166_)
                                                           (_wire-id256174_
                                                            _e256139256171_))
                                                       (_K256135256163_
                                                        _wire-id256174_
                                                        _e256169_)))
                                                   (___match310779310780_))))
                                            (___match310765310766_
                                             (lambda ()
                                               (if (##structure-direct-instance-of?
                                                    _content256130256146_
                                                    'std/actor/proto#!stream::t)
                                                   (let* ((_e256141256205_
                                                           (##vector-ref
                                                            _content256130256146_
                                                            '1))
                                                          (_e256142256210_
                                                           (##vector-ref
                                                            _content256130256146_
                                                            '2)))
                                                     (let ((_e256208_
                                                            _e256141256205_)
                                                           (_wire-id256213_
                                                            _e256142256210_))
                                                       (_K256140256192_
                                                        _wire-id256213_
                                                        _e256208_)))
                                                   (_try-match256132256186_)))))
                                       (if (##structure-direct-instance-of?
                                            _content256130256146_
                                            'std/actor/proto#!call::t)
                                           (let* ((_e256143256195_
                                                   (##vector-ref
                                                    _content256130256146_
                                                    '1))
                                                  (_e256144256200_
                                                   (##vector-ref
                                                    _content256130256146_
                                                    '2)))
                                             (let ((_e256198_ _e256143256195_)
                                                   (_wire-id256203_
                                                    _e256144256200_))
                                               (_K256140256192_
                                                _wire-id256203_
                                                _e256198_)))
                                           (___match310765310766_))))))))
                         (if (##structure-instance-of?
                              _e256124_
                              'std/net/bio/buffer#chunked-output-buffer::t)
                             (if (fx<= (std/net/bio/buffer#chunked-output-length
                                        _e256124_)
                                       std/actor/rpc/proto/message#rpc-proto-message-max-length)
                                 (thread-send _writer255696_ _e256124_)
                                 (begin
                                   (std/actor/rpc/connection#warnf
                                    '"message too large; not sending %d bytes"
                                    (std/net/bio/buffer#chunked-output-length
                                     _e256124_))
                                   (let ((_content256215_
                                          (##direct-structure-ref
                                           _msg256037_
                                           '1
                                           std/actor/message#message::t
                                           '#f))
                                         (_dest256217_
                                          (##direct-structure-ref
                                           _msg256037_
                                           '3
                                           std/actor/message#message::t
                                           '#f)))
                                     (let* ((_content256219256235_
                                             _content256215_)
                                            (_else256222256243_
                                             (lambda () '#!void)))
                                       (let ((_K256229256281_
                                              (lambda (_wire-id256278_
                                                       _e256279_)
                                                (_dispatch-error255702_
                                                 _wire-id256278_
                                                 '"message too large")))
                                             (_K256224256252_
                                              (lambda (_wire-id256247_
                                                       _e256249_)
                                                (if _dispatch-marshal-error?256039_
                                                    (_dispatch-remote-error255703_
                                                     (##structure
                                                      std/actor/proto#!error::t
                                                      '"message too large"
                                                      _wire-id256247_)
                                                     _dest256217_)
                                                    '#!void))))
                                         (let* ((___match310808310809_
                                                 (lambda ()
                                                   (if (##structure-direct-instance-of?
                                                        _content256219256235_
                                                        'std/actor/proto#!yield::t)
                                                       (let* ((_e256225256265_
                                                               (##vector-ref
                                                                _content256219256235_
                                                                '1))
                                                              (_e256226256270_
                                                               (##vector-ref
                                                                _content256219256235_
                                                                '2)))
                                                         (let ((_e256268_
                                                                _e256225256265_)
                                                               (_wire-id256273_
                                                                _e256226256270_))
                                                           (_K256224256252_
                                                            _wire-id256273_
                                                            _e256268_)))
                                                       '#!void)))
                                                (_try-match256221256275_
                                                 (lambda ()
                                                   (if (##structure-direct-instance-of?
                                                        _content256219256235_
                                                        'std/actor/proto#!error::t)
                                                       (let* ((_e256227256255_
                                                               (##vector-ref
                                                                _content256219256235_
                                                                '1))
                                                              (_e256228256260_
                                                               (##vector-ref
                                                                _content256219256235_
                                                                '2)))
                                                         (let ((_e256258_
                                                                _e256227256255_)
                                                               (_wire-id256263_
                                                                _e256228256260_))
                                                           (_K256224256252_
                                                            _wire-id256263_
                                                            _e256258_)))
                                                       (___match310808310809_))))
                                                (___match310794310795_
                                                 (lambda ()
                                                   (if (##structure-direct-instance-of?
                                                        _content256219256235_
                                                        'std/actor/proto#!stream::t)
                                                       (let* ((_e256230256294_
                                                               (##vector-ref
                                                                _content256219256235_
                                                                '1))
                                                              (_e256231256299_
                                                               (##vector-ref
                                                                _content256219256235_
                                                                '2)))
                                                         (let ((_e256297_
                                                                _e256230256294_)
                                                               (_wire-id256302_
                                                                _e256231256299_))
                                                           (_K256229256281_
                                                            _wire-id256302_
                                                            _e256297_)))
                                                       (_try-match256221256275_)))))
                                           (if (##structure-direct-instance-of?
                                                _content256219256235_
                                                'std/actor/proto#!call::t)
                                               (let* ((_e256232256284_
                                                       (##vector-ref
                                                        _content256219256235_
                                                        '1))
                                                      (_e256233256289_
                                                       (##vector-ref
                                                        _content256219256235_
                                                        '2)))
                                                 (let ((_e256287_
                                                        _e256232256284_)
                                                       (_wire-id256292_
                                                        _e256233256289_))
                                                   (_K256229256281_
                                                    _wire-id256292_
                                                    _e256287_)))
                                               (___match310794310795_))))))))
                             (if _dispatch-marshal-error?256039_
                                 (begin
                                   (std/actor/rpc/connection#errorf
                                    '"marshal error: ~a"
                                    _e256124_)
                                   (let ((_content256304_
                                          (##direct-structure-ref
                                           _msg256037_
                                           '1
                                           std/actor/message#message::t
                                           '#f))
                                         (_dest256306_
                                          (##direct-structure-ref
                                           _msg256037_
                                           '3
                                           std/actor/message#message::t
                                           '#f)))
                                     (let* ((_content256308256324_
                                             _content256304_)
                                            (_else256311256332_
                                             (lambda () '#!void)))
                                       (let ((_K256318256370_
                                              (lambda (_wire-id256367_
                                                       _e256368_)
                                                (_dispatch-error255702_
                                                 _wire-id256367_
                                                 '"marshal error")))
                                             (_K256313256341_
                                              (lambda (_wire-id256336_
                                                       _e256338_)
                                                (if _dispatch-marshal-error?256039_
                                                    (_dispatch-remote-error255703_
                                                     (##structure
                                                      std/actor/proto#!error::t
                                                      '"marshal error"
                                                      _wire-id256336_)
                                                     _dest256306_)
                                                    '#!void))))
                                         (let* ((___match310837310838_
                                                 (lambda ()
                                                   (if (##structure-direct-instance-of?
                                                        _content256308256324_
                                                        'std/actor/proto#!yield::t)
                                                       (let* ((_e256314256354_
                                                               (##vector-ref
                                                                _content256308256324_
                                                                '1))
                                                              (_e256315256359_
                                                               (##vector-ref
                                                                _content256308256324_
                                                                '2)))
                                                         (let ((_e256357_
                                                                _e256314256354_)
                                                               (_wire-id256362_
                                                                _e256315256359_))
                                                           (_K256313256341_
                                                            _wire-id256362_
                                                            _e256357_)))
                                                       '#!void)))
                                                (_try-match256310256364_
                                                 (lambda ()
                                                   (if (##structure-direct-instance-of?
                                                        _content256308256324_
                                                        'std/actor/proto#!error::t)
                                                       (let* ((_e256316256344_
                                                               (##vector-ref
                                                                _content256308256324_
                                                                '1))
                                                              (_e256317256349_
                                                               (##vector-ref
                                                                _content256308256324_
                                                                '2)))
                                                         (let ((_e256347_
                                                                _e256316256344_)
                                                               (_wire-id256352_
                                                                _e256317256349_))
                                                           (_K256313256341_
                                                            _wire-id256352_
                                                            _e256347_)))
                                                       (___match310837310838_))))
                                                (___match310823310824_
                                                 (lambda ()
                                                   (if (##structure-direct-instance-of?
                                                        _content256308256324_
                                                        'std/actor/proto#!stream::t)
                                                       (let* ((_e256319256383_
                                                               (##vector-ref
                                                                _content256308256324_
                                                                '1))
                                                              (_e256320256388_
                                                               (##vector-ref
                                                                _content256308256324_
                                                                '2)))
                                                         (let ((_e256386_
                                                                _e256319256383_)
                                                               (_wire-id256391_
                                                                _e256320256388_))
                                                           (_K256318256370_
                                                            _wire-id256391_
                                                            _e256386_)))
                                                       (_try-match256310256364_)))))
                                           (if (##structure-direct-instance-of?
                                                _content256308256324_
                                                'std/actor/proto#!call::t)
                                               (let* ((_e256321256373_
                                                       (##vector-ref
                                                        _content256308256324_
                                                        '1))
                                                      (_e256322256378_
                                                       (##vector-ref
                                                        _content256308256324_
                                                        '2)))
                                                 (let ((_e256376_
                                                        _e256321256373_)
                                                       (_wire-id256381_
                                                        _e256322256378_))
                                                   (_K256318256370_
                                                    _wire-id256381_
                                                    _e256376_)))
                                               (___match310823310824_)))))))
                                 (std/actor/rpc/connection#errorf
                                  '"marshal error: ~a"
                                  _e256124_)))))))
                (_dispatch-error255702_
                 (lambda (_wire-id255986_ _what255987_)
                   (let* ((_g255988255998_
                           (std/actor/rpc/connection#continuation-table-remove!
                            _cont-table255692_
                            _wire-id255986_))
                          (_else255990256006_ (lambda () '#!void))
                          (_K255992256014_
                           (lambda (_stream?256009_
                                    _k256010_
                                    _proto256011_
                                    _actor256012_)
                             (std/actor/message#send-message__%
                              _actor256012_
                              (##structure
                               std/actor/proto#!error::t
                               (make-struct-instance
                                std/actor/proto#rpc-error::t
                                'rpc
                                _what255987_)
                               _k256010_)
                              '#f
                              '#f))))
                     (if (##fx= (if (##values? _g255988255998_)
                                    (##vector-length _g255988255998_)
                                    '1)
                                '4)
                         (let* ((_e255993256017_
                                 (##vector-ref _g255988255998_ '0))
                                (_actor256020_ _e255993256017_)
                                (_e255994256022_
                                 (##vector-ref _g255988255998_ '1))
                                (_proto256025_ _e255994256022_)
                                (_e255995256027_
                                 (##vector-ref _g255988255998_ '2))
                                (_k256030_ _e255995256027_)
                                (_e255996256032_
                                 (##vector-ref _g255988255998_ '3))
                                (_stream?256035_ _e255996256032_))
                           (_K255992256014_
                            _stream?256035_
                            _k256030_
                            _proto256025_
                            _actor256020_))
                         '#!void))))
                (_dispatch-remote-error255703_
                 (lambda (_what255983_ _dest255984_)
                   (_marshal-and-write255701_
                    (##structure
                     std/actor/message#message::t
                     _what255983_
                     '#!void
                     _dest255984_
                     '#f)
                    '#f
                    '#f)))
                (_dispatch-timeout255704_
                 (lambda (_timeo255976_)
                   (set! _next-timeout255693_ '#f)
                   (let ((_$e255978_
                          (std/actor/rpc/connection#continuation-table-get-timeout
                           _cont-table255692_
                           _timeo255976_)))
                     (if _$e255978_
                         ((lambda (_wire-id255981_)
                            (_dispatch-error255702_
                             _wire-id255981_
                             '"timeout"))
                          _$e255978_)
                         '#!void))))
                (_timeout<255705_
                 (lambda (_a255973_ _b255974_)
                   (< (time->seconds _a255973_) (time->seconds _b255974_))))
                (_set-timeout!255706_
                 (lambda (_timeo255968_)
                   (if (or (not _next-timeout255693_)
                           (_timeout<255705_
                            _timeo255968_
                            _next-timeout255693_))
                       (set! _next-timeout255693_ _timeo255968_)
                       '#!void)))
                (_timeout-event255707_
                 (lambda ()
                   (if _next-timeout255693_
                       '#!void
                       (let ((_mx255961_
                              (##unchecked-structure-ref
                               _cont-table255692_
                               '1
                               std/actor/rpc/connection#continuation-table::t
                               '#f)))
                         (mutex-lock! _mx255961_)
                         (let ((_timeouts255964_
                                (##unchecked-structure-ref
                                 _cont-table255692_
                                 '5
                                 std/actor/rpc/connection#continuation-table::t
                                 '#f)))
                           (if (fxzero? (table-length _timeouts255964_))
                               '#!void
                               (table-for-each
                                (lambda (_timeo255966_ _g310935_)
                                  (_set-timeout!255706_ _timeo255966_))
                                _timeouts255964_)))
                         (mutex-unlock! _mx255961_)))
                   _next-timeout255693_))
                (_heartbeat!255708_
                 (lambda ()
                   (let ((_dead-continuations255908_
                          (let ((_mx255864_
                                 (##unchecked-structure-ref
                                  _cont-table255692_
                                  '1
                                  std/actor/rpc/connection#continuation-table::t
                                  '#f)))
                            (mutex-lock! _mx255864_)
                            (let ((_res255905_
                                   (hash-fold
                                    (lambda (_wire-id255867_
                                             _continuation255868_
                                             _r255869_)
                                      (let* ((_continuation255870255879_
                                              _continuation255868_)
                                             (_E255872255883_
                                              (lambda ()
                                                (error '"No clause matching"
                                                       _continuation255870255879_)))
                                             (_K255873255888_
                                              (lambda (_actor255886_)
                                                (if (and (thread? _actor255886_)
                                                         (std/misc/threads#thread-dead?
                                                          _actor255886_))
                                                    (cons _wire-id255867_
                                                          _r255869_)
                                                    _r255869_))))
                                        (if (##fx= (if (##values?
                                                        _continuation255870255879_)
                                                       (##vector-length
                                                        _continuation255870255879_)
                                                       '1)
                                                   '4)
                                            (let* ((_e255874255891_
                                                    (##vector-ref
                                                     _continuation255870255879_
                                                     '0))
                                                   (_actor255894_
                                                    _e255874255891_)
                                                   (_e255875255896_
                                                    (##vector-ref
                                                     _continuation255870255879_
                                                     '1))
                                                   (_e255876255899_
                                                    (##vector-ref
                                                     _continuation255870255879_
                                                     '2))
                                                   (_e255877255902_
                                                    (##vector-ref
                                                     _continuation255870255879_
                                                     '3)))
                                              (_K255873255888_ _actor255894_))
                                            (_E255872255883_))))
                                    '()
                                    (##unchecked-structure-ref
                                     _cont-table255692_
                                     '2
                                     std/actor/rpc/connection#continuation-table::t
                                     '#f))))
                              (mutex-unlock! _mx255864_)
                              _res255905_))))
                     (for-each
                      (lambda (_wire-id255910_)
                        (let* ((_g255911255921_
                                (std/actor/rpc/connection#continuation-table-remove!
                                 _cont-table255692_
                                 _wire-id255910_))
                               (_else255913255929_ (lambda () '#!void))
                               (_K255915255937_
                                (lambda (_stream?255932_
                                         _k255933_
                                         _proto255934_
                                         _actor255935_)
                                  (std/actor/rpc/connection#debugf
                                   '"removing continuation ~a for dead actor ~a"
                                   _wire-id255910_
                                   _actor255935_)
                                  (if _stream?255932_
                                      (_dispatch-remote-error255703_
                                       (##structure
                                        std/actor/proto#!abort::t
                                        _wire-id255910_)
                                       std/actor/rpc/base#null-uuid)
                                      '#!void))))
                          (if (##fx= (if (##values? _g255911255921_)
                                         (##vector-length _g255911255921_)
                                         '1)
                                     '4)
                              (let* ((_e255916255940_
                                      (##vector-ref _g255911255921_ '0))
                                     (_actor255943_ _e255916255940_)
                                     (_e255917255945_
                                      (##vector-ref _g255911255921_ '1))
                                     (_proto255948_ _e255917255945_)
                                     (_e255918255950_
                                      (##vector-ref _g255911255921_ '2))
                                     (_k255953_ _e255918255950_)
                                     (_e255919255955_
                                      (##vector-ref _g255911255921_ '3))
                                     (_stream?255958_ _e255919255955_))
                                (_K255915255937_
                                 _stream?255958_
                                 _k255953_
                                 _proto255948_
                                 _actor255943_))
                              '#!void)))
                      _dead-continuations255908_))
                   (set! _next-heartbeat255695_
                         (seconds->time (+ (##current-time-point) '60)))))
                (_dump!255709_
                 (lambda (_port255860_)
                   (call-with-parameters
                    (lambda ()
                      (displayln '"=== rpc-connection ===")
                      (displayln '"peer-address: " _peer-address255685_)
                      (displayln
                       '"next-continuation-id: "
                       _next-continuation-id255694_)
                      (displayln
                       '"next-timeout: "
                       (if _next-timeout255693_
                           (time->seconds _next-timeout255693_)
                           '#f)))
                    current-output-port
                    _port255860_)
                   (std/actor/rpc/connection#continuation-table-dump!__%
                    _cont-table255692_
                    _port255860_)))
                (_loop255710_
                 (lambda ()
                   (let ((_g310936_
                          (std/actor/message#receive-timeout
                           (_timeout-event255707_)
                           _dispatch-timeout255704_
                           _next-heartbeat255695_
                           (lambda (_$e255724_) (_heartbeat!255708_)))))
                     (begin
                       (let ((_g310937_
                              (if (##values? _g310936_)
                                  (##vector-length _g310936_)
                                  1)))
                         (if (not (##fx= _g310937_ 2))
                             (error "Context expects 2 values" _g310937_)))
                       (let ((_timeo255727_ (##vector-ref _g310936_ 0))
                             (_K255729_ (##vector-ref _g310936_ 1)))
                         (let _loop255722255732_ ()
                           (let ((_next255736_
                                  (thread-mailbox-next
                                   _timeo255727_
                                   std/actor/message#mailbox-timeout)))
                             (if (eq? _next255736_
                                      std/actor/message#mailbox-timeout)
                                 (begin
                                   (thread-mailbox-rewind)
                                   (_K255729_ _timeo255727_))
                                 ((lambda (_msg255739_)
                                    (let* ((_msg255741255763_ _msg255739_)
                                           (_else255749255771_
                                            (lambda () (_loop255722255732_))))
                                      (let ((_K255761255855_
                                             (lambda (_msg255853_)
                                               (thread-mailbox-extract-and-rewind)
                                               (_write-message255699_
                                                _msg255853_)))
                                            (_K255760255847_
                                             (lambda ()
                                               (thread-mailbox-extract-and-rewind)
                                               (_close-connection255698_)))
                                            (_K255759255839_
                                             (lambda ()
                                               (thread-mailbox-extract-and-rewind)
                                               (_close-connection255698_)))
                                            (_K255758255829_
                                             (lambda (_thread255815_)
                                               (thread-mailbox-extract-and-rewind)
                                               (with-exception-catcher
                                                (lambda (_g255816255818_)
                                                  (if ((lambda (_$obj255821_)
                                                         (uncaught-exception?
                                                          _$obj255821_))
                                                       _g255816255818_)
                                                      (let ((_e255824_
                                                             _g255816255818_))
                                                        (std/actor/rpc/connection#errorf
                                                         '"connection error: ~a"
                                                         (uncaught-exception-reason
                                                          _e255824_)))
                                                      (if '#t
                                                          (let ((_e255826_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _g255816255818_))
                    (std/actor/rpc/connection#errorf
                     '"connection error: ~a"
                     _e255826_))
                  (raise _g255816255818_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                (lambda ()
                                                  (thread-join! _thread255815_)
                                                  (std/actor/rpc/connection#warnf
                                                   '"connection error: i/o thread ~a exited unexpectedly"
                                                   (thread-name
                                                    _thread255815_))))
                                               (_close-connection255698_)))
                                            (_K255757255808_
                                             (lambda ()
                                               (thread-mailbox-extract-and-rewind)
                                               (_dump!255709_
                                                (current-error-port))))
                                            (_K255752255788_
                                             (lambda (_port255786_)
                                               (thread-mailbox-extract-and-rewind)
                                               (_dump!255709_ _port255786_)))
                                            (_K255751255777_
                                             (lambda (_bogus255775_)
                                               (thread-mailbox-extract-and-rewind)
                                               (std/actor/rpc/connection#warnf
                                                '"unexpected message ~a"
                                                _bogus255775_))))
                                        (let* ((_try-match255747255803_
                                                (lambda ()
                                                  (if (##pair? _msg255741255763_)
                                                      (let ((_tl255754255793_
                                                             (##cdr _msg255741255763_))
                                                            (_hd255753255791_
                                                             (##car _msg255741255763_)))
                                                        (if (##eq? _hd255753255791_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           'dump)
                    (if (##pair? _tl255754255793_)
                        (let ((_tl255756255798_ (##cdr _tl255754255793_))
                              (_hd255755255796_ (##car _tl255754255793_)))
                          (if (##null? _tl255756255798_)
                              (let ((_port255801_ _hd255755255796_))
                                (_K255752255788_ _port255801_))
                              (let ((_bogus255780_ _msg255741255763_))
                                (_K255751255777_ _bogus255780_))))
                        (let ((_bogus255780_ _msg255741255763_))
                          (_K255751255777_ _bogus255780_)))
                    (let ((_bogus255780_ _msg255741255763_))
                      (_K255751255777_ _bogus255780_))))
              (let ((_bogus255780_ _msg255741255763_))
                (_K255751255777_ _bogus255780_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                               (_try-match255746255811_
                                                (lambda ()
                                                  (if (##eq? _msg255741255763_
                                                             'dump)
                                                      (_K255757255808_)
                                                      (_try-match255747255803_))))
                                               (_try-match255745255834_
                                                (lambda ()
                                                  (if (thread? _msg255741255763_)
                                                      (let ((_thread255832_
                                                             _msg255741255763_))
                                                        (_K255758255829_
                                                         _thread255832_))
                                                      (_try-match255746255811_))))
                                               (_try-match255744255842_
                                                (lambda ()
                                                  (if (##eq? _msg255741255763_
                                                             'shutdown)
                                                      (_K255759255839_)
                                                      (_try-match255745255834_))))
                                               (_try-match255743255850_
                                                (lambda ()
                                                  (if (eof-object?
                                                       _msg255741255763_)
                                                      (_K255760255847_)
                                                      (_try-match255744255842_)))))
                                          (if (##structure-direct-instance-of?
                                               _msg255741255763_
                                               'std/actor/message#message::t)
                                              (let ((_msg255858_
                                                     _msg255741255763_))
                                                (_K255761255855_ _msg255858_))
                                              (_try-match255743255850_))))))
                                  _next255736_)))))))
                   (_loop255710_)))
                (_run255711_
                 (lambda ()
                   (call-with-parameters
                    (lambda () (_loop255710_))
                    std/actor/xdr#current-xdr-type-registry
                    std/actor/xdr#+xdr-default-type-registry+))))
        (begin
          (std/actor/rpc/base#rpc-monitor__0 _reader255697_)
          (std/actor/rpc/base#rpc-monitor__0 _writer255696_)
          (with-exception-catcher
           (lambda (_g255712255714_)
             (if '#t
                 (let ((_e255717_ _g255712255714_))
                   (if (eq? 'shutdown _e255717_)
                       '#!void
                       (begin
                         (std/actor/rpc/connection#errorf
                          '"unhandled exception: ~a"
                          _e255717_)
                         (with-exception-catcher
                          void
                          _close-connection255698_))))
                 (raise _g255712255714_)))
           (lambda () (_run255711_)))))))
  (define std/actor/rpc/connection#rpc-connection-writer
    (lambda (_sockbuf255591_ _write-e255592_)
      (letrec ((_loop255594_
                (lambda ()
                  (let ((_g310938_
                         (std/actor/message#receive-timeout
                          std/actor/rpc/connection#rpc-keep-alive
                          (lambda (_$e255605_)
                            (_write-e255592_ _sockbuf255591_ '#!void)
                            (_loop255594_)))))
                    (begin
                      (let ((_g310939_
                             (if (##values? _g310938_)
                                 (##vector-length _g310938_)
                                 1)))
                        (if (not (##fx= _g310939_ 2))
                            (error "Context expects 2 values" _g310939_)))
                      (let ((_timeo255608_ (##vector-ref _g310938_ 0))
                            (_K255610_ (##vector-ref _g310938_ 1)))
                        (let _loop255603255613_ ()
                          (let ((_next255617_
                                 (thread-mailbox-next
                                  _timeo255608_
                                  std/actor/message#mailbox-timeout)))
                            (if (eq? _next255617_
                                     std/actor/message#mailbox-timeout)
                                (begin
                                  (thread-mailbox-rewind)
                                  (_K255610_ _timeo255608_))
                                ((lambda (_msg255620_)
                                   (let* ((_msg255622255634_ _msg255620_)
                                          (_else255627255642_
                                           (lambda () (_loop255603255613_))))
                                     (let ((_K255632255677_
                                            (lambda (_buf255675_)
                                              (thread-mailbox-extract-and-rewind)
                                              (_write-e255592_
                                               _sockbuf255591_
                                               _buf255675_)
                                              (_loop255594_)))
                                           (_K255631255667_
                                            (lambda (_data255665_)
                                              (thread-mailbox-extract-and-rewind)
                                              (_write-e255592_
                                               _sockbuf255591_
                                               _data255665_)
                                              (_loop255594_)))
                                           (_K255630255658_
                                            (lambda ()
                                              (thread-mailbox-extract-and-rewind)
                                              '#!void))
                                           (_K255629255648_
                                            (lambda (_bogus255646_)
                                              (thread-mailbox-extract-and-rewind)
                                              (std/actor/rpc/connection#warnf
                                               '"unexpected message ~a"
                                               _bogus255646_)
                                              (_loop255594_))))
                                       (let* ((_try-match255625255661_
                                               (lambda ()
                                                 (if (##eq? _msg255622255634_
                                                            'exit)
                                                     (_K255630255658_)
                                                     (let ((_bogus255651_
                                                            _msg255622255634_))
                                                       (_K255629255648_
                                                        _bogus255651_)))))
                                              (_try-match255624255672_
                                               (lambda ()
                                                 (if (u8vector?
                                                      _msg255622255634_)
                                                     (let ((_data255670_
                                                            _msg255622255634_))
                                                       (_K255631255667_
                                                        _data255670_))
                                                     (_try-match255625255661_)))))
                                         (if (##structure-instance-of?
                                              _msg255622255634_
                                              'std/net/bio/output#output-buffer::t)
                                             (let ((_buf255680_
                                                    _msg255622255634_))
                                               (_K255632255677_ _buf255680_))
                                             (_try-match255624255672_))))))
                                 _next255617_))))))))))
        (with-exception-catcher
         (lambda (_g255595255597_)
           (if '#t
               (let ((_e255600_ _g255595255597_))
                 (std/actor/rpc/connection#errorf
                  '"unhandled exception: ~a"
                  _e255600_))
               (raise _g255595255597_)))
         (lambda () (_loop255594_))))))
  (define std/actor/rpc/connection#rpc-connection-reader
    (lambda (_conn255170_
             _connaddr255171_
             _sockbuf255172_
             _actor-table255173_
             _cont-table255174_
             _writer255175_
             _read-e255176_)
      (letrec ((_loop255178_
                (lambda (_u8buf255431_)
                  (let* ((_g255432255445_
                          (_read-e255176_ _sockbuf255172_ _u8buf255431_))
                         (_E255437255449_
                          (lambda ()
                            (error '"No clause matching" _g255432255445_))))
                    (let ((_K255441255578_
                           (lambda (_count255479_ _u8buf255480_)
                             (let* ((_buffer255482_
                                     (std/net/bio/buffer#open-input-buffer__%
                                      _u8buf255480_
                                      '0
                                      _count255479_))
                                    (_msg255484_
                                     (_read-envelope255185_ _buffer255482_)))
                               (let* ((_msg255486255493_ _msg255484_)
                                      (_else255488255501_ (lambda () '#!void))
                                      (_K255490255570_
                                       (lambda (_content255504_)
                                         (let* ((_content255505255515_
                                                 _content255504_)
                                                (_else255509255523_
                                                 (lambda ()
                                                   (_dispatch-call255179_
                                                    _msg255484_
                                                    _buffer255482_))))
                                           (let ((_K255513255561_
                                                  (lambda ()
                                                    (_dispatch-call255179_
                                                     _msg255484_
                                                     _buffer255482_)))
                                                 (_K255512255542_
                                                  (lambda ()
                                                    (_dispatch-value255180_
                                                     _msg255484_
                                                     _buffer255482_)))
                                                 (_K255511255528_
                                                  (lambda ()
                                                    (_dispatch-control255181_
                                                     _msg255484_
                                                     _buffer255482_))))
                                             (let* ((_try-match255508255537_
                                                     (lambda ()
                                                       (if (or (##structure-direct-instance-of?
                                                                _content255505255515_
                                                                'std/actor/proto#!continue::t)
                                                               (##structure-direct-instance-of?
                                                                _content255505255515_
                                                                'std/actor/proto#!close::t)
                                                               (##structure-direct-instance-of?
                                                                _content255505255515_
                                                                'std/actor/proto#!abort::t))
                                                           (_K255511255528_)
                                                           (_else255509255523_))))
                                                    (_try-match255507255557_
                                                     (lambda ()
                                                       (if (or (##structure-direct-instance-of?
                                                                _content255505255515_
                                                                'std/actor/proto#!value::t)
                                                               (##structure-direct-instance-of?
                                                                _content255505255515_
                                                                'std/actor/proto#!error::t)
                                                               (##structure-direct-instance-of?
                                                                _content255505255515_
                                                                'std/actor/proto#!yield::t)
                                                               (##structure-direct-instance-of?
                                                                _content255505255515_
                                                                'std/actor/proto#!end::t)
                                                               (##structure-direct-instance-of?
                                                                _content255505255515_
                                                                'std/actor/proto#!sync::t))
                                                           (_K255512255542_)
                                                           (_try-match255508255537_)))))
                                               (if (or (##structure-direct-instance-of?
                                                        _content255505255515_
                                                        'std/actor/proto#!call::t)
                                                       (##structure-direct-instance-of?
                                                        _content255505255515_
                                                        'std/actor/proto#!event::t)
                                                       (##structure-direct-instance-of?
                                                        _content255505255515_
                                                        'std/actor/proto#!stream::t))
                                                   (_K255513255561_)
                                                   (_try-match255507255557_))))))))
                                 (if (##structure-direct-instance-of?
                                      _msg255486255493_
                                      'std/actor/message#message::t)
                                     (let* ((_e255491255573_
                                             (##vector-ref
                                              _msg255486255493_
                                              '1))
                                            (_content255576_ _e255491255573_))
                                       (_K255490255570_ _content255576_))
                                     '#!void))
                               (_loop255178_ _u8buf255480_))))
                          (_K255440255473_
                           (lambda () (_loop255178_ _u8buf255431_)))
                          (_K255439255465_
                           (lambda () (thread-send _conn255170_ '#!eof)))
                          (_K255438255455_
                           (lambda (_unexpected255453_)
                             (error '"read unexpected object"
                                    _unexpected255453_))))
                      (let* ((_try-match255435255468_
                              (lambda ()
                                (if (eof-object? _g255432255445_)
                                    (_K255439255465_)
                                    (let ((_unexpected255458_ _g255432255445_))
                                      (_K255438255455_ _unexpected255458_)))))
                             (_try-match255434255476_
                              (lambda ()
                                (if (eq? _g255432255445_ '#!void)
                                    (_K255440255473_)
                                    (_try-match255435255468_)))))
                        (if (##fx= (if (##values? _g255432255445_)
                                       (##vector-length _g255432255445_)
                                       '1)
                                   '2)
                            (let* ((_e255442255581_
                                    (##vector-ref _g255432255445_ '0))
                                   (_e255443255586_
                                    (##vector-ref _g255432255445_ '1)))
                              (let ((_u8buf255584_ _e255442255581_)
                                    (_count255589_ _e255443255586_))
                                (_K255441255578_ _count255589_ _u8buf255584_)))
                            (_try-match255434255476_)))))))
               (_dispatch-call255179_
                (lambda (_msg255341_ _buffer255342_)
                  (let* ((_uuid255344_
                          (##direct-structure-ref
                           _msg255341_
                           '3
                           std/actor/message#message::t
                           '#f))
                         (_$e255346_
                          (std/misc/sync#sync-hash-get
                           _actor-table255173_
                           _uuid255344_)))
                    (if _$e255346_
                        ((lambda (_e255348255350_)
                           (let* ((_g255352255359_ _e255348255350_)
                                  (_E255354255363_
                                   (lambda ()
                                     (error '"No clause matching"
                                            _g255352255359_)))
                                  (_K255355255377_
                                   (lambda (_proto255366_ _actor255367_)
                                     (if (_read-payload!255186_
                                          _msg255341_
                                          _buffer255342_
                                          _proto255366_)
                                         (begin
                                           (##direct-structure-set!
                                            _msg255341_
                                            _actor255367_
                                            '3
                                            std/actor/message#message::t
                                            '#f)
                                           (##direct-structure-set!
                                            _msg255341_
                                            (let ((__obj310928
                                                   (make-object
                                                    std/actor/proto#remote::t
                                                    '4)))
                                              (std/actor/proto#remote:::init!
                                               __obj310928
                                               _conn255170_
                                               _uuid255344_
                                               _connaddr255171_
                                               _proto255366_)
                                              __obj310928)
                                            '2
                                            std/actor/message#message::t
                                            '#f)
                                           (std/actor/message#send__0
                                            _actor255367_
                                            _msg255341_))
                                         (if (or (##structure-direct-instance-of?
                                                  (##direct-structure-ref
                                                   _msg255341_
                                                   '1
                                                   std/actor/message#message::t
                                                   '#f)
                                                  'std/actor/proto#!call::t)
                                                 (##structure-direct-instance-of?
                                                  (##direct-structure-ref
                                                   _msg255341_
                                                   '1
                                                   std/actor/message#message::t
                                                   '#f)
                                                  'std/actor/proto#!stream::t))
                                             (let* ((_content255372_
                                                     (##direct-structure-ref
                                                      _msg255341_
                                                      '1
                                                      std/actor/message#message::t
                                                      '#f))
                                                    (_k255374_
                                                     (if (##structure-direct-instance-of?
                                                          _content255372_
                                                          'std/actor/proto#!call::t)
                                                         (##direct-structure-ref
                                                          _content255372_
                                                          '2
                                                          std/actor/proto#!call::t
                                                          '#f)
                                                         (##direct-structure-ref
                                                          _content255372_
                                                          '2
                                                          std/actor/proto#!stream::t
                                                          '#f))))
                                               (_dispatch-remote-error255184_
                                                (##structure
                                                 std/actor/proto#!error::t
                                                 '"unmarshal error"
                                                 _k255374_)
                                                _uuid255344_))
                                             '#!void)))))
                             (if (##fx= (if (##values? _g255352255359_)
                                            (##vector-length _g255352255359_)
                                            '1)
                                        '2)
                                 (let* ((_e255356255380_
                                         (##vector-ref _g255352255359_ '0))
                                        (_actor255383_ _e255356255380_)
                                        (_e255357255385_
                                         (##vector-ref _g255352255359_ '1))
                                        (_proto255388_ _e255357255385_))
                                   (_K255355255377_
                                    _proto255388_
                                    _actor255383_))
                                 (_E255354255363_))))
                         _$e255346_)
                        (begin
                          (std/actor/rpc/connection#warnf
                           '"cannot route message; no actor binding ~a"
                           (std/misc/uuid#uuid->string _uuid255344_))
                          (let* ((_g255389255399_
                                  (##direct-structure-ref
                                   _msg255341_
                                   '1
                                   std/actor/message#message::t
                                   '#f))
                                 (_else255391255407_ (lambda () '#!void))
                                 (_K255393255412_
                                  (lambda (_k255410_)
                                    (_dispatch-remote-error255184_
                                     (##structure
                                      std/actor/proto#!error::t
                                      '"no binding"
                                      _k255410_)
                                     _uuid255344_))))
                            (if (##structure-direct-instance-of?
                                 _g255389255399_
                                 'std/actor/proto#!call::t)
                                (let* ((_e255396255415_
                                        (##vector-ref _g255389255399_ '1))
                                       (_e255397255418_
                                        (##vector-ref _g255389255399_ '2))
                                       (_k255421_ _e255397255418_))
                                  (_K255393255412_ _k255421_))
                                (if (##structure-direct-instance-of?
                                     _g255389255399_
                                     'std/actor/proto#!stream::t)
                                    (let* ((_e255394255423_
                                            (##vector-ref _g255389255399_ '1))
                                           (_e255395255426_
                                            (##vector-ref _g255389255399_ '2))
                                           (_k255429_ _e255395255426_))
                                      (_K255393255412_ _k255429_))
                                    '#!void))))))))
               (_dispatch-value255180_
                (lambda (_msg255272_ _buffer255273_)
                  (let* ((_content255275_
                          (##direct-structure-ref
                           _msg255272_
                           '1
                           std/actor/message#message::t
                           '#f))
                         (_cont255277_ (_value-k255182_ _content255275_)))
                    (let ((_$e255280_
                           (std/actor/rpc/connection#continuation-table-get
                            _cont-table255174_
                            _cont255277_)))
                      (if _$e255280_
                          ((lambda (_e255282255284_)
                             (let* ((_g255286255295_ _e255282255284_)
                                    (_E255288255299_
                                     (lambda ()
                                       (error '"No clause matching"
                                              _g255286255295_)))
                                    (_K255289255318_
                                     (lambda (_stream?255302_
                                              _k255303_
                                              _proto255304_
                                              _actor255305_)
                                       (if (_read-payload!255186_
                                            _msg255272_
                                            _buffer255273_
                                            _proto255304_)
                                           (begin
                                             (_value-k-set!255183_
                                              _content255275_
                                              _k255303_)
                                             (##direct-structure-set!
                                              _msg255272_
                                              (let ((__obj310929
                                                     (make-object
                                                      std/actor/proto#remote::t
                                                      '4)))
                                                (std/actor/proto#remote:::init!
                                                 __obj310929
                                                 _conn255170_
                                                 (##direct-structure-ref
                                                  _msg255272_
                                                  '3
                                                  std/actor/message#message::t
                                                  '#f)
                                                 _connaddr255171_
                                                 _proto255304_)
                                                __obj310929)
                                              '2
                                              std/actor/message#message::t
                                              '#f)
                                             (if (or (##structure-direct-instance-of?
                                                      _content255275_
                                                      'std/actor/proto#!yield::t)
                                                     (##structure-direct-instance-of?
                                                      _content255275_
                                                      'std/actor/proto#!sync::t))
                                                 (let ((_ok255316_
                                                        (let ((_mx255310_
                                                               (##unchecked-structure-ref
                                                                _cont-table255174_
                                                                '1
                                                                std/actor/rpc/connection#continuation-table::t
                                                                '#f)))
                                                          (mutex-lock!
                                                           _mx255310_)
                                                          (let ((_res255313_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (if (table-ref
                              (##unchecked-structure-ref
                               _cont-table255174_
                               '2
                               std/actor/rpc/connection#continuation-table::t
                               '#f)
                              _cont255277_
                              '#f)
                             (begin
                               (std/actor/message#send__0
                                _actor255305_
                                _msg255272_)
                               '#t)
                             '#f)))
                    (mutex-unlock! _mx255310_)
                    _res255313_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (if _ok255316_
                                                       '#!void
                                                       (if (##structure-direct-instance-of?
                                                            _content255275_
                                                            'std/actor/proto#!sync::t)
                                                           (_dispatch-remote-error255184_
                                                            (##structure
                                                             std/actor/proto#!abort::t
                                                             _cont255277_)
                                                            (##direct-structure-ref
                                                             _msg255272_
                                                             '3
                                                             std/actor/message#message::t
                                                             '#f))
                                                           '#!void)))
                                                 (if (std/actor/rpc/connection#continuation-table-remove!
                                                      _cont-table255174_
                                                      _cont255277_)
                                                     (std/actor/message#send__0
                                                      _actor255305_
                                                      _msg255272_)
                                                     '#!void)))
                                           (begin
                                             (if (std/actor/rpc/connection#continuation-table-remove!
                                                  _cont-table255174_
                                                  _cont255277_)
                                                 (std/actor/message#send-message__%
                                                  _actor255305_
                                                  (##structure
                                                   std/actor/proto#!error::t
                                                   (make-struct-instance
                                                    std/actor/proto#rpc-error::t
                                                    'rpc
                                                    '"unmarshal error")
                                                   _k255303_)
                                                  '#f
                                                  '#f)
                                                 '#!void)
                                             (if (##structure-direct-instance-of?
                                                  _content255275_
                                                  'std/actor/proto#!sync::t)
                                                 (_dispatch-remote-error255184_
                                                  (##structure
                                                   std/actor/proto#!abort::t
                                                   _cont255277_)
                                                  (##direct-structure-ref
                                                   _msg255272_
                                                   '3
                                                   std/actor/message#message::t
                                                   '#f))
                                                 '#!void))))))
                               (if (##fx= (if (##values? _g255286255295_)
                                              (##vector-length _g255286255295_)
                                              '1)
                                          '4)
                                   (let* ((_e255290255321_
                                           (##vector-ref _g255286255295_ '0))
                                          (_actor255324_ _e255290255321_)
                                          (_e255291255326_
                                           (##vector-ref _g255286255295_ '1))
                                          (_proto255329_ _e255291255326_)
                                          (_e255292255331_
                                           (##vector-ref _g255286255295_ '2))
                                          (_k255334_ _e255292255331_)
                                          (_e255293255336_
                                           (##vector-ref _g255286255295_ '3))
                                          (_stream?255339_ _e255293255336_))
                                     (_K255289255318_
                                      _stream?255339_
                                      _k255334_
                                      _proto255329_
                                      _actor255324_))
                                   (_E255288255299_))))
                           _$e255280_)
                          (begin
                            (std/actor/rpc/connection#warnf
                             '"cannot route message; unknown continuation ~a"
                             _cont255277_)
                            (if (##structure-direct-instance-of?
                                 _content255275_
                                 'std/actor/proto#!sync::t)
                                (_dispatch-remote-error255184_
                                 (##structure
                                  std/actor/proto#!abort::t
                                  _cont255277_)
                                 (##direct-structure-ref
                                  _msg255272_
                                  '3
                                  std/actor/message#message::t
                                  '#f))
                                '#!void)))))))
               (_dispatch-control255181_
                (lambda (_msg255234_ _buffer255235_)
                  (let* ((_content255237_
                          (##direct-structure-ref
                           _msg255234_
                           '1
                           std/actor/message#message::t
                           '#f))
                         (_cont255239_ (_value-k255182_ _content255237_))
                         (_stream255241_
                          (std/actor/rpc/connection#continuation-table-get-stream-actor
                           _cont-table255174_
                           _cont255239_)))
                    (if _stream255241_
                        (let* ((_stream255243255250_ _stream255241_)
                               (_E255245255254_
                                (lambda ()
                                  (error '"No clause matching"
                                         _stream255243255250_)))
                               (_K255246255260_
                                (lambda (_dest255257_ _actor255258_)
                                  (##direct-structure-set!
                                   _msg255234_
                                   _dest255257_
                                   '2
                                   std/actor/message#message::t
                                   '#f)
                                  (std/actor/message#send__0
                                   _actor255258_
                                   _msg255234_)
                                  (std/actor/rpc/connection#continuation-table-remove-stream-actor!
                                   _cont-table255174_
                                   _cont255239_))))
                          (if (##pair? _stream255243255250_)
                              (let ((_hd255247255263_
                                     (##car _stream255243255250_))
                                    (_tl255248255265_
                                     (##cdr _stream255243255250_)))
                                (let* ((_actor255268_ _hd255247255263_)
                                       (_dest255270_ _tl255248255265_))
                                  (_K255246255260_
                                   _dest255270_
                                   _actor255268_)))
                              (_E255245255254_)))
                        (begin
                          (std/actor/rpc/connection#warnf
                           '"unexpected control message; unknown stream ~a"
                           _cont255239_)
                          (if (##structure-direct-instance-of?
                               _content255237_
                               'std/actor/proto#!abort::t)
                              '#!void
                              (_dispatch-remote-error255184_
                               (##structure
                                std/actor/proto#!error::t
                                '"uknown stream"
                                _cont255239_)
                               (##direct-structure-ref
                                _msg255234_
                                '3
                                std/actor/message#message::t
                                '#f))))))))
               (_value-k255182_
                (lambda (_obj255232_)
                  (##vector-ref
                   _obj255232_
                   (fx- (##vector-length _obj255232_) '1))))
               (_value-k-set!255183_
                (lambda (_obj255229_ _k255230_)
                  (##vector-set!
                   _obj255229_
                   (fx- (##vector-length _obj255229_) '1)
                   _k255230_)))
               (_dispatch-remote-error255184_
                (lambda (_err255221_ _dest255222_)
                  (let* ((_msg255224_
                          (##structure
                           std/actor/message#message::t
                           _err255221_
                           '#!void
                           _dest255222_
                           '#f))
                         (_data255226_
                          (std/actor/rpc/proto/message#rpc-proto-marshal-message
                           _msg255224_
                           '#f)))
                    (thread-send _writer255175_ _data255226_))))
               (_read-envelope255185_
                (lambda (_buffer255209_)
                  (with-exception-catcher
                   (lambda (_g255210255212_)
                     (if ((lambda (_$obj255215_) (exception? _$obj255215_))
                          _g255210255212_)
                         (let ((_e255218_ _g255210255212_))
                           (std/actor/rpc/connection#errorf
                            '"read error: ~a"
                            _e255218_)
                           _e255218_)
                         (raise _g255210255212_)))
                   (lambda ()
                     (std/actor/rpc/proto/message#rpc-proto-read-envelope
                      _buffer255209_)))))
               (_read-payload!255186_
                (lambda (_msg255198_ _buffer255199_ _proto255200_)
                  (with-exception-catcher
                   (lambda (_g255201255203_)
                     (if '#t
                         (let ((_e255206_ _g255201255203_))
                           (std/actor/rpc/connection#errorf
                            '"unmarshal error: ~a"
                            _e255206_)
                           '#f)
                         (raise _g255201255203_)))
                   (lambda ()
                     (std/actor/rpc/proto/message#rpc-proto-read-payload!
                      _msg255198_
                      _buffer255199_
                      _proto255200_)))))
               (_run255187_
                (lambda ()
                  (call-with-parameters
                   (lambda () (_loop255178_ (make-u8vector '4096)))
                   std/actor/xdr#current-xdr-type-registry
                   std/actor/xdr#+xdr-default-type-registry+))))
        (with-exception-catcher
         (lambda (_g255188255190_)
           (if '#t
               (let ((_e255193_ _g255188255190_))
                 (std/actor/rpc/connection#errorf
                  '"unhandled exception: ~a"
                  _e255193_))
               (raise _g255188255190_)))
         (lambda () (_run255187_))))))
  (define std/actor/rpc/connection#rpc-options-timeout
    (lambda (_opts255157_ _default255158_)
      (letrec ((_timeout255160_
                (lambda (_dt255167_ _default255168_)
                  (if (real? _dt255167_)
                      (seconds->time (+ (##current-time-point) _dt255167_))
                      (if (time? _dt255167_)
                          _dt255167_
                          (if (not _dt255167_)
                              _dt255167_
                              (_timeout255160_ _default255168_ '#f)))))))
        (let ((_$e255162_ (if _opts255157_ (memq 'timeout: _opts255157_) '#f)))
          (if _$e255162_
              ((lambda (_plist255165_)
                 (_timeout255160_ (cadr _plist255165_) _default255158_))
               _$e255162_)
              (_timeout255160_ _default255158_ '#f))))))
  (define std/actor/rpc/connection#rpc-connection-shutdown
    (lambda (_rpc-server255059_)
      (std/actor/message#send-message__0
       _rpc-server255059_
       (##structure
        std/actor/proto#!event::t
        (##structure std/actor/rpc/base#rpc.connection-shutdown::t)))
      (let _lp255061_ ()
        (let _loop255063255065_ ()
          (let ((_next255069_ (thread-mailbox-next)))
            ((lambda (_msg255072_)
               (let* ((_msg255074255082_ _msg255072_)
                      (_else255077255090_ (lambda () (_loop255063255065_))))
                 (let ((_K255080255152_
                        (lambda (_msg255104_)
                          (thread-mailbox-extract-and-rewind)
                          (let* ((_msg255105255111_ _msg255104_)
                                 (_E255107255115_
                                  (lambda ()
                                    (error '"No clause matching"
                                           _msg255105255111_)))
                                 (_K255108255144_
                                  (lambda (_content255118_)
                                    (let* ((_content255119255126_
                                            _content255118_)
                                           (_else255121255134_
                                            (lambda ()
                                              (std/actor/rpc/connection#rpc-send-error-response
                                               _msg255104_
                                               '"connection error")
                                              (_lp255061_)))
                                           (_K255123255138_
                                            (lambda ()
                                              (std/actor/rpc/connection#rpc-send-error-responses
                                               '"connection error"))))
                                      (if (##structure-direct-instance-of?
                                           _content255119255126_
                                           'std/actor/proto#!event::t)
                                          (let ((_e255124255141_
                                                 (##vector-ref
                                                  _content255119255126_
                                                  '1)))
                                            (if (##structure-direct-instance-of?
                                                 _e255124255141_
                                                 'std/actor#rpc.connection-close::t)
                                                (_K255123255138_)
                                                (_else255121255134_)))
                                          (_else255121255134_))))))
                            (if (##structure-direct-instance-of?
                                 _msg255105255111_
                                 'std/actor/message#message::t)
                                (let* ((_e255109255147_
                                        (##vector-ref _msg255105255111_ '1))
                                       (_content255150_ _e255109255147_))
                                  (_K255108255144_ _content255150_))
                                (_E255107255115_)))))
                       (_K255079255096_
                        (lambda (_ignore255094_)
                          (thread-mailbox-extract-and-rewind)
                          (_lp255061_))))
                   (if (##structure-direct-instance-of?
                        _msg255074255082_
                        'std/actor/message#message::t)
                       (let ((_msg255155_ _msg255074255082_))
                         (_K255080255152_ _msg255155_))
                       (let ((_ignore255099_ _msg255074255082_))
                         (_K255079255096_ _ignore255099_))))))
             _next255069_))))))
  (define std/actor/rpc/connection#rpc-connection-cleanup
    (lambda (_rpc-server255055_ _exn255056_ _sock255057_)
      (std/actor/rpc/connection#errorf '"connection error: ~a" _exn255056_)
      (if _sock255057_ (std/net/socket/api#ssocket-close _sock255057_) '#!void)
      (std/actor/rpc/connection#rpc-connection-shutdown _rpc-server255055_)))
  (define std/actor/rpc/connection#rpc-send-error-response
    (lambda (_msg254956_ _what254957_)
      (if (##structure-direct-instance-of?
           _msg254956_
           'std/actor/message#message::t)
          (let* ((_msg254958254966_ _msg254956_)
                 (_E254960254970_
                  (lambda () (error '"No clause matching" _msg254958254966_)))
                 (_K254961255037_
                  (lambda (_dest254973_ _src254974_ _content254975_)
                    (let* ((_content254976254989_ _content254975_)
                           (_else254979254997_ (lambda () '#!void)))
                      (let ((_K254983255018_
                             (lambda (_k255016_)
                               (std/actor/message#send-message__%
                                (##direct-structure-ref
                                 _msg254956_
                                 '2
                                 std/actor/message#message::t
                                 '#f)
                                (##structure
                                 std/actor/proto#!error::t
                                 (make-struct-instance
                                  std/actor/proto#rpc-error::t
                                  'rpc
                                  _what254957_)
                                 _k255016_)
                                '#f
                                '#f)))
                            (_K254981255005_
                             (lambda (_k255001_)
                               (let ((_abort255003_
                                      (##structure
                                       std/actor/message#message::t
                                       (##structure
                                        std/actor/proto#!abort::t
                                        _k255001_)
                                       _dest254973_
                                       _src254974_
                                       '#f)))
                                 (std/actor/message#send__0
                                  _src254974_
                                  _abort255003_)))))
                        (let* ((_try-match254978255013_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content254976254989_
                                       'std/actor/proto#!yield::t)
                                      (let* ((_e254982255008_
                                              (##vector-ref
                                               _content254976254989_
                                               '1))
                                             (_k255011_ _e254982255008_))
                                        (_K254981255005_ _k255011_))
                                      '#!void)))
                               (___match310908310909_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content254976254989_
                                       'std/actor/proto#!stream::t)
                                      (let* ((_e254984255029_
                                              (##vector-ref
                                               _content254976254989_
                                               '1))
                                             (_e254985255032_
                                              (##vector-ref
                                               _content254976254989_
                                               '2))
                                             (_k255035_ _e254985255032_))
                                        (_K254983255018_ _k255035_))
                                      (_try-match254978255013_)))))
                          (if (##structure-direct-instance-of?
                               _content254976254989_
                               'std/actor/proto#!call::t)
                              (let* ((_e254986255021_
                                      (##vector-ref _content254976254989_ '1))
                                     (_e254987255024_
                                      (##vector-ref _content254976254989_ '2))
                                     (_k255027_ _e254987255024_))
                                (_K254983255018_ _k255027_))
                              (___match310908310909_))))))))
            (if (##structure-direct-instance-of?
                 _msg254958254966_
                 'std/actor/message#message::t)
                (let* ((_e254962255040_ (##vector-ref _msg254958254966_ '1))
                       (_content255043_ _e254962255040_)
                       (_e254963255045_ (##vector-ref _msg254958254966_ '2))
                       (_src255048_ _e254963255045_)
                       (_e254964255050_ (##vector-ref _msg254958254966_ '3))
                       (_dest255053_ _e254964255050_))
                  (_K254961255037_ _dest255053_ _src255048_ _content255043_))
                (_E254960254970_)))
          '#!void)))
  (define std/actor/rpc/connection#rpc-send-error-responses
    (lambda (_what254903_)
      (let _lp254905_ ()
        (let _loop254907254909_ ()
          (let ((_next254913_ (std/actor/message#mailbox-next)))
            (if (eq? _next254913_ std/actor/message#mailbox-empty)
                ((lambda () (thread-mailbox-rewind) '#!void))
                ((lambda (_msg254917_)
                   (let* ((_msg254919254927_ _msg254917_)
                          (_else254922254935_
                           (lambda () (_loop254907254909_))))
                     (let ((_K254925254951_
                            (lambda (_msg254949_)
                              (thread-mailbox-extract-and-rewind)
                              (std/actor/rpc/connection#rpc-send-error-response
                               _msg254949_
                               _what254903_)
                              (_lp254905_)))
                           (_K254924254941_
                            (lambda (_ignore254939_)
                              (thread-mailbox-extract-and-rewind)
                              (_lp254905_))))
                       (if (##structure-direct-instance-of?
                            _msg254919254927_
                            'std/actor/message#message::t)
                           (let ((_msg254954_ _msg254919254927_))
                             (_K254925254951_ _msg254954_))
                           (let ((_ignore254944_ _msg254919254927_))
                             (_K254924254941_ _ignore254944_))))))
                 _next254913_))))))))
