(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/actor/rpc/proto/cookie#challenge-digest
    std/crypto/digest#digest::sha256)
  (define std/actor/rpc/proto/cookie#challenge-length
    (std/crypto/digest#digest-size
     std/actor/rpc/proto/cookie#challenge-digest))
  (define std/actor/rpc/proto/cookie#rpc-cookie-proto-accept
    (lambda (_ibuf254440_ _obuf254441_ _cookie254442_)
      (std/actor/rpc/proto/null#rpc-proto-accept-e
       _ibuf254440_
       _obuf254441_
       std/actor/rpc/proto/message#rpc-proto-cookie
       (lambda (_ibuf254444_ _obuf254445_)
         (std/actor/rpc/proto/cookie#rpc-cookie-proto-challenge
          _ibuf254444_
          _obuf254445_
          _cookie254442_)
         (values std/actor/rpc/proto/null#rpc-null-proto-read
                 std/actor/rpc/proto/null#rpc-null-proto-write)))))
  (define std/actor/rpc/proto/cookie#rpc-cookie-proto-connect
    (lambda (_ibuf254431_ _obuf254432_ _cookie254433_)
      (std/actor/rpc/proto/null#rpc-proto-connect-e
       _ibuf254431_
       _obuf254432_
       std/actor/rpc/proto/message#rpc-proto-cookie
       (lambda (_ibuf254435_ _obuf254436_)
         (let ((_e254438_ (std/net/bio/input#bio-read-u8 _ibuf254435_)))
           (if (eq? _e254438_ std/actor/rpc/proto/message#rpc-proto-challenge)
               (begin
                 (std/actor/rpc/proto/cookie#rpc-cookie-proto-challenge-respond
                  _ibuf254435_
                  _obuf254436_
                  _cookie254433_)
                 (values std/actor/rpc/proto/null#rpc-null-proto-read
                         std/actor/rpc/proto/null#rpc-null-proto-write))
               (if (eof-object? _e254438_)
                   (std/actor/proto#raise-rpc-io-error
                    'rpc-proto-connect
                    '"connection closed")
                   (std/actor/proto#raise-rpc-io-error
                    'rpc-proto-connect
                    '"bad hello"
                    _e254438_))))))))
  (define std/actor/rpc/proto/cookie#rpc-cookie-proto-challenge
    (lambda (_ibuf254414_ _obuf254415_ _cookie254416_)
      (std/net/bio/output#bio-write-u8
       std/actor/rpc/proto/message#rpc-proto-challenge
       _obuf254415_)
      (let ((_challenge254418_
             (std/crypto/etc#random-bytes
              std/actor/rpc/proto/cookie#challenge-length)))
        (std/net/bio/output#bio-write-u32
         std/actor/rpc/proto/cookie#challenge-length
         _obuf254415_)
        (std/net/bio/output#bio-write-bytes _challenge254418_ _obuf254415_)
        (std/net/bio/output#bio-force-output _obuf254415_)
        (let* ((_sz254420_ (std/net/bio/input#bio-read-u32 _ibuf254414_))
               (_g310695_
                (if (fx= _sz254420_
                         std/actor/rpc/proto/cookie#challenge-length)
                    '#!void
                    (std/actor/proto#raise-rpc-io-error
                     'rpc-proto-authen
                     '"challenge response size mismatch"
                     _sz254420_)))
               (_response254423_ (make-u8vector _sz254420_))
               (_g310696_
                (std/net/bio/input#bio-read-bytes
                 _response254423_
                 _ibuf254414_))
               (_secret254428_
                (let ((_digest254426_
                       (let ((__obj310693
                              (make-object std/crypto/digest#digest::t '2)))
                         (std/crypto/digest#digest:::init!
                          __obj310693
                          std/actor/rpc/proto/cookie#challenge-digest)
                         __obj310693)))
                  (std/crypto/digest#digest-update!__0
                   _digest254426_
                   _cookie254416_)
                  (std/crypto/digest#digest-update!__0
                   _digest254426_
                   _challenge254418_)
                  (std/crypto/digest#digest-final!__0 _digest254426_))))
          (if (equal? _response254423_ _secret254428_)
              (begin
                (std/net/bio/output#bio-write-u8
                 std/actor/rpc/proto/message#rpc-proto-connect-accept
                 _obuf254415_)
                (std/net/bio/output#bio-force-output _obuf254415_))
              (begin
                (std/net/bio/output#bio-write-u8
                 std/actor/rpc/proto/message#rpc-proto-connect-reject
                 _obuf254415_)
                (std/net/bio/output#bio-force-output _obuf254415_)
                (std/actor/proto#raise-rpc-io-error
                 'rpc-proto-authen
                 '"authentication failure"
                 _challenge254418_
                 _response254423_)))))))
  (define std/actor/rpc/proto/cookie#rpc-cookie-proto-challenge-respond
    (lambda (_ibuf254397_ _obuf254398_ _cookie254399_)
      (let* ((_sz254401_ (std/net/bio/input#bio-read-u32 _ibuf254397_))
             (_g310697_
              (if (fx> _sz254401_ '1024)
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-authen
                   '"inordinately sized challenge"
                   _sz254401_)
                  '#!void))
             (_challenge254404_ (make-u8vector _sz254401_))
             (_g310698_
              (std/net/bio/input#bio-read-bytes
               _challenge254404_
               _ibuf254397_))
             (_digest254407_
              (let ((__obj310694 (make-object std/crypto/digest#digest::t '2)))
                (std/crypto/digest#digest:::init!
                 __obj310694
                 std/actor/rpc/proto/cookie#challenge-digest)
                __obj310694)))
        (std/crypto/digest#digest-update!__0 _digest254407_ _cookie254399_)
        (std/crypto/digest#digest-update!__0 _digest254407_ _challenge254404_)
        (let ((_response254410_
               (std/crypto/digest#digest-final!__0 _digest254407_)))
          (std/net/bio/output#bio-write-u32
           std/actor/rpc/proto/cookie#challenge-length
           _obuf254398_)
          (std/net/bio/output#bio-write-bytes _response254410_ _obuf254398_)
          (std/net/bio/output#bio-force-output _obuf254398_))
        (let ((_e254412_ (std/net/bio/input#bio-read-u8 _ibuf254397_)))
          (if (eq? _e254412_
                   std/actor/rpc/proto/message#rpc-proto-connect-accept)
              '#!void
              (if (eof-object? _e254412_)
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-authen
                   '"connection closed")
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-authen
                   '"authentication failure"
                   _e254412_)))))))
  (define std/actor/rpc/proto/cookie#rpc-cookie-proto__%
    (lambda (_cookie-file254371_)
      (let ((_cookie254373_ (call-with-input-file _cookie-file254371_ read)))
        (if (u8vector? _cookie254373_)
            (##structure
             std/actor/rpc/base#!rpc-protocol::t
             (lambda (_g254374254377_ _g254375254379_)
               (std/actor/rpc/proto/cookie#rpc-cookie-proto-connect
                _g254374254377_
                _g254375254379_
                _cookie254373_))
             (lambda (_g254381254384_ _g254382254386_)
               (std/actor/rpc/proto/cookie#rpc-cookie-proto-accept
                _g254381254384_
                _g254382254386_
                _cookie254373_)))
            (error '"Invalid cookie; expected u8vector"
                   _cookie-file254371_
                   _cookie254373_)))))
  (define std/actor/rpc/proto/cookie#rpc-cookie-proto__0
    (lambda ()
      (let ((_cookie-file254393_ '"~/.gerbil/cookie"))
        (std/actor/rpc/proto/cookie#rpc-cookie-proto__% _cookie-file254393_))))
  (define std/actor/rpc/proto/cookie#rpc-cookie-proto
    (lambda _g310700_
      (let ((_g310699_ (##length _g310700_)))
        (cond ((##fx= _g310699_ 0)
               (apply std/actor/rpc/proto/cookie#rpc-cookie-proto__0
                      _g310700_))
              ((##fx= _g310699_ 1)
               (apply std/actor/rpc/proto/cookie#rpc-cookie-proto__%
                      _g310700_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/rpc/proto/cookie#rpc-cookie-proto
                _g310700_))))))
  (define std/actor/rpc/proto/cookie#rpc-generate-cookie!__%
    (lambda (_cookie-file254354_)
      (let ((_cookie254356_
             (std/crypto/etc#random-bytes
              std/actor/rpc/proto/cookie#challenge-length)))
        (call-with-output-file
         _cookie-file254354_
         (lambda (_g254357254359_) (write _cookie254356_ _g254357254359_))))))
  (define std/actor/rpc/proto/cookie#rpc-generate-cookie!__0
    (lambda ()
      (let ((_cookie-file254366_ '"~/.gerbil/cookie"))
        (std/actor/rpc/proto/cookie#rpc-generate-cookie!__%
         _cookie-file254366_))))
  (define std/actor/rpc/proto/cookie#rpc-generate-cookie!
    (lambda _g310702_
      (let ((_g310701_ (##length _g310702_)))
        (cond ((##fx= _g310701_ 0)
               (apply std/actor/rpc/proto/cookie#rpc-generate-cookie!__0
                      _g310702_))
              ((##fx= _g310701_ 1)
               (apply std/actor/rpc/proto/cookie#rpc-generate-cookie!__%
                      _g310702_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/rpc/proto/cookie#rpc-generate-cookie!
                _g310702_)))))))
