(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/crypto/pkey#keygen/ed25519
    (lambda ()
      (letrec* ((_ctx210375_
                 (std/crypto/libcrypto#EVP_PKEY_CTX_new_id
                  std/crypto/libcrypto#EVP_PKEY_ED25519
                  '#f)))
        (if (and _ctx210375_
                 (< '0
                    (std/crypto/libcrypto#EVP_PKEY_keygen_init _ctx210375_)))
            '#!void
            (error '"Can't create ED25519 keygen context"))
        (std/crypto/libcrypto#EVP_PKEY_keygen _ctx210375_))))
  (define std/crypto/pkey#bytes->private-key__%
    (lambda (_g301656_ _engine210350210353_ _type210355_ _bytes210356_)
      (let ((_engine210358_
             (if (eq? _engine210350210353_ absent-value)
                 '#f
                 _engine210350210353_)))
        (std/crypto/libcrypto#EVP_PKEY_new_raw_private_key
         _type210355_
         _engine210358_
         _bytes210356_))))
  (define std/crypto/pkey#bytes->private-key__@
    (lambda (_keys210349210363_ . _args210365_)
      (apply std/crypto/pkey#bytes->private-key__%
             _keys210349210363_
             (table-ref _keys210349210363_ 'engine: absent-value)
             _args210365_)))
  (define std/crypto/pkey#bytes->private-key
    (lambda _args210351210371_
      (apply keyword-dispatch
             '#(engine:)
             std/crypto/pkey#bytes->private-key__@
             _args210351210371_)))
  (define std/crypto/pkey#bytes->public-key__%
    (lambda (_g301657_ _engine210324210327_ _type210329_ _bytes210330_)
      (let ((_engine210332_
             (if (eq? _engine210324210327_ absent-value)
                 '#f
                 _engine210324210327_)))
        (std/crypto/libcrypto#EVP_PKEY_new_raw_public_key
         _type210329_
         _engine210332_
         _bytes210330_))))
  (define std/crypto/pkey#bytes->public-key__@
    (lambda (_keys210323210337_ . _args210339_)
      (apply std/crypto/pkey#bytes->public-key__%
             _keys210323210337_
             (table-ref _keys210323210337_ 'engine: absent-value)
             _args210339_)))
  (define std/crypto/pkey#bytes->public-key
    (lambda _args210325210345_
      (apply keyword-dispatch
             '#(engine:)
             std/crypto/pkey#bytes->public-key__@
             _args210325210345_)))
  (define std/crypto/pkey#bytes-argument
    (lambda (_bytes210320_)
      (if (u8vector? _bytes210320_)
          _bytes210320_
          (if (fixnum? _bytes210320_)
              (make-u8vector _bytes210320_)
              (if (not _bytes210320_)
                  '#f
                  (error '"invalid bytes argument" _bytes210320_))))))
  (define std/crypto/pkey#bytes-result
    (lambda (_bytes210317_ _len210318_)
      (if (zero? _len210318_)
          '#f
          (if (= _len210318_ (u8vector-length _bytes210317_))
              _bytes210317_
              (if (< _len210318_ (u8vector-length _bytes210317_))
                  (subu8vector _bytes210317_ '0 _len210318_)
                  '#f)))))
  (define std/crypto/pkey#key->bytes
    (lambda (_pkey210307_ _bytes210308_ _get_raw210309_)
      (letrec* ((_b210311_
                 (let ((_$e210314_
                        (std/crypto/pkey#bytes-argument _bytes210308_)))
                   (if _$e210314_
                       _$e210314_
                       (make-u8vector (_get_raw210309_ _pkey210307_ '#f)))))
                (_len210312_ (_get_raw210309_ _pkey210307_ _b210311_)))
        (std/crypto/pkey#bytes-result _b210311_ _len210312_))))
  (define std/crypto/pkey#private-key->bytes__%
    (lambda (_pkey210294_ _bytes210295_)
      (std/crypto/pkey#key->bytes
       _pkey210294_
       _bytes210295_
       std/crypto/libcrypto#EVP_PKEY_get_raw_private_key)))
  (define std/crypto/pkey#private-key->bytes__0
    (lambda (_pkey210300_)
      (let ((_bytes210302_ '#f))
        (std/crypto/pkey#private-key->bytes__% _pkey210300_ _bytes210302_))))
  (define std/crypto/pkey#private-key->bytes
    (lambda _g301659_
      (let ((_g301658_ (let () (declare (not safe)) (##length _g301659_))))
        (cond ((let () (declare (not safe)) (##fx= _g301658_ 1))
               (apply std/crypto/pkey#private-key->bytes__0 _g301659_))
              ((let () (declare (not safe)) (##fx= _g301658_ 2))
               (apply std/crypto/pkey#private-key->bytes__% _g301659_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/pkey#private-key->bytes
                _g301659_))))))
  (define std/crypto/pkey#public-key->bytes__%
    (lambda (_pkey210280_ _bytes210281_)
      (std/crypto/pkey#key->bytes
       _pkey210280_
       _bytes210281_
       std/crypto/libcrypto#EVP_PKEY_get_raw_public_key)))
  (define std/crypto/pkey#public-key->bytes__0
    (lambda (_pkey210286_)
      (let ((_bytes210288_ '#f))
        (std/crypto/pkey#public-key->bytes__% _pkey210286_ _bytes210288_))))
  (define std/crypto/pkey#public-key->bytes
    (lambda _g301661_
      (let ((_g301660_ (let () (declare (not safe)) (##length _g301661_))))
        (cond ((let () (declare (not safe)) (##fx= _g301660_ 1))
               (apply std/crypto/pkey#public-key->bytes__0 _g301661_))
              ((let () (declare (not safe)) (##fx= _g301660_ 2))
               (apply std/crypto/pkey#public-key->bytes__% _g301661_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/pkey#public-key->bytes
                _g301661_))))))
  (define std/crypto/pkey#digest-sign__%
    (lambda (_g301662_
             _engine210242210246_
             _sig210243210248_
             _pkey210250_
             _bytes210251_)
      (let* ((_engine210253_
              (if (eq? _engine210242210246_ absent-value)
                  '#f
                  _engine210242210246_))
             (_sig210255_
              (if (eq? _sig210243210248_ absent-value) '#f _sig210243210248_)))
        (letrec* ((_mctx210257_ (std/crypto/libcrypto#EVP_MD_CTX_create))
                  (_pctx210258_
                   (std/crypto/libcrypto#EVP_PKEY_CTX_new
                    _pkey210250_
                    _engine210253_))
                  (_g301663_
                   (let ((_g301664_
                          (if (and _mctx210257_ _pctx210258_)
                              (std/crypto/libcrypto#EVP_MD_CTX_set_pkey_ctx
                               _mctx210257_
                               _pctx210258_)
                              (error '"Can't create signing context"))))
                     #!void
                     _g301664_))
                  (_s210259_
                   (let ((_$e210262_
                          (std/crypto/pkey#bytes-argument _sig210255_)))
                     (if _$e210262_ _$e210262_ (make-u8vector '8192))))
                  (_len210260_
                   (std/crypto/libcrypto#EVP_DigestSign
                    _mctx210257_
                    _s210259_
                    _bytes210251_)))
          (std/crypto/pkey#bytes-result _s210259_ _len210260_)))))
  (define std/crypto/pkey#digest-sign__@
    (lambda (_keys210241210268_ . _args210270_)
      (apply std/crypto/pkey#digest-sign__%
             _keys210241210268_
             (table-ref _keys210241210268_ 'engine: absent-value)
             (table-ref _keys210241210268_ 'sig: absent-value)
             _args210270_)))
  (define std/crypto/pkey#digest-sign
    (lambda _args210244210276_
      (apply keyword-dispatch
             '#(sig: engine:)
             std/crypto/pkey#digest-sign__@
             _args210244210276_)))
  (define std/crypto/pkey#digest-verify__%
    (lambda (_g301666_
             _engine210212210215_
             _pkey210217_
             _sig210218_
             _bytes210219_)
      (let ((_engine210221_
             (if (eq? _engine210212210215_ absent-value)
                 '#f
                 _engine210212210215_)))
        (letrec* ((_mctx210223_ (std/crypto/libcrypto#EVP_MD_CTX_create))
                  (_pctx210224_
                   (std/crypto/libcrypto#EVP_PKEY_CTX_new
                    _pkey210217_
                    _engine210221_)))
          (if (and _mctx210223_ _pctx210224_)
              (std/crypto/libcrypto#EVP_MD_CTX_set_pkey_ctx
               _mctx210223_
               _pctx210224_)
              (error '"Can't create verification context"))
          (= '1
             (std/crypto/libcrypto#EVP_DigestVerify
              _mctx210223_
              _sig210218_
              _bytes210219_))))))
  (define std/crypto/pkey#digest-verify__@
    (lambda (_keys210211210229_ . _args210231_)
      (apply std/crypto/pkey#digest-verify__%
             _keys210211210229_
             (table-ref _keys210211210229_ 'engine: absent-value)
             _args210231_)))
  (define std/crypto/pkey#digest-verify
    (lambda _args210213210237_
      (apply keyword-dispatch
             '#(engine:)
             std/crypto/pkey#digest-verify__@
             _args210213210237_))))
