(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/logger#default-level '1)
  (define std/logger#verbose-level '4)
  (define std/logger#levels
    (let ((_ht49028_ (make-table 'size: '5)))
      (table-set! _ht49028_ '0 'ERROR)
      (table-set! _ht49028_ '1 'WARN)
      (table-set! _ht49028_ '2 'INFO)
      (table-set! _ht49028_ '3 'DEBUG)
      (table-set! _ht49028_ '4 'VERBOSE)
      _ht49028_))
  (define std/logger#symbolic-levels
    (let ((_ht49025_ (make-table 'size: '5)))
      (table-set! _ht49025_ 'ERROR '0)
      (table-set! _ht49025_ 'WARN '1)
      (table-set! _ht49025_ 'INFO '2)
      (table-set! _ht49025_ 'DEBUG '3)
      (table-set! _ht49025_ 'VERBOSE '4)
      _ht49025_))
  (define std/logger#level->symbolic
    (lambda (_level49023_)
      (table-ref std/logger#levels _level49023_ 'UNKNOWN)))
  (define std/logger#object->level
    (lambda (_level49021_)
      (if (fixnum? _level49021_)
          _level49021_
          (if (symbol? _level49021_)
              (table-ref
               std/logger#symbolic-levels
               _level49021_
               std/logger#verbose-level)
              (error '"invalid level; must be fixnum or symbol"
                     _level49021_)))))
  (define std/logger#current-logger (make-parameter '#f))
  (define std/logger#current-logger-options (make-parameter '1))
  (define std/logger#logger-options::t
    (make-struct-type
     'std/logger#logger-options::t
     '#f
     '2
     'logger-options
     '()
     '#f
     '(threshold sources)))
  (define std/logger#logger-options?
    (make-struct-predicate std/logger#logger-options::t))
  (define std/logger#make-logger-options
    (lambda _$args49018_
      (apply make-struct-instance std/logger#logger-options::t _$args49018_)))
  (define std/logger#logger-options-threshold
    (make-struct-field-accessor std/logger#logger-options::t '0))
  (define std/logger#logger-options-sources
    (make-struct-field-accessor std/logger#logger-options::t '1))
  (define std/logger#logger-options-threshold-set!
    (make-struct-field-mutator std/logger#logger-options::t '0))
  (define std/logger#logger-options-sources-set!
    (make-struct-field-mutator std/logger#logger-options::t '1))
  (define std/logger#log-message
    (lambda (_source48988_ _level48989_ _fmt48990_ _args48991_)
      (letrec ((_log-it48993_
                (lambda (_logger49009_ _threshold49010_)
                  (let ((_level49012_ (std/logger#object->level _level48989_))
                        (_threshold49013_
                         (std/logger#object->level _threshold49010_)))
                    (if (let ()
                          (declare (not safe))
                          (##fx<= _level49012_ _threshold49013_))
                        (let ((_now49015_ (std/srfi/19#current-date))
                              (_msg49016_
                               (if (null? _args48991_)
                                   _fmt48990_
                                   (apply std/format#format
                                          _fmt48990_
                                          (map std/logger#exception->string
                                               _args48991_)))))
                          (thread-send
                           _logger49009_
                           (let ()
                             (declare (not safe))
                             (##structure
                              std/logger#!log-message::t
                              _now49015_
                              _level49012_
                              _source48988_
                              _msg49016_))))
                        '#!void)))))
        (let ((_$e48995_ (std/logger#current-logger)))
          (if _$e48995_
              ((lambda (_logger48998_)
                 (let ((_opts49000_ (std/logger#current-logger-options)))
                   (if (let ()
                         (declare (not safe))
                         (##structure-instance-of?
                          _opts49000_
                          'std/logger#logger-options::t))
                       (let ((_$e49002_
                              (table-ref
                               (##structure-ref
                                _opts49000_
                                '2
                                std/logger#logger-options::t
                                '#f)
                               _source48988_
                               '#f)))
                         (if _$e49002_
                             ((lambda (_g4900449006_)
                                (_log-it48993_ _logger48998_ _g4900449006_))
                              _$e49002_)
                             (_log-it48993_
                              _logger48998_
                              (##structure-ref
                               _opts49000_
                               '1
                               std/logger#logger-options::t
                               '#f))))
                       (_log-it48993_ _logger48998_ _opts49000_))))
               _$e48995_)
              '#!void)))))
  (define std/logger#exception->string
    (lambda (_obj48984_)
      (if (exception? _obj48984_)
          (let ((_outp48986_ (open-output-string)))
            (display-exception _obj48984_ _outp48986_)
            (get-output-string _outp48986_))
          _obj48984_)))
  (define std/logger#errorf
    (lambda (_fmt48981_ . _args48982_)
      (std/logger#log-message 'default '0 _fmt48981_ _args48982_)))
  (define std/logger#warnf
    (lambda (_fmt48978_ . _args48979_)
      (std/logger#log-message 'default '1 _fmt48978_ _args48979_)))
  (define std/logger#infof
    (lambda (_fmt48975_ . _args48976_)
      (std/logger#log-message 'default '2 _fmt48975_ _args48976_)))
  (define std/logger#debugf
    (lambda (_fmt48972_ . _args48973_)
      (std/logger#log-message 'default '3 _fmt48972_ _args48973_)))
  (define std/logger#verbosef
    (lambda (_fmt48967_ . _args48969_)
      (std/logger#log-message 'default '4 _fmt48967_ _args48969_)))
  (define std/logger#!log-message::t
    (make-struct-type
     'std/logger#!log-message::t
     '#f
     '4
     '!log-message
     '()
     '#f
     '(ts level source msg)))
  (define std/logger#!log-message?
    (make-struct-predicate std/logger#!log-message::t))
  (define std/logger#make-!log-message
    (lambda _$args48964_
      (apply make-struct-instance std/logger#!log-message::t _$args48964_)))
  (define std/logger#!log-message-ts
    (make-struct-field-accessor std/logger#!log-message::t '0))
  (define std/logger#!log-message-level
    (make-struct-field-accessor std/logger#!log-message::t '1))
  (define std/logger#!log-message-source
    (make-struct-field-accessor std/logger#!log-message::t '2))
  (define std/logger#!log-message-msg
    (make-struct-field-accessor std/logger#!log-message::t '3))
  (define std/logger#!log-message-ts-set!
    (make-struct-field-mutator std/logger#!log-message::t '0))
  (define std/logger#!log-message-level-set!
    (make-struct-field-mutator std/logger#!log-message::t '1))
  (define std/logger#!log-message-source-set!
    (make-struct-field-mutator std/logger#!log-message::t '2))
  (define std/logger#!log-message-msg-set!
    (make-struct-field-mutator std/logger#!log-message::t '3))
  (define std/logger#start-logger!__%
    (lambda (_output48945_)
      (let ((_$e48947_ (std/logger#current-logger)))
        (if _$e48947_
            (values _$e48947_)
            (let ((_g292263_
                   (if (output-port? _output48945_)
                       (values _output48945_ '#f)
                       (if (string? _output48945_)
                           (values (open-output-file
                                    (cons 'path:
                                          (cons _output48945_
                                                (cons 'append:
                                                      (cons '#t '())))))
                                   '#t)
                           (error '"Bad output; expected filename or port"
                                  _output48945_)))))
              (begin
                (let ((_g292264_
                       (let ()
                         (declare (not safe))
                         (if (##values? _g292263_)
                             (##vector-length _g292263_)
                             1))))
                  (if (not (let () (declare (not safe)) (##fx= _g292264_ 2)))
                      (error "Context expects 2 values" _g292264_)))
                (let ((_port48950_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g292263_ 0)))
                      (_own-port?48951_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g292263_ 1))))
                  (let ((_srv48953_
                         (gerbil/gambit/threads#spawn/name
                          'logger
                          std/logger#logger-server
                          _port48950_
                          _own-port?48951_)))
                    (std/logger#current-logger _srv48953_)
                    _srv48953_))))))))
  (define std/logger#start-logger!__0
    (lambda ()
      (let ((_output48960_ (current-error-port)))
        (std/logger#start-logger!__% _output48960_))))
  (define std/logger#start-logger!
    (lambda _g292266_
      (let ((_g292265_ (let () (declare (not safe)) (##length _g292266_))))
        (cond ((let () (declare (not safe)) (##fx= _g292265_ 0))
               (apply std/logger#start-logger!__0 _g292266_))
              ((let () (declare (not safe)) (##fx= _g292265_ 1))
               (apply std/logger#start-logger!__% _g292266_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/logger#start-logger!
                _g292266_))))))
  (define std/logger#logger-server
    (lambda (_port48878_ _own-port?48879_)
      (letrec ((_loop48881_
                (lambda ()
                  (let* ((_g4888548897_ (thread-receive))
                         (_else4888848905_ (lambda () (_loop48881_))))
                    (let ((_K4889148921_
                           (lambda (_msg48916_
                                    _source48917_
                                    _level48918_
                                    _ts48919_)
                             (std/format#fprintf
                              _port48878_
                              '"~a ~a ~a ~a~n"
                              (std/srfi/19#date->string _ts48919_ '"~4")
                              (std/logger#level->symbolic _level48918_)
                              _source48917_
                              _msg48916_)
                             (force-output _port48878_)
                             (_loop48881_)))
                          (_K4889048910_ (lambda () '#!void)))
                      (let ((_try-match4888748913_
                             (lambda ()
                               (if (let ()
                                     (declare (not safe))
                                     (##eq? _g4888548897_ 'shutdown))
                                   '#!void
                                   (_loop48881_)))))
                        (if (let ()
                              (declare (not safe))
                              (##structure-instance-of?
                               _g4888548897_
                               'std/logger#!log-message::t))
                            (let* ((_e4889248924_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _g4888548897_ '1)))
                                   (_e4889348929_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _g4888548897_ '2)))
                                   (_e4889448934_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _g4888548897_ '3)))
                                   (_e4889548939_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _g4888548897_ '4))))
                              (let ((_ts48927_ _e4889248924_)
                                    (_level48932_ _e4889348929_)
                                    (_source48937_ _e4889448934_)
                                    (_msg48942_ _e4889548939_))
                                (_K4889148921_
                                 _msg48942_
                                 _source48937_
                                 _level48932_
                                 _ts48927_)))
                            (_try-match4888748913_))))))))
        (with-unwind-protect
         (lambda () (_loop48881_))
         (lambda ()
           (if _own-port?48879_ (close-port _port48878_) '#!void)))))))
