(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/misc/uuid#uuid-length '16)
  (define std/misc/uuid#uuid::t
    (make-struct-type
     'std/misc/uuid#uuid::t
     '#f
     '2
     'uuid
     '((equal: bytes) (final: . #t))
     '#f
     '(bytes str)))
  (define std/misc/uuid#uuid? (make-struct-predicate std/misc/uuid#uuid::t))
  (define std/misc/uuid#make-uuid
    (lambda _$args177984_
      (apply make-struct-instance std/misc/uuid#uuid::t _$args177984_)))
  (define std/misc/uuid#uuid-bytes
    (make-struct-field-accessor std/misc/uuid#uuid::t '0))
  (define std/misc/uuid#uuid-str
    (make-struct-field-accessor std/misc/uuid#uuid::t '1))
  (define std/misc/uuid#uuid-bytes-set!
    (make-struct-field-mutator std/misc/uuid#uuid::t '0))
  (define std/misc/uuid#uuid-str-set!
    (make-struct-field-mutator std/misc/uuid#uuid::t '1))
  (define std/misc/uuid#uuid=?
    (lambda (_a177981_ _b177982_)
      (equal? (##direct-structure-ref _a177981_ '1 std/misc/uuid#uuid::t '#f)
              (##direct-structure-ref
               _b177982_
               '1
               std/misc/uuid#uuid::t
               '#f))))
  (define std/misc/uuid#uuid-hash
    (lambda (_uuid177979_)
      (equal?-hash
       (##direct-structure-ref _uuid177979_ '1 std/misc/uuid#uuid::t '#f))))
  (define std/misc/uuid#UUID
    (lambda (_obj177977_)
      (if (let ()
            (declare (not safe))
            (##structure-direct-instance-of?
             _obj177977_
             'std/misc/uuid#uuid::t))
          _obj177977_
          (if (string? _obj177977_)
              (std/misc/uuid#text->uuid _obj177977_)
              (if (symbol? _obj177977_)
                  (std/misc/uuid#text->uuid (symbol->string _obj177977_))
                  (if (u8vector? _obj177977_)
                      (std/misc/uuid#u8vector->uuid _obj177977_)
                      (error '"bad uuid identifier" _obj177977_)))))))
  (define std/misc/uuid#random-uuid
    (lambda ()
      (let ((_bytes177975_ (make-u8vector std/misc/uuid#uuid-length)))
        (std/crypto/etc#random-bytes!__0 _bytes177975_)
        (let ()
          (declare (not safe))
          (##structure std/misc/uuid#uuid::t _bytes177975_ '#f)))))
  (define std/misc/uuid#content-uuid
    (lambda (_str177967_)
      (let* ((_bytes177969_ (std/text/utf8#string->utf8__0 _str177967_))
             (_hash177971_ (std/crypto/digest#md5 _bytes177969_)))
        (let ()
          (declare (not safe))
          (##structure std/misc/uuid#uuid::t _hash177971_ '#f)))))
  (define std/misc/uuid#uuid-re
    (std/pregexp#pregexp
     '"[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}"))
  (define std/misc/uuid#uuid-re-capture
    (std/pregexp#pregexp
     '"([0-9a-fA-F]{8})-([0-9a-fA-F]{4})-([0-9a-fA-F]{4})-([0-9a-fA-F]{4})-([0-9a-fA-F]{12})"))
  (define std/misc/uuid#text->uuid
    (lambda (_str177965_)
      (if (std/pregexp#pregexp-match std/misc/uuid#uuid-re _str177965_)
          (std/misc/uuid#string->uuid _str177965_)
          (std/misc/uuid#content-uuid _str177965_))))
  (define std/misc/uuid#u8vector->uuid
    (lambda (_u8v177963_)
      (if (let ((__tmp301959 (u8vector-length _u8v177963_)))
            (declare (not safe))
            (##fx= __tmp301959 std/misc/uuid#uuid-length))
          (let ()
            (declare (not safe))
            (##structure std/misc/uuid#uuid::t _u8v177963_ '#f))
          (error '"Bad argument; invalid u8vector length" _u8v177963_))))
  (define std/misc/uuid#uuid->u8vector
    (lambda (_uuid177961_)
      (##direct-structure-ref _uuid177961_ '1 std/misc/uuid#uuid::t '#f)))
  (define std/misc/uuid#string->uuid
    (lambda (_str177884_)
      (let* ((_g177885177903_
              (std/pregexp#pregexp-match
               std/misc/uuid#uuid-re-capture
               _str177884_))
             (_else177887177911_
              (lambda () (error '"Bad argument; malformed uuid" _str177884_)))
             (_K177889177920_
              (lambda (_e177914_ _d177915_ _c177916_ _b177917_ _a177918_)
                (let ((__tmp301960
                       (u8vector-append
                        (std/text/hex#hex-decode__0 _a177918_)
                        (std/text/hex#hex-decode__0 _b177917_)
                        (std/text/hex#hex-decode__0 _c177916_)
                        (std/text/hex#hex-decode__0 _d177915_)
                        (std/text/hex#hex-decode__0 _e177914_))))
                  (declare (not safe))
                  (##structure
                   std/misc/uuid#uuid::t
                   __tmp301960
                   _str177884_)))))
        (if (let () (declare (not safe)) (##pair? _g177885177903_))
            (let ((_tl177891177923_
                   (let () (declare (not safe)) (##cdr _g177885177903_))))
              (if (let () (declare (not safe)) (##pair? _tl177891177923_))
                  (let ((_hd177892177926_
                         (let ()
                           (declare (not safe))
                           (##car _tl177891177923_)))
                        (_tl177893177928_
                         (let ()
                           (declare (not safe))
                           (##cdr _tl177891177923_))))
                    (let ((_a177931_ _hd177892177926_))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _tl177893177928_))
                          (let ((_hd177894177933_
                                 (let ()
                                   (declare (not safe))
                                   (##car _tl177893177928_)))
                                (_tl177895177935_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _tl177893177928_))))
                            (let ((_b177938_ _hd177894177933_))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _tl177895177935_))
                                  (let ((_hd177896177940_
                                         (let ()
                                           (declare (not safe))
                                           (##car _tl177895177935_)))
                                        (_tl177897177942_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _tl177895177935_))))
                                    (let ((_c177945_ _hd177896177940_))
                                      (if (let ()
                                            (declare (not safe))
                                            (##pair? _tl177897177942_))
                                          (let ((_hd177898177947_
                                                 (let ()
                                                   (declare (not safe))
                                                   (##car _tl177897177942_)))
                                                (_tl177899177949_
                                                 (let ()
                                                   (declare (not safe))
                                                   (##cdr _tl177897177942_))))
                                            (let ((_d177952_ _hd177898177947_))
                                              (if (let ()
                                                    (declare (not safe))
                                                    (##pair? _tl177899177949_))
                                                  (let ((_hd177900177954_
                                                         (let ()
                                                           (declare (not safe))
                                                           (##car _tl177899177949_)))
                                                        (_tl177901177956_
                                                         (let ()
                                                           (declare (not safe))
                                                           (##cdr _tl177899177949_))))
                                                    (let ((_e177959_
                                                           _hd177900177954_))
                                                      (if (let ()
                                                            (declare
                                                              (not safe))
                                                            (##null? _tl177901177956_))
                                                          (_K177889177920_
                                                           _e177959_
                                                           _d177952_
                                                           _c177945_
                                                           _b177938_
                                                           _a177931_)
                                                          (_else177887177911_))))
                                                  (_else177887177911_))))
                                          (_else177887177911_))))
                                  (_else177887177911_))))
                          (_else177887177911_))))
                  (_else177887177911_)))
            (_else177887177911_)))))
  (define std/misc/uuid#uuid->string
    (lambda (_uuid177864_)
      (let ((_$e177866_
             (##direct-structure-ref
              _uuid177864_
              '2
              std/misc/uuid#uuid::t
              '#f)))
        (if _$e177866_
            (values _$e177866_)
            (let* ((_bytes177869_
                    (##direct-structure-ref
                     _uuid177864_
                     '1
                     std/misc/uuid#uuid::t
                     '#f))
                   (_a177871_ (std/text/hex#hex-encode__% _bytes177869_ '0 '4))
                   (_b177873_ (std/text/hex#hex-encode__% _bytes177869_ '4 '6))
                   (_c177875_ (std/text/hex#hex-encode__% _bytes177869_ '6 '8))
                   (_d177877_
                    (std/text/hex#hex-encode__% _bytes177869_ '8 '10))
                   (_e177879_
                    (std/text/hex#hex-encode__% _bytes177869_ '10 '16))
                   (_str177881_
                    (string-append
                     _a177871_
                     '"-"
                     _b177873_
                     '"-"
                     _c177875_
                     '"-"
                     _d177877_
                     '"-"
                     _e177879_)))
              (##direct-structure-set!
               _uuid177864_
               _str177881_
               '2
               std/misc/uuid#uuid::t
               '#f)
              _str177881_))))))
