(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/address#ip4-address
    (lambda (_obj171532_)
      (if (std/net/address#ip4-address? _obj171532_)
          _obj171532_
          (if (std/net/address#ip4-address-string? _obj171532_)
              (std/net/address#string->ip4-address _obj171532_)
              (error '"Malformed ip4 address" _obj171532_)))))
  (define std/net/address#ip4-address?
    (lambda (_obj171530_)
      (if (let () (declare (not safe)) (##u8vector? _obj171530_))
          (let ((__tmp300874
                 (let ()
                   (declare (not safe))
                   (##u8vector-length _obj171530_))))
            (declare (not safe))
            (##fx= __tmp300874 '4))
          '#f)))
  (define std/net/address#ip4-address-string?
    (lambda (_obj171528_)
      (if (string? _obj171528_)
          (if (std/pregexp#pregexp-match
               std/net/address#ip4-address-rx
               _obj171528_)
              '#t
              '#f)
          '#f)))
  (define std/net/address#ip4-address-rx
    (std/pregexp#pregexp
     '"^(\\d{1,3})\\.(\\d{1,3})\\.(\\d{1,3})\\.(\\d{1,3})$"))
  (define std/net/address#string->ip4-address
    (lambda (_str171503_)
      (let* ((_g171504171511_
              (std/pregexp#pregexp-match
               std/net/address#ip4-address-rx
               _str171503_))
             (_E171506171515_
              (lambda () (error '"No clause matching" _g171504171511_)))
             (_K171507171520_
              (lambda (_octets171518_)
                (apply ##u8vector (map string->number _octets171518_)))))
        (if (let () (declare (not safe)) (##pair? _g171504171511_))
            (let* ((_tl171509171523_
                    (let () (declare (not safe)) (##cdr _g171504171511_)))
                   (_octets171526_ _tl171509171523_))
              (_K171507171520_ _octets171526_))
            (_E171506171515_)))))
  (define std/net/address#ip4-address->string
    (lambda (_ip4171501_)
      (if (std/net/address#ip4-address? _ip4171501_)
          (apply std/format#format
                 '"~a.~a.~a.~a"
                 (let () (declare (not safe)) (##u8vector->list _ip4171501_)))
          (if (std/net/address#ip4-address-string? _ip4171501_)
              _ip4171501_
              (error '"Malformed ip4 address" _ip4171501_)))))
  (define std/net/address#ip6-address
    (lambda (_obj171499_)
      (if (std/net/address#ip6-address? _obj171499_)
          _obj171499_
          (if (std/net/address#ip6-address-string? _obj171499_)
              (std/net/address#string->ip6-address _obj171499_)
              (error '"Malformed ip6 address" _obj171499_)))))
  (define std/net/address#ip6-address?
    (lambda (_obj171497_)
      (if (let () (declare (not safe)) (##u8vector? _obj171497_))
          (let ((__tmp300875
                 (let ()
                   (declare (not safe))
                   (##u8vector-length _obj171497_))))
            (declare (not safe))
            (##fx= __tmp300875 '16))
          '#f)))
  (define std/net/address#ip6-address-rx
    (std/pregexp#pregexp '"^[0-9a-fA-F:]+$"))
  (define std/net/address#ip6-address-string?
    (lambda (_obj171495_)
      (if (string? _obj171495_)
          (if (std/pregexp#pregexp-match
               std/net/address#ip6-address-rx
               _obj171495_)
              '#t
              '#f)
          '#f)))
  (define std/net/address#string->ip6-address
    (lambda (_str171382_)
      (letrec ((_hex-e171384_
                (lambda (_str171487_ _k171488_)
                  (let* ((_char171490_ (string-ref _str171487_ _k171488_))
                         (_$e171492_ (std/text/hex#unhex* _char171490_)))
                    (if _$e171492_
                        (values _$e171492_)
                        (error '"Malformed address; not a hex digit"
                               _str171487_
                               _char171490_)))))
               (_loop171385_
                (lambda (_rest171437_ _bytes171438_ _have-zeros171439_)
                  (let* ((_rest171440171448_ _rest171437_)
                         (_else171442171456_
                          (lambda ()
                            (_check171386_
                             (list->u8vector (reverse _bytes171438_)))))
                         (_K171444171475_
                          (lambda (_rest171459_ _hex171460_)
                            (let ((_$e171462_ (string-length _hex171460_)))
                              (if (eq? '0 _$e171462_)
                                  (if _have-zeros171439_
                                      (error '"Malformed address" _str171382_)
                                      (let* ((_count171465_
                                              (length _rest171459_))
                                             (_count171467_
                                              (let ((__tmp300876
                                                     (let ()
                                                       (declare (not safe))
                                                       (##fx- '8
                                                              _count171465_))))
                                                (declare (not safe))
                                                (##fx* __tmp300876 '2)))
                                             (_count171469_
                                              (let ((__tmp300877
                                                     (length _bytes171438_)))
                                                (declare (not safe))
                                                (##fx- _count171467_
                                                       __tmp300877)))
                                             (_g300878_
                                              (if (let ()
                                                    (declare (not safe))
                                                    (##fxnegative?
                                                     _count171469_))
                                                  (error '"Malformed address; too many bits"
                                                         _str171382_)
                                                  '#!void))
                                             (_block171472_
                                              (make-list _count171469_ '0)))
                                        (_loop171385_
                                         _rest171459_
                                         (foldl1 cons
                                                 _bytes171438_
                                                 _block171472_)
                                         '#t)))
                                  (if (eq? '1 _$e171462_)
                                      (_loop171385_
                                       _rest171459_
                                       (cons (_hex-e171384_ _hex171460_ '0)
                                             (cons '0 _bytes171438_))
                                       _have-zeros171439_)
                                      (if (eq? '2 _$e171462_)
                                          (_loop171385_
                                           _rest171459_
                                           (cons (let ((__tmp300880
                                                        (let ((__tmp300881
                                                               (_hex-e171384_
                                                                _hex171460_
                                                                '0)))
                                                          (declare (not safe))
                                                          (##fxarithmetic-shift
                                                           __tmp300881
                                                           '4)))
                                                       (__tmp300879
                                                        (_hex-e171384_
                                                         _hex171460_
                                                         '1)))
                                                   (declare (not safe))
                                                   (##fxior __tmp300880
                                                            __tmp300879))
                                                 (cons '0 _bytes171438_))
                                           _have-zeros171439_)
                                          (if (eq? '3 _$e171462_)
                                              (_loop171385_
                                               _rest171459_
                                               (cons (let ((__tmp300883
                                                            (let ((__tmp300884
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           (_hex-e171384_ _hex171460_ '1)))
                      (declare (not safe))
                      (##fxarithmetic-shift __tmp300884 '4)))
                   (__tmp300882 (_hex-e171384_ _hex171460_ '2)))
               (declare (not safe))
               (##fxior __tmp300883 __tmp300882))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (cons (_hex-e171384_
                                                            _hex171460_
                                                            '0)
                                                           _bytes171438_))
                                               _have-zeros171439_)
                                              (if (eq? '4 _$e171462_)
                                                  (_loop171385_
                                                   _rest171459_
                                                   (cons (let ((__tmp300886
                                                                (let ((__tmp300887
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                               (_hex-e171384_ _hex171460_ '2)))
                          (declare (not safe))
                          (##fxarithmetic-shift __tmp300887 '4)))
                       (__tmp300885 (_hex-e171384_ _hex171460_ '3)))
                   (declare (not safe))
                   (##fxior __tmp300886 __tmp300885))
                 (cons (let ((__tmp300889
                              (let ((__tmp300890
                                     (_hex-e171384_ _hex171460_ '0)))
                                (declare (not safe))
                                (##fxarithmetic-shift __tmp300890 '4)))
                             (__tmp300888 (_hex-e171384_ _hex171460_ '1)))
                         (declare (not safe))
                         (##fxior __tmp300889 __tmp300888))
                       _bytes171438_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   _have-zeros171439_)
                                                  _hex171460_)))))))))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _rest171440171448_))
                        (let ((_hd171445171478_
                               (let ()
                                 (declare (not safe))
                                 (##car _rest171440171448_)))
                              (_tl171446171480_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _rest171440171448_))))
                          (let* ((_hex171483_ _hd171445171478_)
                                 (_rest171485_ _tl171446171480_))
                            (_K171444171475_ _rest171485_ _hex171483_)))
                        (_else171442171456_)))))
               (_check171386_
                (lambda (_bytes171435_)
                  (if (let ((__tmp300891 (u8vector-length _bytes171435_)))
                        (declare (not safe))
                        (##fx= __tmp300891 '16))
                      _bytes171435_
                      (if (let ((__tmp300892 (u8vector-length _bytes171435_)))
                            (declare (not safe))
                            (##fx< __tmp300892 '16))
                          (error '"Malformed address; not enough bits"
                                 _str171382_
                                 _bytes171435_)
                          (error '"malformed address; too many bits"
                                 _str171382_
                                 _bytes171435_))))))
        (let* ((_hexes171388_ (string-split _str171382_ '#\:))
               (_hexes171389171399_ _hexes171388_)
               (_else171391171407_
                (lambda () (_loop171385_ _hexes171388_ '() '#f)))
               (_K171393171420_
                (lambda (_rest171410_)
                  (let* ((_count171412_ (length _rest171410_))
                         (_count171414_
                          (let ((__tmp300893
                                 (let ()
                                   (declare (not safe))
                                   (##fx- '8 _count171412_))))
                            (declare (not safe))
                            (##fx* __tmp300893 '2)))
                         (_g300894_
                          (if (let ()
                                (declare (not safe))
                                (##fxnegative? _count171414_))
                              (error '"Malformed address; too many bits"
                                     _str171382_)
                              '#!void))
                         (_bytes171417_ (make-list _count171414_ '0)))
                    (_loop171385_ _rest171410_ _bytes171417_ '#t)))))
          (if (let () (declare (not safe)) (##pair? _hexes171389171399_))
              (let ((_hd171394171423_
                     (let () (declare (not safe)) (##car _hexes171389171399_)))
                    (_tl171395171425_
                     (let ()
                       (declare (not safe))
                       (##cdr _hexes171389171399_))))
                (if (equal? _hd171394171423_ '"")
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl171395171425_))
                        (let ((_hd171396171428_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl171395171425_)))
                              (_tl171397171430_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl171395171425_))))
                          (if (equal? _hd171396171428_ '"")
                              (let ((_rest171433_ _tl171397171430_))
                                (_K171393171420_ _rest171433_))
                              (_else171391171407_)))
                        (_else171391171407_))
                    (_else171391171407_)))
              (_else171391171407_))))))
  (define std/net/address#ip6-address->string
    (lambda (_ip6171147_)
      (letrec ((_compress-zeros171149_
                (lambda (_hexes171380_)
                  (_compress-leading-trailing171150_
                   (_compress171151_ _hexes171380_))))
               (_compress-leading-trailing171150_
                (lambda (_hexes171378_)
                  (if (equal? (car _hexes171378_) '"")
                      (cons '"" _hexes171378_)
                      (if (equal? (last _hexes171378_) '"")
                          (begin
                            (set-cdr! (last-pair _hexes171378_) '(""))
                            _hexes171378_)
                          _hexes171378_))))
               (_compress171151_
                (lambda (_hexes171316_)
                  (let* ((_hexes171317171331_ _hexes171316_)
                         (_else171320171339_ (lambda () '())))
                    (let ((_K171325171363_
                           (lambda (_rest171361_)
                             (cons '"" (_compress*171152_ _rest171361_))))
                          (_K171322171346_
                           (lambda (_rest171343_ _hd171344_)
                             (cons _hd171344_
                                   (_compress171151_ _rest171343_)))))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _hexes171317171331_))
                          (let ((_tl171327171368_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _hexes171317171331_)))
                                (_hd171326171366_
                                 (let ()
                                   (declare (not safe))
                                   (##car _hexes171317171331_))))
                            (if (equal? _hd171326171366_ '"0")
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl171327171368_))
                                    (let ((_tl171329171373_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl171327171368_)))
                                          (_hd171328171371_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl171327171368_))))
                                      (if (equal? _hd171328171371_ '"0")
                                          (let ((_rest171376_
                                                 _tl171329171373_))
                                            (_K171325171363_ _rest171376_))
                                          (let ((_hd171354_ _hd171326171366_)
                                                (_rest171356_
                                                 _tl171327171368_))
                                            (_K171322171346_
                                             _rest171356_
                                             _hd171354_))))
                                    (let ((_hd171354_ _hd171326171366_)
                                          (_rest171356_ _tl171327171368_))
                                      (_K171322171346_
                                       _rest171356_
                                       _hd171354_)))
                                (let ((_hd171354_ _hd171326171366_)
                                      (_rest171356_ _tl171327171368_))
                                  (_K171322171346_ _rest171356_ _hd171354_))))
                          (_else171320171339_))))))
               (_compress*171152_
                (lambda (_hexes171284_)
                  (let* ((_hexes171285171293_ _hexes171284_)
                         (_else171287171301_ (lambda () _hexes171284_))
                         (_K171289171306_
                          (lambda (_rest171304_)
                            (_compress*171152_ _rest171304_))))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _hexes171285171293_))
                        (let ((_hd171290171309_
                               (let ()
                                 (declare (not safe))
                                 (##car _hexes171285171293_)))
                              (_tl171291171311_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _hexes171285171293_))))
                          (if (equal? _hd171290171309_ '"0")
                              (let ((_rest171314_ _tl171291171311_))
                                (_compress*171152_ _rest171314_))
                              (_else171287171301_)))
                        (_else171287171301_))))))
        (let _lp171154_ ((_rest171156_ (u8vector->list _ip6171147_))
                         (_hexes171157_ '()))
          (let* ((_rest171158171168_ _rest171156_)
                 (_else171160171176_
                  (lambda ()
                    (string-join
                     (_compress-zeros171149_ (reverse _hexes171157_))
                     '#\:)))
                 (_K171162171265_
                  (lambda (_rest171179_ _b1171180_ _b0171181_)
                    (let ((_b0h171183_
                           (let ((__tmp300895
                                  (let ()
                                    (declare (not safe))
                                    (##fxarithmetic-shift _b0171181_ '-4))))
                             (declare (not safe))
                             (##fxand __tmp300895 '15)))
                          (_b0l171184_
                           (let ()
                             (declare (not safe))
                             (##fxand _b0171181_ '15)))
                          (_b1h171185_
                           (let ((__tmp300896
                                  (let ()
                                    (declare (not safe))
                                    (##fxarithmetic-shift _b1171180_ '-4))))
                             (declare (not safe))
                             (##fxand __tmp300896 '15)))
                          (_b1l171186_
                           (let ()
                             (declare (not safe))
                             (##fxand _b1171180_ '15))))
                      (let ((_b0h171187171202_ _b0h171183_)
                            (_b0l171188171204_ _b0l171184_)
                            (_b1h171189171206_ _b1h171185_)
                            (_b1l171190171208_ _b1l171186_))
                        (let ((_else171195171216_
                               (lambda ()
                                 (_lp171154_
                                  _rest171179_
                                  (cons (string (std/text/hex#hex _b0h171183_)
                                                (std/text/hex#hex _b0l171184_)
                                                (std/text/hex#hex _b1h171185_)
                                                (std/text/hex#hex _b1l171186_))
                                        _hexes171157_)))))
                          (let ((_K171200171262_
                                 (lambda ()
                                   (_lp171154_
                                    _rest171179_
                                    (cons '"0" _hexes171157_))))
                                (_K171199171253_
                                 (lambda (_b1l171251_)
                                   (_lp171154_
                                    _rest171179_
                                    (cons (string (std/text/hex#hex
                                                   _b1l171251_))
                                          _hexes171157_))))
                                (_K171198171240_
                                 (lambda (_b1h171237_ _b1l171238_)
                                   (_lp171154_
                                    _rest171179_
                                    (cons (string (std/text/hex#hex
                                                   _b1h171237_)
                                                  (std/text/hex#hex
                                                   _b1l171238_))
                                          _hexes171157_))))
                                (_K171197171224_
                                 (lambda (_b0l171220_ _b1h171221_ _b1l171222_)
                                   (_lp171154_
                                    _rest171179_
                                    (cons (string (std/text/hex#hex
                                                   _b0l171220_)
                                                  (std/text/hex#hex
                                                   _b1h171221_)
                                                  (std/text/hex#hex
                                                   _b1l171222_))
                                          _hexes171157_)))))
                            (if (let ()
                                  (declare (not safe))
                                  (##eq? _b0h171187171202_ '0))
                                (if (let ()
                                      (declare (not safe))
                                      (##eq? _b0l171188171204_ '0))
                                    (if (let ()
                                          (declare (not safe))
                                          (##eq? _b1h171189171206_ '0))
                                        (if (let ()
                                              (declare (not safe))
                                              (##eq? _b1l171190171208_ '0))
                                            (_K171200171262_)
                                            (let ((_b1l171256_
                                                   _b1l171190171208_))
                                              (_K171199171253_ _b1l171256_)))
                                        (let ((_b1h171243_ _b1h171189171206_)
                                              (_b1l171245_ _b1l171190171208_))
                                          (_K171198171240_
                                           _b1h171243_
                                           _b1l171245_)))
                                    (let ((_b0l171227_ _b0l171188171204_)
                                          (_b1h171229_ _b1h171189171206_)
                                          (_b1l171231_ _b1l171190171208_))
                                      (_K171197171224_
                                       _b0l171227_
                                       _b1h171229_
                                       _b1l171231_)))
                                (_else171195171216_)))))))))
            (if (let () (declare (not safe)) (##pair? _rest171158171168_))
                (let ((_hd171163171268_
                       (let ()
                         (declare (not safe))
                         (##car _rest171158171168_)))
                      (_tl171164171270_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest171158171168_))))
                  (let ((_b0171273_ _hd171163171268_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl171164171270_))
                        (let ((_hd171165171275_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl171164171270_)))
                              (_tl171166171277_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl171164171270_))))
                          (let* ((_b1171280_ _hd171165171275_)
                                 (_rest171282_ _tl171166171277_))
                            (_K171162171265_
                             _rest171282_
                             _b1171280_
                             _b0171273_)))
                        (_else171160171176_))))
                (_else171160171176_)))))))
  (define std/net/address#inet-address
    (lambda (_obj171145_)
      (if (std/net/address#inet-address? _obj171145_)
          (std/net/address#inet-address-normalize _obj171145_)
          (if (std/net/address#inet-address-string? _obj171145_)
              (std/net/address#string->inet-address _obj171145_)
              (error '"Malformed inet address" _obj171145_)))))
  (define std/net/address#inet-address-normalize
    (lambda (_addr171112_)
      (let* ((_addr171113171120_ _addr171112_)
             (_E171115171124_
              (lambda () (error '"No clause matching" _addr171113171120_)))
             (_K171116171133_
              (lambda (_port171127_ _host171128_)
                (if (or (std/net/address#ip4-address? _host171128_)
                        (std/net/address#ip6-address? _host171128_))
                    _addr171112_
                    (if (std/net/address#ip4-address-string? _host171128_)
                        (cons (std/net/address#string->ip4-address
                               _host171128_)
                              _port171127_)
                        (if (std/net/address#ip6-address-string? _host171128_)
                            (cons (std/net/address#string->ip6-address
                                   _host171128_)
                                  _port171127_)
                            _addr171112_))))))
        (if (let () (declare (not safe)) (##pair? _addr171113171120_))
            (let ((_hd171117171136_
                   (let () (declare (not safe)) (##car _addr171113171120_)))
                  (_tl171118171138_
                   (let () (declare (not safe)) (##cdr _addr171113171120_))))
              (let* ((_host171141_ _hd171117171136_)
                     (_port171143_ _tl171118171138_))
                (_K171116171133_ _port171143_ _host171141_)))
            (_E171115171124_)))))
  (define std/net/address#inet-address?
    (lambda (_obj171077_)
      (let* ((_obj171078171086_ _obj171077_)
             (_else171080171094_ (lambda () '#f))
             (_K171082171100_
              (lambda (_port171097_ _host171098_)
                (if (std/net/address#inet-host-address? _host171098_)
                    (fixnum? _port171097_)
                    '#f))))
        (if (let () (declare (not safe)) (##pair? _obj171078171086_))
            (let ((_hd171083171103_
                   (let () (declare (not safe)) (##car _obj171078171086_)))
                  (_tl171084171105_
                   (let () (declare (not safe)) (##cdr _obj171078171086_))))
              (let* ((_host171108_ _hd171083171103_)
                     (_port171110_ _tl171084171105_))
                (_K171082171100_ _port171110_ _host171108_)))
            (_else171080171094_)))))
  (define std/net/address#inet-address-string?
    (lambda (_obj171031_)
      (let ((_$e171033_
             (if (string? _obj171031_)
                 (std/net/address#inet-address-split__% _obj171031_ false)
                 '#f)))
        (if _$e171033_
            ((lambda (_e171035171037_)
               (let* ((_g171039171047_ _e171035171037_)
                      (_else171041171055_ (lambda () '#f))
                      (_K171043171064_
                       (lambda (_port171058_ _host171059_)
                         (let ((_$e171061_ (string-empty? _host171059_)))
                           (if _$e171061_
                               _$e171061_
                               (std/net/address#inet-host-address-string?
                                _host171059_))))))
                 (if (let ((__tmp300897
                            (if (let ()
                                  (declare (not safe))
                                  (##values? _g171039171047_))
                                (let ()
                                  (declare (not safe))
                                  (##vector-length _g171039171047_))
                                '1)))
                       (declare (not safe))
                       (##fx= __tmp300897 '2))
                     (let* ((_e171044171067_
                             (let ()
                               (declare (not safe))
                               (##vector-ref _g171039171047_ '0)))
                            (_host171070_ _e171044171067_)
                            (_e171045171072_
                             (let ()
                               (declare (not safe))
                               (##vector-ref _g171039171047_ '1)))
                            (_port171075_ _e171045171072_))
                       (_K171043171064_ _port171075_ _host171070_))
                     (_else171041171055_))))
             _$e171033_)
            '#f))))
  (define std/net/address#inet-address-split__%
    (lambda (_str171013_ _E171014_)
      (let ((_$e171016_ (string-rindex _str171013_ '#\:)))
        (if _$e171016_
            ((lambda (_ix171019_)
               (values (substring _str171013_ '0 _ix171019_)
                       (substring
                        _str171013_
                        (let () (declare (not safe)) (##fx+ _ix171019_ '1))
                        (string-length _str171013_))))
             _$e171016_)
            (_E171014_ '"Malformed address; no port separator" _str171013_)))))
  (define std/net/address#inet-address-split__0
    (lambda (_str171024_)
      (let ((_E171026_ error))
        (std/net/address#inet-address-split__% _str171024_ _E171026_))))
  (define std/net/address#inet-address-split
    (lambda _g300899_
      (let ((_g300898_ (let () (declare (not safe)) (##length _g300899_))))
        (cond ((let () (declare (not safe)) (##fx= _g300898_ 1))
               (apply std/net/address#inet-address-split__0 _g300899_))
              ((let () (declare (not safe)) (##fx= _g300898_ 2))
               (apply std/net/address#inet-address-split__% _g300899_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/address#inet-address-split
                _g300899_))))))
  (define std/net/address#inet-host-address?
    (lambda (_obj171004_)
      (let ((_$e171006_ (std/net/address#ip4-address? _obj171004_)))
        (if _$e171006_
            _$e171006_
            (let ((_$e171009_ (std/net/address#ip6-address? _obj171004_)))
              (if _$e171009_
                  _$e171009_
                  (std/net/address#inet-host-address-string? _obj171004_)))))))
  (define std/net/address#inet-host-address-string?
    (lambda (_obj170996_)
      (let ((_$e170998_ (std/net/address#ip4-address-string? _obj170996_)))
        (if _$e170998_
            _$e170998_
            (let ((_$e171001_
                   (std/net/address#ip6-address-string? _obj170996_)))
              (if _$e171001_
                  _$e171001_
                  (std/net/address#inet-host-name? _obj170996_)))))))
  (define std/net/address#inet-host-name?
    (lambda (_obj170994_)
      (if (string? _obj170994_)
          (std/pregexp#pregexp-match
           std/net/address#inet-host-name-rx
           _obj170994_)
          '#f)))
  (define std/net/address#inet-host-name-rx
    (std/pregexp#pregexp
     '"^[a-zA-Z0-9](?:[a-zA-Z0-9-]*[a-zA-Z0-9])?(?:\\.[a-zA-Z0-9](?:[a-zA-Z0-9-]*[a-zA-Z0-9])?)*$"))
  (define std/net/address#string->inet-address
    (lambda (_str170954_)
      (letrec ((_string->host170956_
                (lambda (_host170992_)
                  (if (std/net/address#ip4-address-string? _host170992_)
                      (std/net/address#string->ip4-address _host170992_)
                      (if (std/net/address#ip6-address-string? _host170992_)
                          (std/net/address#string->ip6-address _host170992_)
                          (if (std/net/address#inet-host-name? _host170992_)
                              _host170992_
                              (if (string-empty? _host170992_)
                                  '#u8(0 0 0 0)
                                  (error '"Malformed address; bad host"
                                         _str170954_
                                         _host170992_)))))))
               (_string->port170957_
                (lambda (_port170988_)
                  (let ((_port170990_ (string->number _port170988_)))
                    (if (and (fixnum? _port170990_)
                             (let ()
                               (declare (not safe))
                               (##fx<= '0 _port170990_ '65535)))
                        _port170990_
                        (error '"Malformed address; bad port"
                               _str170954_
                               _port170990_))))))
        (let* ((_g170958170965_
                (std/net/address#inet-address-split__0 _str170954_))
               (_E170960170969_
                (lambda () (error '"No clause matching" _g170958170965_)))
               (_K170961170975_
                (lambda (_port170972_ _host170973_)
                  (cons (_string->host170956_ _host170973_)
                        (_string->port170957_ _port170972_)))))
          (if (let ((__tmp300900
                     (if (let ()
                           (declare (not safe))
                           (##values? _g170958170965_))
                         (let ()
                           (declare (not safe))
                           (##vector-length _g170958170965_))
                         '1)))
                (declare (not safe))
                (##fx= __tmp300900 '2))
              (let* ((_e170962170978_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _g170958170965_ '0)))
                     (_host170981_ _e170962170978_)
                     (_e170963170983_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _g170958170965_ '1)))
                     (_port170986_ _e170963170983_))
                (_K170961170975_ _port170986_ _host170981_))
              (_E170960170969_))))))
  (define std/net/address#inet-address->string
    (lambda (_obj170924_)
      (if (std/net/address#inet-address? _obj170924_)
          (let* ((_obj170925170932_ _obj170924_)
                 (_E170927170936_
                  (lambda () (error '"No clause matching" _obj170925170932_)))
                 (_K170928170942_
                  (lambda (_port170939_ _host170940_)
                    (std/format#format
                     '"~a:~a"
                     (std/net/address#inet-host-address->string _host170940_)
                     _port170939_))))
            (if (let () (declare (not safe)) (##pair? _obj170925170932_))
                (let ((_hd170929170945_
                       (let () (declare (not safe)) (##car _obj170925170932_)))
                      (_tl170930170947_
                       (let ()
                         (declare (not safe))
                         (##cdr _obj170925170932_))))
                  (let* ((_host170950_ _hd170929170945_)
                         (_port170952_ _tl170930170947_))
                    (_K170928170942_ _port170952_ _host170950_)))
                (_E170927170936_)))
          (if (std/net/address#inet-address-string? _obj170924_)
              _obj170924_
              (error '"Malformed inet address")))))
  (define std/net/address#inet-host-address->string
    (lambda (_host170922_)
      (if (string? _host170922_)
          _host170922_
          (if (std/net/address#ip4-address? _host170922_)
              (std/net/address#ip4-address->string _host170922_)
              (if (std/net/address#ip6-address? _host170922_)
                  (std/net/address#ip6-address->string _host170922_)
                  (error '"Malformed inet host address" _host170922_))))))
  (define std/net/address#resolve-address
    (lambda (_addr170852_)
      (let* ((_addr170854_ (std/net/address#inet-address _addr170852_))
             (_addr170855170862_ _addr170854_)
             (_E170857170866_
              (lambda () (error '"No clause matching" _addr170855170862_)))
             (_K170858170910_
              (lambda (_port170869_ _host170870_)
                (if (or (std/net/address#ip4-address? _host170870_)
                        (std/net/address#ip6-address? _host170870_))
                    _addr170854_
                    (let* ((_info170875_ (host-info _host170870_))
                           (_g170876170884_ (host-info-addresses _info170875_))
                           (_else170878170892_
                            (lambda ()
                              (error '"Failed to resolve address"
                                     _addr170854_)))
                           (_K170880170898_
                            (lambda (_rest170895_ _ip170896_)
                              (cons _ip170896_ _port170869_))))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _g170876170884_))
                          (let ((_hd170881170901_
                                 (let ()
                                   (declare (not safe))
                                   (##car _g170876170884_)))
                                (_tl170882170903_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _g170876170884_))))
                            (let* ((_ip170906_ _hd170881170901_)
                                   (_rest170908_ _tl170882170903_))
                              (_K170880170898_ _rest170908_ _ip170906_)))
                          (_else170878170892_)))))))
        (if (let () (declare (not safe)) (##pair? _addr170855170862_))
            (let ((_hd170859170913_
                   (let () (declare (not safe)) (##car _addr170855170862_)))
                  (_tl170860170915_
                   (let () (declare (not safe)) (##cdr _addr170855170862_))))
              (let* ((_host170918_ _hd170859170913_)
                     (_port170920_ _tl170860170915_))
                (_K170858170910_ _port170920_ _host170918_)))
            (_E170857170866_)))))
  (define std/net/address#resolved-address?
    (lambda (_obj170814_)
      (let* ((_obj170815170823_ _obj170814_)
             (_else170817170831_ (lambda () '#f))
             (_K170819170840_
              (lambda (_port170834_ _host170835_)
                (if (or (std/net/address#ip4-address? _host170835_)
                        (std/net/address#ip6-address? _host170835_))
                    (fixnum? _port170834_)
                    '#f))))
        (if (let () (declare (not safe)) (##pair? _obj170815170823_))
            (let ((_hd170820170843_
                   (let () (declare (not safe)) (##car _obj170815170823_)))
                  (_tl170821170845_
                   (let () (declare (not safe)) (##cdr _obj170815170823_))))
              (let* ((_host170848_ _hd170820170843_)
                     (_port170850_ _tl170821170845_))
                (_K170819170840_ _port170850_ _host170848_)))
            (_else170817170831_))))))
