(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/repl#errorf
    (lambda (_fmt197781_ . _args197782_)
      (std/logger#log-message 'repl '0 _fmt197781_ _args197782_)))
  (define std/net/repl#warnf
    (lambda (_fmt197778_ . _args197779_)
      (std/logger#log-message 'repl '1 _fmt197778_ _args197779_)))
  (define std/net/repl#infof
    (lambda (_fmt197775_ . _args197776_)
      (std/logger#log-message 'repl '2 _fmt197775_ _args197776_)))
  (define std/net/repl#debugf
    (lambda (_fmt197772_ . _args197773_)
      (std/logger#log-message 'repl '3 _fmt197772_ _args197773_)))
  (define std/net/repl#verbosef
    (lambda (_fmt197767_ . _args197769_)
      (std/logger#log-message 'repl '4 _fmt197767_ _args197769_)))
  (define std/net/repl#repl-state::t
    (make-struct-type
     'std/net/repl#repl-state::t
     '#f
     '4
     'repl-state
     '((final: . #t))
     '#f
     '(client channel reader eof)))
  (define std/net/repl#repl-state?
    (make-struct-predicate std/net/repl#repl-state::t))
  (define std/net/repl#make-repl-state
    (lambda _$args197764_
      (apply make-struct-instance std/net/repl#repl-state::t _$args197764_)))
  (define std/net/repl#repl-state-client
    (make-struct-field-accessor std/net/repl#repl-state::t '0))
  (define std/net/repl#repl-state-channel
    (make-struct-field-accessor std/net/repl#repl-state::t '1))
  (define std/net/repl#repl-state-reader
    (make-struct-field-accessor std/net/repl#repl-state::t '2))
  (define std/net/repl#repl-state-eof
    (make-struct-field-accessor std/net/repl#repl-state::t '3))
  (define std/net/repl#repl-state-client-set!
    (make-struct-field-mutator std/net/repl#repl-state::t '0))
  (define std/net/repl#repl-state-channel-set!
    (make-struct-field-mutator std/net/repl#repl-state::t '1))
  (define std/net/repl#repl-state-reader-set!
    (make-struct-field-mutator std/net/repl#repl-state::t '2))
  (define std/net/repl#repl-state-eof-set!
    (make-struct-field-mutator std/net/repl#repl-state::t '3))
  (define std/net/repl#start-repl-server!__%
    (lambda (_g303106_ _passwd197732197736_ _address197733197738_)
      (let* ((_passwd197741_
              (if (eq? _passwd197732197736_ absent-value)
                  '#f
                  _passwd197732197736_))
             (_address197743_
              (if (eq? _address197733197738_ absent-value)
                  '"127.0.0.1:7000"
                  _address197733197738_)))
        (std/logger#start-logger!__0)
        (let* ((_sock197745_
                (open-tcp-server
                 (cons 'server-address:
                       (cons _address197743_
                             (cons 'eol-encoding:
                                   (cons 'cr-lf
                                         (cons 'reuse-address:
                                               (cons '#t '()))))))))
               (_server197747_
                (gerbil/gambit/threads#spawn/group
                 'repl-server
                 std/net/repl#repl-server
                 _sock197745_
                 _passwd197741_)))
          (thread-specific-set! _server197747_ _sock197745_)
          _server197747_))))
  (define std/net/repl#start-repl-server!__@
    (lambda (_keys197731197753_ . _args197755_)
      (apply std/net/repl#start-repl-server!__%
             _keys197731197753_
             (table-ref _keys197731197753_ 'password: absent-value)
             (table-ref _keys197731197753_ 'address: absent-value)
             _args197755_)))
  (define std/net/repl#start-repl-server!
    (lambda _args197734197761_
      (apply keyword-dispatch
             '#(password: address:)
             std/net/repl#start-repl-server!__@
             _args197734197761_)))
  (define std/net/repl#stop-repl-server!
    (lambda (_server197713_)
      (let ((_tgroup197715_ (thread-thread-group _server197713_))
            (_port197716_ (thread-specific _server197713_)))
        (with-unwind-protect
         (lambda ()
           (with-exception-catcher
            (lambda (_g197717197720_)
              (if ((lambda (_$obj197723_) (uncaught-exception? _$obj197723_))
                   _g197717197720_)
                  (let ((_e197726_ _g197717197720_))
                    (if (os-exception? (uncaught-exception-reason _e197726_))
                        '#!void
                        (raise _e197726_)))
                  (raise _g197717197720_)))
            (lambda ()
              (close-port _port197716_)
              (std/misc/threads#thread-async! _server197713_ void)
              (thread-join! _server197713_))))
         (lambda () (std/misc/threads#thread-group-kill! _tgroup197715_))))))
  (define std/net/repl#repl-server
    (lambda (_sock197693_ _passwd197694_)
      (let _lp197696_ ()
        (let ((_client197699_ (read _sock197693_)))
          (if (eof-object? _client197699_)
              '#!void
              (begin
                (let ((_sinfo197701_
                       (tcp-client-peer-socket-info _client197699_)))
                  (std/net/repl#debugf
                   '"accepted repl connection from ~a"
                   (std/net/address#inet-address->string
                    (cons (socket-info-address _sinfo197701_)
                          (socket-info-port-number _sinfo197701_)))))
                (output-port-readtable-set!
                 _client197699_
                 (readtable-sharing-allowed?-set
                  (output-port-readtable _client197699_)
                  '#t))
                (let* ((_tgroup197703_ (make-thread-group 'repl-client))
                       (_thread197706_
                        (make-thread
                         (lambda ()
                           (std/net/repl#repl-client
                            _client197699_
                            _passwd197694_))
                         'repl
                         _tgroup197703_))
                       (_state197708_
                        (std/net/repl#make-repl-client-state
                         _client197699_
                         _thread197706_)))
                  (thread-group-specific-set! _tgroup197703_ _state197708_)
                  (thread-start! _thread197706_)
                  (let ((_monitor197711_
                         (gerbil/gambit/threads#spawn/name
                          'repl-client-monitor
                          std/net/repl#repl-client-monitor
                          _thread197706_
                          _tgroup197703_)))
                    (thread-specific-set! _monitor197711_ _tgroup197703_))
                  (_lp197696_))))))))
  (define std/net/repl#repl-client-monitor
    (lambda (_thread197678_ _tgroup197679_)
      (with-unwind-protect
       (lambda ()
         (with-exception-catcher
          (lambda (_g197680197683_)
            (if ((lambda (_$obj197686_) (uncaught-exception? _$obj197686_))
                 _g197680197683_)
                (let ((_e197689_ _g197680197683_))
                  (std/net/repl#errorf
                   '"repl client error: ~a"
                   (uncaught-exception-reason _e197689_)))
                (raise _g197680197683_)))
          (lambda () (thread-join! _thread197678_))))
       (lambda () (std/misc/threads#thread-group-kill! _tgroup197679_)))))
  (define std/net/repl#repl-client
    (lambda (_client197666_ _passwd197667_)
      (if _passwd197667_
          (let _lp197669_ ()
            (display '"Password: " _client197666_)
            (force-output _client197666_)
            (let ((_pw197672_ (read-line _client197666_)))
              (if (equal? _pw197672_ _passwd197667_) '#!void (_lp197669_))))
          '#!void)
      (let ((_state197674_ (std/net/repl#repl-client-state__0)))
        (thread-start!
         (##direct-structure-ref
          _state197674_
          '3
          std/net/repl#repl-state::t
          '#f))
        (call-with-parameters
         (lambda () (replx))
         current-input-port
         (let () (declare (not safe)) (##repl-input-port))
         current-output-port
         (let () (declare (not safe)) (##repl-output-port))
         current-error-port
         (let () (declare (not safe)) (##repl-output-port))
         ##current-user-interrupt-handler
         (lambda () (let () (declare (not safe)) (##handle-interrupt '#f))))
        (close-port _client197666_)
        (thread-terminate!
         (##direct-structure-ref
          _state197674_
          '3
          std/net/repl#repl-state::t
          '#f)))))
  (define std/net/repl#repl-client-reader
    (lambda (_state197625_ _in197626_ _out197627_ _repl-thread197628_)
      (letrec ((_loop197630_
                (lambda (_mode197639_)
                  (let ((_c197641_ (read-char _in197626_)))
                    (if (eof-object? _c197641_)
                        (begin
                          (##direct-structure-set!
                           _state197625_
                           '#t
                           '4
                           std/net/repl#repl-state::t
                           '#f)
                          (close-output-port _out197627_))
                        (let ((_$e197643_ _mode197639_))
                          (if (eq? 'input _$e197643_)
                              (if (char=? _c197641_ '#\ÿ)
                                  (_loop197630_ _c197641_)
                                  (if (char=? _c197641_ '#\x4)
                                      (begin
                                        (close-output-port _out197627_)
                                        (_loop197630_ _mode197639_))
                                      (begin
                                        (write-char _c197641_ _out197627_)
                                        (force-output _out197627_)
                                        (_loop197630_ _mode197639_))))
                              (if (or (eq? '#\û _$e197643_)
                                      (eq? '#\ü _$e197643_)
                                      (eq? '#\þ _$e197643_))
                                  (_loop197630_ 'input)
                                  (if (eq? '#\ý _$e197643_)
                                      (begin
                                        (if (char=? _c197641_ '#\x6)
                                            (let ((_client197652_
                                                   (##direct-structure-ref
                                                    _state197625_
                                                    '1
                                                    std/net/repl#repl-state::t
                                                    '#f)))
                                              (gerbil/gambit/ports#write-u8vector__%
                                               '#u8(255 251 6)
                                               _client197652_)
                                              (force-output _client197652_))
                                            '#!void)
                                        (_loop197630_ 'input))
                                      (if (eq? '#\ÿ _$e197643_)
                                          (let ((_$e197654_ _c197641_))
                                            (if (eq? '#\ô _$e197654_)
                                                (begin
                                                  (std/misc/threads#thread-async!
                                                   _repl-thread197628_
                                                   ##user-interrupt!)
                                                  (_loop197630_ 'input))
                                                (if (or (eq? '#\û _$e197654_)
                                                        (eq? '#\ü _$e197654_)
                                                        (eq? '#\ý _$e197654_)
                                                        (eq? '#\þ _$e197654_))
                                                    (_loop197630_ _c197641_)
                                                    (_loop197630_ 'input))))
                                          (_loop197630_ 'input)))))))))))
        (with-exception-catcher
         (lambda (_g197631197633_)
           (if '#t
               (let ((_e197636_ _g197631197633_))
                 (std/net/repl#errorf '"repl reader error: ~a" _e197636_)
                 (##direct-structure-set!
                  _state197625_
                  '#t
                  '4
                  std/net/repl#repl-state::t
                  '#f)
                 (close-output-port _out197627_))
               (raise _g197631197633_)))
         (lambda () (_loop197630_ 'input))))))
  (define std/net/repl#make-repl-client-state
    (lambda (_client197607_ _thread197608_)
      (let ((_g303107_
             (open-string-pipe '(direction: input permanent-close: #f))))
        (begin
          (let ((_g303108_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g303107_) (##vector-length _g303107_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g303108_ 2)))
                (error "Context expects 2 values" _g303108_)))
          (let ((_in-rd197610_
                 (let () (declare (not safe)) (##vector-ref _g303107_ 0)))
                (_in-wr197611_
                 (let () (declare (not safe)) (##vector-ref _g303107_ 1))))
            (let* ((_g303109_
                    (macro-port-name-set!
                     _in-rd197610_
                     (lambda (_port197613_) '(repl))))
                   (_channel197616_
                    (let ()
                      (declare (not safe))
                      (##make-repl-channel-ports
                       _in-rd197610_
                       _client197607_)))
                   (_g303110_
                    (macro-repl-channel-last-owner-set!
                     _channel197616_
                     _thread197608_))
                   (_state197619_
                    (let ()
                      (declare (not safe))
                      (##structure
                       std/net/repl#repl-state::t
                       _client197607_
                       _channel197616_
                       '#f
                       '#f)))
                   (_reader197622_
                    (make-thread
                     (lambda ()
                       (std/net/repl#repl-client-reader
                        _state197619_
                        _client197607_
                        _in-wr197611_
                        _thread197608_))
                     'repl-client-reader)))
              (##direct-structure-set!
               _state197619_
               _reader197622_
               '3
               std/net/repl#repl-state::t
               '#f)
              _state197619_))))))
  (define std/net/repl#repl-context-command
    (lambda (_repl-context197599_ _src197600_)
      (if (eof-object? _src197600_)
          (let ((_$e197602_ (std/net/repl#repl-client-state__0)))
            (if _$e197602_
                ((lambda (_state197605_)
                   (if (##direct-structure-ref
                        _state197605_
                        '4
                        std/net/repl#repl-state::t
                        '#f)
                       (let ()
                         (declare (not safe))
                         (##repl-context-return _repl-context197599_ '#!void))
                       (begin
                         (let () (declare (not safe)) (##repl-channel-newline))
                         (if (fx< '0
                                  (macro-repl-context-level
                                   _repl-context197599_))
                             (let ()
                               (declare (not safe))
                               (##repl-cmd-d _repl-context197599_))
                             (if (let ()
                                   (declare (not safe))
                                   (##repl-channel-really-exit?))
                                 (let ()
                                   (declare (not safe))
                                   (##repl-context-return
                                    _repl-context197599_
                                    '#!void))
                                 (let ()
                                   (declare (not safe))
                                   (##repl-context-prompt
                                    _repl-context197599_)))))))
                 _$e197602_)
                (let ()
                  (declare (not safe))
                  (##default-repl-context-command
                   _repl-context197599_
                   _src197600_))))
          (let ()
            (declare (not safe))
            (##default-repl-context-command
             _repl-context197599_
             _src197600_)))))
  (let ()
    (declare (not safe))
    (##repl-context-command-set! std/net/repl#repl-context-command))
  (define std/net/repl#make-repl-channel
    (lambda (_thread197594_)
      (let ((_$e197596_ (std/net/repl#repl-client-state__% _thread197594_)))
        (if _$e197596_
            (##direct-structure-ref
             _$e197596_
             '2
             std/net/repl#repl-state::t
             '#f)
            (let ()
              (declare (not safe))
              (##default-thread-make-repl-channel _thread197594_))))))
  (let ()
    (declare (not safe))
    (##thread-make-repl-channel-set! std/net/repl#make-repl-channel))
  (define std/net/repl#repl-client-state__%
    (lambda (_thread197575_)
      (let _lp197577_ ((_tgroup197579_ (thread-thread-group _thread197575_)))
        (if (not _tgroup197579_)
            '#f
            (let ((_$e197581_ (thread-group-specific _tgroup197579_)))
              (if _$e197581_
                  ((lambda (_state197584_)
                     (if (let ()
                           (declare (not safe))
                           (##structure-direct-instance-of?
                            _state197584_
                            'std/net/repl#repl-state::t))
                         _state197584_
                         (_lp197577_ (thread-group-parent _tgroup197579_))))
                   _$e197581_)
                  (_lp197577_ (thread-group-parent _tgroup197579_))))))))
  (define std/net/repl#repl-client-state__0
    (lambda ()
      (let ((_thread197590_ (current-thread)))
        (std/net/repl#repl-client-state__% _thread197590_))))
  (define std/net/repl#repl-client-state
    (lambda _g303112_
      (let ((_g303111_ (let () (declare (not safe)) (##length _g303112_))))
        (cond ((let () (declare (not safe)) (##fx= _g303111_ 0))
               (apply std/net/repl#repl-client-state__0 _g303112_))
              ((let () (declare (not safe)) (##fx= _g303111_ 1))
               (apply std/net/repl#repl-client-state__% _g303112_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/repl#repl-client-state
                _g303112_))))))
  (define std/net/repl#taint!__%
    (lambda (_tgroup197551_)
      (let ((_$e197553_ (std/net/repl#repl-client-state__0)))
        (if _$e197553_
            ((lambda (_state197556_)
               (let* ((_tgroup197561_
                       (let ((_$e197558_ _tgroup197551_))
                         (if _$e197558_
                             _$e197558_
                             (std/misc/threads#primordial-thread-group))))
                      (_ostate197563_ (thread-group-specific _tgroup197561_)))
                 (thread-group-specific-set! _tgroup197561_ _state197556_)
                 _ostate197563_))
             _$e197553_)
            (error '"No repl state")))))
  (define std/net/repl#taint!__0
    (lambda ()
      (let ((_tgroup197570_ '#f)) (std/net/repl#taint!__% _tgroup197570_))))
  (define std/net/repl#taint!
    (lambda _g303114_
      (let ((_g303113_ (let () (declare (not safe)) (##length _g303114_))))
        (cond ((let () (declare (not safe)) (##fx= _g303113_ 0))
               (apply std/net/repl#taint!__0 _g303114_))
              ((let () (declare (not safe)) (##fx= _g303113_ 1))
               (apply std/net/repl#taint!__% _g303114_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/repl#taint!
                _g303114_))))))
  (define std/net/repl#untaint!__%
    (lambda (_tgroup197527_ _state197528_)
      (let ((_tgroup197533_
             (let ((_$e197530_ _tgroup197527_))
               (if _$e197530_
                   _$e197530_
                   (std/misc/threads#primordial-thread-group)))))
        (if (let ((__tmp303115 (thread-group-specific _tgroup197533_)))
              (declare (not safe))
              (##structure-direct-instance-of?
               __tmp303115
               'std/net/repl#repl-state::t))
            (thread-group-specific-set! _tgroup197533_ _state197528_)
            (error '"No tainted repl state in thread-group" _tgroup197533_)))))
  (define std/net/repl#untaint!__0
    (lambda ()
      (let* ((_tgroup197539_ '#f) (_state197541_ '#f))
        (std/net/repl#untaint!__% _tgroup197539_ _state197541_))))
  (define std/net/repl#untaint!__1
    (lambda (_tgroup197543_)
      (let ((_state197545_ '#f))
        (std/net/repl#untaint!__% _tgroup197543_ _state197545_))))
  (define std/net/repl#untaint!
    (lambda _g303117_
      (let ((_g303116_ (let () (declare (not safe)) (##length _g303117_))))
        (cond ((let () (declare (not safe)) (##fx= _g303116_ 0))
               (apply std/net/repl#untaint!__0 _g303117_))
              ((let () (declare (not safe)) (##fx= _g303116_ 1))
               (apply std/net/repl#untaint!__1 _g303117_))
              ((let () (declare (not safe)) (##fx= _g303116_ 2))
               (apply std/net/repl#untaint!__% _g303117_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/repl#untaint!
                _g303117_)))))))
