(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/socks#open-socks-client
    (lambda (_proxy172058_ _server172059_ _open172060_ _connect172061_)
      (let ((_sock172063_
             (open-tcp-client
              (std/net/address#inet-address->string
               (std/net/address#inet-address _proxy172058_)))))
        (with-exception-catcher
         (lambda (_e172065_)
           (with-exception-catcher void (lambda () (close-port _sock172063_)))
           (raise _e172065_))
         (lambda ()
           (_open172060_ _sock172063_)
           (_connect172061_ _sock172063_ _server172059_)
           _sock172063_)))))
  (define std/net/socks#open-socks4-client
    (lambda (_proxy172055_ _server172056_)
      (std/net/socks#open-socks-client
       _proxy172055_
       _server172056_
       void
       std/net/socks#socks4-connect)))
  (define std/net/socks#open-socks5-client
    (lambda (_proxy172052_ _server172053_)
      (std/net/socks#open-socks-client
       _proxy172052_
       _server172053_
       std/net/socks#socks5-open
       std/net/socks#socks5-connect)))
  (define std/net/socks#socks5-open
    (lambda (_sock172044_)
      (std/net/socks#send-msg _sock172044_ '#u8(5 1 0))
      (let ((_in172046_ (let () (declare (not safe)) (##make-u8vector '2 '0))))
        (std/net/socks#recv-msg _sock172044_ _in172046_)
        (let ((_proto172048_
               (let () (declare (not safe)) (##u8vector-ref _in172046_ '0))))
          (if (eq? _proto172048_ '5)
              '#!void
              (std/error#raise-io-error
               'socks5-open
               '"SOCKS5 handshake error; protocol version mismatch"
               _proto172048_)))
        (let ((_rep172050_
               (let () (declare (not safe)) (##u8vector-ref _in172046_ '1))))
          (if (eq? _rep172050_ '0)
              '#!void
              (std/error#raise-io-error
               'socks5-open
               '"SOCKS5 handshake error; negotiation failed"
               _rep172050_))))))
  (define std/net/socks#socks5-connect
    (lambda (_sock172041_ _address172042_)
      (std/net/socks#socks-connect
       std/net/socks#socks5-send-request
       std/net/socks#socks5-recv-reply
       _sock172041_
       _address172042_)))
  (define std/net/socks#socks5-bind__%
    (lambda (_sock172028_ _address172029_)
      (std/net/socks#socks-bind
       std/net/socks#socks5-send-request
       std/net/socks#socks5-recv-reply
       _sock172028_
       _address172029_)))
  (define std/net/socks#socks5-bind__0
    (lambda (_sock172034_)
      (let ((_address172036_ '#f))
        (std/net/socks#socks5-bind__% _sock172034_ _address172036_))))
  (define std/net/socks#socks5-bind
    (lambda _g300902_
      (let ((_g300901_ (let () (declare (not safe)) (##length _g300902_))))
        (cond ((let () (declare (not safe)) (##fx= _g300901_ 1))
               (apply std/net/socks#socks5-bind__0 _g300902_))
              ((let () (declare (not safe)) (##fx= _g300901_ 2))
               (apply std/net/socks#socks5-bind__% _g300902_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socks#socks5-bind
                _g300902_))))))
  (define std/net/socks#socks5-accept
    (lambda (_sock172025_) (std/net/socks#socks5-recv-reply _sock172025_)))
  (define std/net/socks#socks4-connect__%
    (lambda (_sock172009_ _address172010_ _userid172011_)
      (std/net/socks#socks-connect
       std/net/socks#socks4-send-request
       std/net/socks#socks4-recv-reply
       _sock172009_
       _address172010_
       _userid172011_)))
  (define std/net/socks#socks4-connect__0
    (lambda (_sock172016_ _address172017_)
      (let ((_userid172019_ '#f))
        (std/net/socks#socks4-connect__%
         _sock172016_
         _address172017_
         _userid172019_))))
  (define std/net/socks#socks4-connect
    (lambda _g300904_
      (let ((_g300903_ (let () (declare (not safe)) (##length _g300904_))))
        (cond ((let () (declare (not safe)) (##fx= _g300903_ 2))
               (apply std/net/socks#socks4-connect__0 _g300904_))
              ((let () (declare (not safe)) (##fx= _g300903_ 3))
               (apply std/net/socks#socks4-connect__% _g300904_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socks#socks4-connect
                _g300904_))))))
  (define std/net/socks#socks4-bind__%
    (lambda (_sock171986_ _address171987_ _userid171988_)
      (std/net/socks#socks-bind
       std/net/socks#socks4-send-request
       std/net/socks#socks4-recv-reply
       _sock171986_
       _address171987_
       _userid171988_)))
  (define std/net/socks#socks4-bind__0
    (lambda (_sock171993_)
      (let* ((_address171995_ '#f) (_userid171997_ '#f))
        (std/net/socks#socks4-bind__%
         _sock171993_
         _address171995_
         _userid171997_))))
  (define std/net/socks#socks4-bind__1
    (lambda (_sock171999_ _address172000_)
      (let ((_userid172002_ '#f))
        (std/net/socks#socks4-bind__%
         _sock171999_
         _address172000_
         _userid172002_))))
  (define std/net/socks#socks4-bind
    (lambda _g300906_
      (let ((_g300905_ (let () (declare (not safe)) (##length _g300906_))))
        (cond ((let () (declare (not safe)) (##fx= _g300905_ 1))
               (apply std/net/socks#socks4-bind__0 _g300906_))
              ((let () (declare (not safe)) (##fx= _g300905_ 2))
               (apply std/net/socks#socks4-bind__1 _g300906_))
              ((let () (declare (not safe)) (##fx= _g300905_ 3))
               (apply std/net/socks#socks4-bind__% _g300906_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socks#socks4-bind
                _g300906_))))))
  (define std/net/socks#socks4-accept
    (lambda (_sock171983_) (std/net/socks#socks4-recv-reply _sock171983_)))
  (define std/net/socks#socks-connect
    (lambda (_send171974_
             _recv171975_
             _sock171976_
             _address171977_
             .
             _args171978_)
      (let ((_g300907_ (std/net/socks#parse-address _address171977_)))
        (begin
          (let ((_g300908_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g300907_) (##vector-length _g300907_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g300908_ 2)))
                (error "Context expects 2 values" _g300908_)))
          (let ((_host171980_
                 (let () (declare (not safe)) (##vector-ref _g300907_ 0)))
                (_port171981_
                 (let () (declare (not safe)) (##vector-ref _g300907_ 1))))
            (apply _send171974_
                   _sock171976_
                   '1
                   _host171980_
                   _port171981_
                   _args171978_))))
      (_recv171975_ _sock171976_)))
  (define std/net/socks#socks-bind
    (lambda (_send171965_
             _recv171966_
             _sock171967_
             _address171968_
             .
             _args171969_)
      (let ((_g300909_
             (if _address171968_
                 (std/net/socks#parse-address _address171968_)
                 (values '#u8(0 0 0 0) '0))))
        (begin
          (let ((_g300910_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g300909_) (##vector-length _g300909_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g300910_ 2)))
                (error "Context expects 2 values" _g300910_)))
          (let ((_host171971_
                 (let () (declare (not safe)) (##vector-ref _g300909_ 0)))
                (_port171972_
                 (let () (declare (not safe)) (##vector-ref _g300909_ 1))))
            (begin
              (apply _send171965_
                     _sock171967_
                     '2
                     _host171971_
                     _port171972_
                     _args171969_)
              (_recv171966_ _sock171967_)))))))
  (define std/net/socks#parse-address
    (lambda (_addr171935_)
      (let* ((_g171936171943_ (std/net/address#inet-address _addr171935_))
             (_E171938171947_
              (lambda () (error '"No clause matching" _g171936171943_)))
             (_K171939171953_
              (lambda (_port171950_ _host171951_)
                (values _host171951_ _port171950_))))
        (if (let () (declare (not safe)) (##pair? _g171936171943_))
            (let ((_hd171940171956_
                   (let () (declare (not safe)) (##car _g171936171943_)))
                  (_tl171941171958_
                   (let () (declare (not safe)) (##cdr _g171936171943_))))
              (let* ((_host171961_ _hd171940171956_)
                     (_port171963_ _tl171941171958_))
                (_K171939171953_ _port171963_ _host171961_)))
            (_E171938171947_)))))
  (define std/net/socks#socks5-send-request
    (lambda (_sock171909_ _cmd171910_ _host171911_ _port171912_)
      (let* ((_porthi171914_
              (let ((__tmp300911
                     (let ()
                       (declare (not safe))
                       (##fxarithmetic-shift _port171912_ '-8))))
                (declare (not safe))
                (##fxand __tmp300911 '255)))
             (_portlo171916_
              (let () (declare (not safe)) (##fxand _port171912_ '255)))
             (_out171932_
              (if (string? _host171911_)
                  (let* ((_fqdn171918_
                          (std/text/utf8#string->utf8__0 _host171911_))
                         (_fqdnlen171920_
                          (let ()
                            (declare (not safe))
                            (##u8vector-length _fqdn171918_)))
                         (_g300912_
                          (if (let ()
                                (declare (not safe))
                                (##fx> _fqdnlen171920_ '255))
                              (error '"Domain name too long"
                                     _host171911_
                                     _fqdnlen171920_)
                              '#!void))
                         (_len171923_
                          (let ()
                            (declare (not safe))
                            (##fx+ '7 _fqdnlen171920_)))
                         (_out171925_
                          (let ()
                            (declare (not safe))
                            (##make-u8vector _len171923_ '0))))
                    (let ()
                      (declare (not safe))
                      (##u8vector-set! _out171925_ '3 '3))
                    (let ()
                      (declare (not safe))
                      (##u8vector-set! _out171925_ '4 _fqdnlen171920_))
                    (let ()
                      (declare (not safe))
                      (##subu8vector-move!
                       _fqdn171918_
                       '0
                       _fqdnlen171920_
                       _out171925_
                       '5))
                    (let ((__tmp300913
                           (let ()
                             (declare (not safe))
                             (##fx+ _fqdnlen171920_ '5))))
                      (declare (not safe))
                      (##u8vector-set! _out171925_ __tmp300913 _porthi171914_))
                    (let ((__tmp300914
                           (let ()
                             (declare (not safe))
                             (##fx+ _fqdnlen171920_ '6))))
                      (declare (not safe))
                      (##u8vector-set!
                       _out171925_
                       __tmp300914
                       _portlo171916_)))
                  (if (and (let ()
                             (declare (not safe))
                             (##u8vector? _host171911_))
                           (let ((__tmp300915
                                  (let ()
                                    (declare (not safe))
                                    (##u8vector-length _host171911_))))
                             (declare (not safe))
                             (##fx= __tmp300915 '4)))
                      (let ((_out171928_
                             (let ()
                               (declare (not safe))
                               (##make-u8vector '10 '0))))
                        (let ()
                          (declare (not safe))
                          (##u8vector-set! _out171928_ '3 '1))
                        (let ()
                          (declare (not safe))
                          (##subu8vector-move!
                           _host171911_
                           '0
                           '4
                           _out171928_
                           '4))
                        (let ()
                          (declare (not safe))
                          (##u8vector-set! _out171928_ '8 _porthi171914_))
                        (let ()
                          (declare (not safe))
                          (##u8vector-set! _out171928_ '9 _portlo171916_)))
                      (if (and (let ()
                                 (declare (not safe))
                                 (##u8vector? _host171911_))
                               (let ((__tmp300916
                                      (let ()
                                        (declare (not safe))
                                        (##u8vector-length _host171911_))))
                                 (declare (not safe))
                                 (##fx= __tmp300916 '16)))
                          (let ((_out171930_
                                 (let ()
                                   (declare (not safe))
                                   (##make-u8vector '22 '0))))
                            (let ()
                              (declare (not safe))
                              (##u8vector-set! _out171930_ '3 '4))
                            (let ()
                              (declare (not safe))
                              (##subu8vector-move!
                               _host171911_
                               '0
                               '4
                               _out171930_
                               '16))
                            (let ()
                              (declare (not safe))
                              (##u8vector-set! _out171930_ '20 _porthi171914_))
                            (let ()
                              (declare (not safe))
                              (##u8vector-set!
                               _out171930_
                               '21
                               _portlo171916_)))
                          (error '"Unexpected host address" _host171911_))))))
        (let () (declare (not safe)) (##u8vector-set! _out171932_ '0 '5))
        (let ()
          (declare (not safe))
          (##u8vector-set! _out171932_ '1 _cmd171910_))
        (std/net/socks#send-msg _sock171909_ _out171932_))))
  (define std/net/socks#socks5-recv-reply
    (lambda (_sock171879_)
      (letrec ((_recv-port171881_
                (lambda ()
                  (let* ((_porthi171904_
                          (let ()
                            (declare (not safe))
                            (##read-u8 _sock171879_)))
                         (_portlo171906_
                          (let ()
                            (declare (not safe))
                            (##read-u8 _sock171879_))))
                    (let ((__tmp300917
                           (let ()
                             (declare (not safe))
                             (##fxarithmetic-shift _porthi171904_ '8))))
                      (declare (not safe))
                      (##fxior __tmp300917 _portlo171906_)))))
               (_recv-address171882_
                (lambda (_atype171891_ _rep171892_)
                  (let ((_$e171894_ _atype171891_))
                    (if (eq? '1 _$e171894_)
                        (let ((_addr171897_
                               (let ()
                                 (declare (not safe))
                                 (##make-u8vector '4 '0))))
                          (std/net/socks#recv-msg _sock171879_ _addr171897_)
                          (cons _addr171897_ (_recv-port171881_)))
                        (if (eq? '3 _$e171894_)
                            (let ((_buf171899_
                                   (let ((__tmp300918
                                          (let ()
                                            (declare (not safe))
                                            (##read-u8 _sock171879_))))
                                     (declare (not safe))
                                     (##make-u8vector __tmp300918 '0))))
                              (std/net/socks#recv-msg _sock171879_ _buf171899_)
                              (cons (std/text/utf8#utf8->string__0 _buf171899_)
                                    (_recv-port171881_)))
                            (if (eq? '4 _$e171894_)
                                (let ((_addr171901_
                                       (let ()
                                         (declare (not safe))
                                         (##make-u8vector '16 '0))))
                                  (std/net/socks#recv-msg
                                   _sock171879_
                                   _addr171901_)
                                  (cons _addr171901_ (_recv-port171881_)))
                                (std/error#raise-io-error
                                 'socks5-recv-reply
                                 '"Unexpected SOCKS5 address type"
                                 _atype171891_
                                 _rep171892_))))))))
        (let ((_hdr171884_
               (let () (declare (not safe)) (##make-u8vector '4 '0))))
          (std/net/socks#recv-msg _sock171879_ _hdr171884_)
          (let ((_proto171886_
                 (let () (declare (not safe)) (##u8vector-ref _hdr171884_ '0)))
                (_rep171887_
                 (let ()
                   (declare (not safe))
                   (##u8vector-ref _hdr171884_ '1))))
            (if (eq? _proto171886_ '5)
                '#!void
                (std/error#raise-io-error
                 'socks5-recv-reply
                 '"Unexpected SOCKS5 reply; protocol mismatch"
                 _proto171886_))
            (let ((_addr171889_
                   (_recv-address171882_
                    (let ()
                      (declare (not safe))
                      (##u8vector-ref _hdr171884_ '3))
                    _rep171887_)))
              (if (eq? _rep171887_ '0)
                  _addr171889_
                  (std/error#raise-io-error
                   'socks5-recv-reply
                   '"SOCKS5 error response"
                   _rep171887_))))))))
  (define std/net/socks#socks4-send-request
    (lambda (_sock171848_ _cmd171849_ _host171850_ _port171851_ _userid171852_)
      (let* ((_porthi171854_
              (let ((__tmp300919
                     (let ()
                       (declare (not safe))
                       (##fxarithmetic-shift _port171851_ '-8))))
                (declare (not safe))
                (##fxand __tmp300919 '255)))
             (_portlo171856_
              (let () (declare (not safe)) (##fxand _port171851_ '255)))
             (_userid171858_
              (if _userid171852_
                  (std/text/utf8#string->utf8__0 _userid171852_)
                  '#f))
             (_userlen171860_
              (if _userid171858_
                  (let ()
                    (declare (not safe))
                    (##u8vector-length _userid171858_))
                  '0))
             (_out171876_
              (if (string? _host171850_)
                  (let* ((_fqdn171862_
                          (std/text/utf8#string->utf8__0 _host171850_))
                         (_fqdnlen171864_
                          (let ()
                            (declare (not safe))
                            (##u8vector-length _fqdn171862_)))
                         (_len171866_
                          (let ()
                            (declare (not safe))
                            (##fx+ '8 _userlen171860_ '1 _fqdnlen171864_ '1)))
                         (_out171868_
                          (let ()
                            (declare (not safe))
                            (##make-u8vector _len171866_ '0))))
                    (let ()
                      (declare (not safe))
                      (##u8vector-set! _out171868_ '7 '1))
                    (let ((__tmp300920
                           (let ()
                             (declare (not safe))
                             (##fx+ _userlen171860_ '9))))
                      (declare (not safe))
                      (##subu8vector-move!
                       _fqdn171862_
                       '0
                       _fqdnlen171864_
                       _out171868_
                       __tmp300920)))
                  (if (and (let ()
                             (declare (not safe))
                             (##u8vector? _host171850_))
                           (let ((__tmp300921
                                  (let ()
                                    (declare (not safe))
                                    (##u8vector-length _host171850_))))
                             (declare (not safe))
                             (##fx= __tmp300921 '4)))
                      (let* ((_len171871_
                              (let ()
                                (declare (not safe))
                                (##fx+ _userlen171860_ '9)))
                             (_out171873_
                              (let ()
                                (declare (not safe))
                                (##make-u8vector _len171871_ '0))))
                        (let ()
                          (declare (not safe))
                          (##subu8vector-move!
                           _host171850_
                           '0
                           '4
                           _out171873_
                           '4)))
                      (error '"Unexpected host address" _host171850_)))))
        (let () (declare (not safe)) (##u8vector-set! _out171876_ '0 '4))
        (let ()
          (declare (not safe))
          (##u8vector-set! _out171876_ '1 _cmd171849_))
        (let ()
          (declare (not safe))
          (##u8vector-set! _out171876_ '2 _porthi171854_))
        (let ()
          (declare (not safe))
          (##u8vector-set! _out171876_ '3 _portlo171856_))
        (if _userid171858_
            (let ()
              (declare (not safe))
              (##subu8vector-move!
               _userid171858_
               '0
               _userlen171860_
               _out171876_
               '8))
            '#!void)
        (std/net/socks#send-msg _sock171848_ _out171876_))))
  (define std/net/socks#socks4-recv-reply
    (lambda (_sock171840_)
      (let ((_buf171842_
             (let () (declare (not safe)) (##make-u8vector '8 '0))))
        (std/net/socks#recv-msg _sock171840_ _buf171842_)
        (let ((_vn171844_
               (let () (declare (not safe)) (##u8vector-ref _buf171842_ '0))))
          (if (eq? _vn171844_ '0)
              '#!void
              (std/error#raise-io-error
               'socks4-recv-reply
               '"Unexpected SOCKS4 reply; version mismatch"
               _vn171844_)))
        (let ((_rep171846_
               (let () (declare (not safe)) (##u8vector-ref _buf171842_ '1))))
          (if (eq? _rep171846_ '90)
              '#!void
              (std/error#raise-io-error
               'socks4-recv-reply
               '"SOCKS4 request rejected"
               _rep171846_)))
        (cons (let () (declare (not safe)) (##subu8vector _buf171842_ '4 '8))
              (let ((__tmp300923
                     (let ((__tmp300924
                            (let ()
                              (declare (not safe))
                              (##u8vector-ref _buf171842_ '2))))
                       (declare (not safe))
                       (##fxarithmetic-shift __tmp300924 '8)))
                    (__tmp300922
                     (let ()
                       (declare (not safe))
                       (##u8vector-ref _buf171842_ '3))))
                (declare (not safe))
                (##fxior __tmp300923 __tmp300922))))))
  (define std/net/socks#send-msg
    (lambda (_sock171835_ _buf171836_)
      (let ((_wr171838_
             (gerbil/gambit/ports#write-u8vector__% _buf171836_ _sock171835_)))
        (if (eq? _wr171838_
                 (let () (declare (not safe)) (##u8vector-length _buf171836_)))
            '#!void
            (std/error#raise-io-error
             'socks-send-message
             '"Failed to send message; incomplete write"
             _sock171835_
             _wr171838_))
        (force-output _sock171835_))))
  (define std/net/socks#recv-msg
    (lambda (_sock171830_ _buf171831_)
      (let ((_rd171833_
             (gerbil/gambit/ports#read-u8vector__% _buf171831_ _sock171830_)))
        (if (eq? _rd171833_
                 (let () (declare (not safe)) (##u8vector-length _buf171831_)))
            '#!void
            (std/error#raise-io-error
             'socks-recv-message
             '"Failed to receive message; incomplete read"
             _sock171830_
             _rd171833_))))))
