(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (fixnum) (not safe))
  (define std/sort#sort
    (lambda (_seq7647_ _elt<7649_)
      (if (procedure? _elt<7649_)
          '#!void
          (error '"Expected procedure" _elt<7649_))
      (if (null? _seq7647_)
          _seq7647_
          (if (pair? _seq7647_)
              (std/sort#list-merge-sort _seq7647_ _elt<7649_)
              (if (vector? _seq7647_)
                  (std/sort#heap-sort _seq7647_ _elt<7649_)
                  (error '"Expected list or vector" _seq7647_))))))
  (define std/sort#sort!
    (lambda (_seq7642_ _elt<7644_)
      (if (procedure? _elt<7644_)
          '#!void
          (error '"Expected procedure" _elt<7644_))
      (if (null? _seq7642_)
          _seq7642_
          (if (pair? _seq7642_)
              (std/sort#list-merge-sort! _seq7642_ _elt<7644_)
              (if (vector? _seq7642_)
                  (std/sort#vector-heap-sort! _seq7642_ _elt<7644_)
                  (error '"Expected list or vector" _seq7642_))))))
  (define std/sort#stable-sort
    (lambda (_seq7637_ _elt<7639_)
      (if (procedure? _elt<7639_)
          '#!void
          (error '"Expected procedure" _elt<7639_))
      (if (null? _seq7637_)
          _seq7637_
          (if (pair? _seq7637_)
              (std/sort#list-merge-sort _seq7637_ _elt<7639_)
              (if (vector? _seq7637_)
                  (std/sort#vector-merge-sort _seq7637_ _elt<7639_)
                  (error '"Expected list or vector" _seq7637_))))))
  (define std/sort#stable-sort!
    (lambda (_seq7632_ _elt<7634_)
      (if (procedure? _elt<7634_)
          '#!void
          (error '"Expected procedure" _elt<7634_))
      (if (null? _seq7632_)
          _seq7632_
          (if (pair? _seq7632_)
              (std/sort#list-merge-sort! _seq7632_ _elt<7634_)
              (if (vector? _seq7632_)
                  (std/sort#vector-merge-sort! _seq7632_ _elt<7634_)
                  (error '"Expected list or vector" _seq7632_))))))
  (define std/sort#vector-copy!
    (lambda (_target7627_ _src7628_ _start7629_ _end7630_)
      (subvector-move! _src7628_ _start7629_ _end7630_ _target7627_ '0)))
  (define std/sort#vector-merge-sort!
    (lambda (_v7624_ _elt<7625_)
      (std/sort#%vector-merge-sort!
       _v7624_
       _elt<7625_
       '0
       (vector-length _v7624_)
       (vector-copy _v7624_))
      _v7624_))
  (define std/sort#vector-merge-sort
    (lambda (_v7621_ _elt<7622_)
      (std/sort#vector-merge-sort! (vector-copy _v7621_) _elt<7622_)))
  (define std/sort#vector-heap-sort!
    (lambda (_v7618_ _elt<7619_)
      (std/sort#heap-sort! _v7618_ _elt<7619_)
      _v7618_))
  (define std/sort#parse-vector-start+end
    (lambda (_proc7597_ _v7598_ _args7599_)
      (let ((_vlen7601_ (vector-length _v7598_)))
        (if (pair? _args7599_)
            (let ((_start7603_ (car _args7599_)) (_args7604_ (cdr _args7599_)))
              (if (or (not (integer? _start7603_)) (< _start7603_ '0))
                  (error '"Illegal subvector START spec"
                         _proc7597_
                         _start7603_
                         _v7598_)
                  (let ((_g281459_
                         (if (pair? _args7604_)
                             (let ((_end7609_ (car _args7604_))
                                   (_args7610_ (cdr _args7604_)))
                               (if (or (not (integer? _end7609_))
                                       (< _vlen7601_ _end7609_))
                                   (error '"Illegal subvector END spec"
                                          _proc7597_
                                          _end7609_
                                          _v7598_)
                                   (values _end7609_ _args7610_)))
                             (values _vlen7601_ _args7604_))))
                    (begin
                      (let ((_g281460_
                             (if (##values? _g281459_)
                                 (##vector-length _g281459_)
                                 1)))
                        (if (not (##fx= _g281460_ 2))
                            (error "Context expects 2 values" _g281460_)))
                      (let ((_end7615_ (##vector-ref _g281459_ 0))
                            (_args7616_ (##vector-ref _g281459_ 1)))
                        (if (<= _start7603_ _end7615_)
                            (values _start7603_ _end7615_ _args7616_)
                            (error '"Illegal subvector START/END spec"
                                   _proc7597_
                                   _start7603_
                                   _end7615_
                                   _v7598_)))))))
            (values '0 (vector-length _v7598_) '())))))
  (define std/sort#parse-vector-final-start+end
    (lambda (_proc7589_ _v7590_ _args7591_)
      (let ((_g281461_
             (std/sort#parse-vector-start+end _proc7589_ _v7590_ _args7591_)))
        (begin
          (let ((_g281462_
                 (if (##values? _g281461_) (##vector-length _g281461_) 1)))
            (if (not (##fx= _g281462_ 3))
                (error "Context expects 3 values" _g281462_)))
          (let ((_start7593_ (##vector-ref _g281461_ 0))
                (_end7594_ (##vector-ref _g281461_ 1))
                (_rest7595_ (##vector-ref _g281461_ 2)))
            (if (pair? _rest7595_)
                (error '"Extra arguments to procedure" _proc7589_ _rest7595_)
                (values _start7593_ _end7594_)))))))
  (define std/sort#list-merge-sort
    (lambda (_lis7513_ _elt<7514_)
      (letrec ((_getrun7516_
                (lambda (_lis7579_)
                  (let _lp7581_ ((_xs7583_ (cdr _lis7579_))
                                 (_prev7584_ (car _lis7579_))
                                 (_i7585_ '1))
                    (if (pair? _xs7583_)
                        (let ((_x7587_ (car _xs7583_)))
                          (if (_elt<7514_ _x7587_ _prev7584_)
                              (values _i7585_ _xs7583_)
                              (_lp7581_
                               (cdr _xs7583_)
                               _x7587_
                               (+ _i7585_ '1))))
                        (values _i7585_ _xs7583_)))))
               (_cmerge7517_
                (lambda (_a7557_ _la7558_ _b7559_ _lb7560_)
                  (let _recur7562_ ((_x7564_ (car _a7557_))
                                    (_a7565_ _a7557_)
                                    (_la7566_ _la7558_)
                                    (_y7567_ (car _b7559_))
                                    (_b7568_ _b7559_)
                                    (_lb7569_ _lb7560_))
                    (if (_elt<7514_ _y7567_ _x7564_)
                        (cons _y7567_
                              (let ((_lb7571_ (- _lb7569_ '1)))
                                (if (= _lb7571_ '0)
                                    _a7565_
                                    (let ((_b7573_ (cdr _b7568_)))
                                      (_recur7562_
                                       _x7564_
                                       _a7565_
                                       _la7566_
                                       (car _b7573_)
                                       _b7573_
                                       _lb7571_)))))
                        (cons _x7564_
                              (let ((_la7575_ (- _la7566_ '1)))
                                (if (= _la7575_ '0)
                                    _b7568_
                                    (let ((_a7577_ (cdr _a7565_)))
                                      (_recur7562_
                                       (car _a7577_)
                                       _a7577_
                                       _la7575_
                                       _y7567_
                                       _b7568_
                                       _lb7569_)))))))))
               (_grow7518_
                (lambda (_s7533_ _ls7534_ _ls27535_ _u7536_ _lw7537_)
                  (if (or (<= _lw7537_ _ls7534_) (not (pair? _u7536_)))
                      (values _s7533_ _ls7534_ _u7536_)
                      (let* ((_ls27548_
                              (let _lp7542_ ((_ls27544_ _ls27535_))
                                (let ((_ls2*27546_ (+ _ls27544_ _ls27544_)))
                                  (if (<= _ls2*27546_ _ls7534_)
                                      (_lp7542_ _ls2*27546_)
                                      _ls27544_))))
                             (_g281463_ (_getrun7516_ _u7536_)))
                        (begin
                          (let ((_g281464_
                                 (if (##values? _g281463_)
                                     (##vector-length _g281463_)
                                     1)))
                            (if (not (##fx= _g281464_ 2))
                                (error "Context expects 2 values" _g281464_)))
                          (let ((_lr7550_ (##vector-ref _g281463_ 0))
                                (_u27551_ (##vector-ref _g281463_ 1)))
                            (let ((_g281465_
                                   (_grow7518_
                                    _u7536_
                                    _lr7550_
                                    '1
                                    _u27551_
                                    _ls27548_)))
                              (begin
                                (let ((_g281466_
                                       (if (##values? _g281465_)
                                           (##vector-length _g281465_)
                                           1)))
                                  (if (not (##fx= _g281466_ 3))
                                      (error "Context expects 3 values"
                                             _g281466_)))
                                (let ((_t7553_ (##vector-ref _g281465_ 0))
                                      (_lt7554_ (##vector-ref _g281465_ 1))
                                      (_u37555_ (##vector-ref _g281465_ 2)))
                                  (_grow7518_
                                   (_cmerge7517_
                                    _s7533_
                                    _ls7534_
                                    _t7553_
                                    _lt7554_)
                                   (+ _ls7534_ _lt7554_)
                                   (+ _ls27548_ _ls27548_)
                                   _u37555_
                                   _lw7537_))))))))))
               (_first7519_
                (lambda (_lis7530_ _i7531_)
                  (if (= '0 _i7531_)
                      '()
                      (cons (car _lis7530_)
                            (_first7519_ (cdr _lis7530_) (- _i7531_ '1)))))))
        (if (not (pair? _lis7513_))
            '()
            (let ((_g281467_ (_getrun7516_ _lis7513_)))
              (begin
                (let ((_g281468_
                       (if (##values? _g281467_)
                           (##vector-length _g281467_)
                           1)))
                  (if (not (##fx= _g281468_ 2))
                      (error "Context expects 2 values" _g281468_)))
                (let ((_lr7521_ (##vector-ref _g281467_ 0))
                      (_tail7522_ (##vector-ref _g281467_ 1)))
                  (let* ((_infinity7524_ '16777216)
                         (_g281469_
                          (_grow7518_
                           _lis7513_
                           _lr7521_
                           '1
                           _tail7522_
                           _infinity7524_)))
                    (begin
                      (let ((_g281470_
                             (if (##values? _g281469_)
                                 (##vector-length _g281469_)
                                 1)))
                        (if (not (##fx= _g281470_ 3))
                            (error "Context expects 3 values" _g281470_)))
                      (let ((_a7526_ (##vector-ref _g281469_ 0))
                            (_la7527_ (##vector-ref _g281469_ 1))
                            (_v7528_ (##vector-ref _g281469_ 2)))
                        (_first7519_ _a7526_ _la7527_)))))))))))
  (define std/sort#list-merge-sort!
    (lambda (_lis7418_ _elt<7419_)
      (letrec ((_getrun7421_
                (lambda (_lis7502_)
                  (let _lp7504_ ((_lis7506_ _lis7502_)
                                 (_x7507_ (car _lis7502_))
                                 (_i7508_ '1)
                                 (_next7509_ (cdr _lis7502_)))
                    (if (pair? _next7509_)
                        (let ((_y7511_ (car _next7509_)))
                          (if (_elt<7419_ _y7511_ _x7507_)
                              (values _i7508_ _lis7506_ _next7509_)
                              (_lp7504_
                               _next7509_
                               _y7511_
                               (+ _i7508_ '1)
                               (cdr _next7509_))))
                        (values _i7508_ _lis7506_ _next7509_)))))
               (_merge!7422_
                (lambda (_a7463_ _enda7464_ _b7465_ _endb7466_)
                  (letrec ((_scan-a7468_
                            (lambda (_prev7472_
                                     _x7473_
                                     _a7474_
                                     _y7475_
                                     _b7476_)
                              (if (_elt<7419_ _y7475_ _x7473_)
                                  (begin
                                    (set-cdr! _prev7472_ _b7476_)
                                    (let ((_next-b7478_ (cdr _b7476_)))
                                      (if (eq? _b7476_ _endb7466_)
                                          (begin
                                            (set-cdr! _b7476_ _a7474_)
                                            _enda7464_)
                                          (_scan-b7469_
                                           _b7476_
                                           _x7473_
                                           _a7474_
                                           (car _next-b7478_)
                                           _next-b7478_))))
                                  (if (eq? _a7474_ _enda7464_)
                                      (begin
                                        (_maybe-set-cdr!7470_ _a7474_ _b7476_)
                                        _endb7466_)
                                      (let ((_next-a7480_ (cdr _a7474_)))
                                        (_scan-a7468_
                                         _a7474_
                                         (car _next-a7480_)
                                         _next-a7480_
                                         _y7475_
                                         _b7476_))))))
                           (_scan-b7469_
                            (lambda (_prev7482_
                                     _x7483_
                                     _a7484_
                                     _y7485_
                                     _b7486_)
                              (if (_elt<7419_ _y7485_ _x7483_)
                                  (if (eq? _b7486_ _endb7466_)
                                      (begin
                                        (set-cdr! _b7486_ _a7484_)
                                        _enda7464_)
                                      (let ((_next-b7488_ (cdr _b7486_)))
                                        (_scan-b7469_
                                         _b7486_
                                         _x7483_
                                         _a7484_
                                         (car _next-b7488_)
                                         _next-b7488_)))
                                  (begin
                                    (set-cdr! _prev7482_ _a7484_)
                                    (if (eq? _a7484_ _enda7464_)
                                        (begin
                                          (_maybe-set-cdr!7470_
                                           _a7484_
                                           _b7486_)
                                          _endb7466_)
                                        (let ((_next-a7490_ (cdr _a7484_)))
                                          (_scan-a7468_
                                           _a7484_
                                           (car _next-a7490_)
                                           _next-a7490_
                                           _y7485_
                                           _b7486_)))))))
                           (_maybe-set-cdr!7470_
                            (lambda (_pair7492_ _val7493_)
                              (if (not (eq? (cdr _pair7492_) _val7493_))
                                  (set-cdr! _pair7492_ _val7493_)
                                  '#!void))))
                    (let ((_x7495_ (car _a7463_)) (_y7496_ (car _b7465_)))
                      (if (_elt<7419_ _y7496_ _x7495_)
                          (values _b7465_
                                  (if (eq? _b7465_ _endb7466_)
                                      (begin
                                        (set-cdr! _b7465_ _a7463_)
                                        _enda7464_)
                                      (let ((_next-b7498_ (cdr _b7465_)))
                                        (_scan-b7469_
                                         _b7465_
                                         _x7495_
                                         _a7463_
                                         (car _next-b7498_)
                                         _next-b7498_))))
                          (values _a7463_
                                  (if (eq? _a7463_ _enda7464_)
                                      (begin
                                        (_maybe-set-cdr!7470_ _a7463_ _b7465_)
                                        _endb7466_)
                                      (let ((_next-a7500_ (cdr _a7463_)))
                                        (_scan-a7468_
                                         _a7463_
                                         (car _next-a7500_)
                                         _next-a7500_
                                         _y7496_
                                         _b7465_)))))))))
               (_grow7423_
                (lambda (_s7436_
                         _ends7437_
                         _ls7438_
                         _ls27439_
                         _u7440_
                         _lw7441_)
                  (if (and (pair? _u7440_) (< _ls7438_ _lw7441_))
                      (let* ((_ls27449_
                              (let _lp7443_ ((_ls27445_ _ls27439_))
                                (let ((_ls2*27447_ (+ _ls27445_ _ls27445_)))
                                  (if (<= _ls2*27447_ _ls7438_)
                                      (_lp7443_ _ls2*27447_)
                                      _ls27445_))))
                             (_g281471_ (_getrun7421_ _u7440_)))
                        (begin
                          (let ((_g281472_
                                 (if (##values? _g281471_)
                                     (##vector-length _g281471_)
                                     1)))
                            (if (not (##fx= _g281472_ 3))
                                (error "Context expects 3 values" _g281472_)))
                          (let ((_lr7451_ (##vector-ref _g281471_ 0))
                                (_endr7452_ (##vector-ref _g281471_ 1))
                                (_u27453_ (##vector-ref _g281471_ 2)))
                            (let ((_g281473_
                                   (_grow7423_
                                    _u7440_
                                    _endr7452_
                                    _lr7451_
                                    '1
                                    _u27453_
                                    _ls27449_)))
                              (begin
                                (let ((_g281474_
                                       (if (##values? _g281473_)
                                           (##vector-length _g281473_)
                                           1)))
                                  (if (not (##fx= _g281474_ 4))
                                      (error "Context expects 4 values"
                                             _g281474_)))
                                (let ((_t7455_ (##vector-ref _g281473_ 0))
                                      (_endt7456_ (##vector-ref _g281473_ 1))
                                      (_lt7457_ (##vector-ref _g281473_ 2))
                                      (_u37458_ (##vector-ref _g281473_ 3)))
                                  (let ((_g281475_
                                         (_merge!7422_
                                          _s7436_
                                          _ends7437_
                                          _t7455_
                                          _endt7456_)))
                                    (begin
                                      (let ((_g281476_
                                             (if (##values? _g281475_)
                                                 (##vector-length _g281475_)
                                                 1)))
                                        (if (not (##fx= _g281476_ 2))
                                            (error "Context expects 2 values"
                                                   _g281476_)))
                                      (let ((_st7460_
                                             (##vector-ref _g281475_ 0))
                                            (_end-st7461_
                                             (##vector-ref _g281475_ 1)))
                                        (_grow7423_
                                         _st7460_
                                         _end-st7461_
                                         (+ _ls7438_ _lt7457_)
                                         (+ _ls27449_ _ls27449_)
                                         _u37458_
                                         _lw7441_))))))))))
                      (values _s7436_ _ends7437_ _ls7438_ _u7440_)))))
        (if (pair? _lis7418_)
            (let ((_g281477_ (_getrun7421_ _lis7418_)))
              (begin
                (let ((_g281478_
                       (if (##values? _g281477_)
                           (##vector-length _g281477_)
                           1)))
                  (if (not (##fx= _g281478_ 3))
                      (error "Context expects 3 values" _g281478_)))
                (let ((_lr7425_ (##vector-ref _g281477_ 0))
                      (_endr7426_ (##vector-ref _g281477_ 1))
                      (_rest7427_ (##vector-ref _g281477_ 2)))
                  (let* ((_infinity7429_ '16777216)
                         (_g281479_
                          (_grow7423_
                           _lis7418_
                           _endr7426_
                           _lr7425_
                           '1
                           _rest7427_
                           _infinity7429_)))
                    (begin
                      (let ((_g281480_
                             (if (##values? _g281479_)
                                 (##vector-length _g281479_)
                                 1)))
                        (if (not (##fx= _g281480_ 4))
                            (error "Context expects 4 values" _g281480_)))
                      (let ((_a7431_ (##vector-ref _g281479_ 0))
                            (_enda7432_ (##vector-ref _g281479_ 1))
                            (_la7433_ (##vector-ref _g281479_ 2))
                            (_v7434_ (##vector-ref _g281479_ 3)))
                        (begin (set-cdr! _enda7432_ '()) _a7431_)))))))
            '()))))
  (define std/sort#really-heap-sort!
    (lambda (_v7369_ _elt<7370_ _start7371_ _end7372_)
      (letrec ((_restore-heap!7374_
                (lambda (_end7390_ _i7391_)
                  (let* ((_vi7393_ (vector-ref _v7369_ _i7391_))
                         (_first-leaf7395_
                          (quotient (+ _start7371_ _end7390_) '2))
                         (_final-k7415_
                          (let _lp7397_ ((_k7399_ _i7391_))
                            (if (>= _k7399_ _first-leaf7395_)
                                _k7399_
                                (let* ((_k*2-start7401_
                                        (+ _k7399_ (- _k7399_ _start7371_)))
                                       (_child17403_ (+ '1 _k*2-start7401_))
                                       (_child27405_ (+ '2 _k*2-start7401_))
                                       (_child1-val7407_
                                        (vector-ref _v7369_ _child17403_)))
                                  (let ((_g281481_
                                         (if (< _child27405_ _end7390_)
                                             (let ((_child2-val7410_
                                                    (vector-ref
                                                     _v7369_
                                                     _child27405_)))
                                               (if (_elt<7370_
                                                    _child2-val7410_
                                                    _child1-val7407_)
                                                   (values _child17403_
                                                           _child1-val7407_)
                                                   (values _child27405_
                                                           _child2-val7410_)))
                                             (values _child17403_
                                                     _child1-val7407_))))
                                    (begin
                                      #!void
                                      (let ((_max-child7412_
                                             (##vector-ref _g281481_ 0))
                                            (_max-child-val7413_
                                             (##vector-ref _g281481_ 1)))
                                        (if (_elt<7370_
                                             _vi7393_
                                             _max-child-val7413_)
                                            (begin
                                              (vector-set!
                                               _v7369_
                                               _k7399_
                                               _max-child-val7413_)
                                              (_lp7397_ _max-child7412_))
                                            _k7399_)))))))))
                    (vector-set! _v7369_ _final-k7415_ _vi7393_)))))
        (let ((_first-leaf7376_ (quotient (+ _start7371_ _end7372_) '2)))
          (let _$loop7378_ ((_i7381_ (- _first-leaf7376_ '1)))
            (if (< _i7381_ '0)
                '#!void
                (begin
                  (_restore-heap!7374_ _end7372_ _i7381_)
                  (_$loop7378_ (- _i7381_ '1))))))
        (let _$loop7383_ ((_i7386_ (- _end7372_ '1)))
          (if (<= _i7386_ '0)
              '#!void
              (begin
                (let ((_top7388_ (vector-ref _v7369_ _start7371_)))
                  (vector-set!
                   _v7369_
                   _start7371_
                   (vector-ref _v7369_ _i7386_))
                  (vector-set! _v7369_ _i7386_ _top7388_)
                  (_restore-heap!7374_ _i7386_ _start7371_))
                (_$loop7383_ (- _i7386_ '1))))))))
  (define std/sort#heap-sort!
    (lambda (_v7362_ _elt<7363_ . _maybe-start+end7364_)
      (let ((_g281482_
             (std/sort#parse-vector-final-start+end
              std/sort#heap-sort!
              _v7362_
              _maybe-start+end7364_)))
        (begin
          (let ((_g281483_
                 (if (##values? _g281482_) (##vector-length _g281482_) 1)))
            (if (not (##fx= _g281483_ 2))
                (error "Context expects 2 values" _g281483_)))
          (let ((_start7366_ (##vector-ref _g281482_ 0))
                (_end7367_ (##vector-ref _g281482_ 1)))
            (std/sort#really-heap-sort!
             _v7362_
             _elt<7363_
             _start7366_
             _end7367_))))))
  (define std/sort#heap-sort
    (lambda (_v7353_ _elt<7354_ . _maybe-start+end7355_)
      (let ((_g281484_
             (std/sort#parse-vector-final-start+end
              std/sort#heap-sort
              _v7353_
              _maybe-start+end7355_)))
        (begin
          (let ((_g281485_
                 (if (##values? _g281484_) (##vector-length _g281484_) 1)))
            (if (not (##fx= _g281485_ 2))
                (error "Context expects 2 values" _g281485_)))
          (let ((_start7357_ (##vector-ref _g281484_ 0))
                (_end7358_ (##vector-ref _g281484_ 1)))
            (let ((_ans7360_ (subvector _v7353_ _start7357_ _end7358_)))
              (std/sort#really-heap-sort!
               _ans7360_
               _elt<7354_
               '0
               (- _end7358_ _start7357_))
              _ans7360_))))))
  (define std/sort#%vector-merge!
    (lambda (_v7315_
             _v17316_
             _v27317_
             _elt<7318_
             _start07319_
             _start17320_
             _end17321_
             _start27322_
             _end27323_)
      (letrec ((_vblit7325_
                (lambda (_fromv7327_ _j7328_ _i7329_ _end7330_)
                  (let _lp7332_ ((_j7334_ _j7328_) (_i7335_ _i7329_))
                    (vector-set!
                     _v7315_
                     _i7335_
                     (vector-ref _fromv7327_ _j7334_))
                    (let ((_j7337_ (+ _j7334_ '1)))
                      (if (< _j7337_ _end7330_)
                          (_lp7332_ _j7337_ (+ _i7335_ '1))
                          '#!void))))))
        (if (<= _end17321_ _start17320_)
            (if (< _start27322_ _end27323_)
                (_vblit7325_ _v27317_ _start27322_ _start07319_ _end27323_)
                '#!void)
            (if (<= _end27323_ _start27322_)
                (_vblit7325_ _v17316_ _start17320_ _start07319_ _end17321_)
                (let _lp7339_ ((_i7341_ _start07319_)
                               (_j7342_ _start17320_)
                               (_x7343_ (vector-ref _v17316_ _start17320_))
                               (_k7344_ _start27322_)
                               (_y7345_ (vector-ref _v27317_ _start27322_)))
                  (let ((_i17347_ (+ _i7341_ '1)))
                    (if (_elt<7318_ _y7345_ _x7343_)
                        (let ((_k7349_ (+ _k7344_ '1)))
                          (vector-set! _v7315_ _i7341_ _y7345_)
                          (if (< _k7349_ _end27323_)
                              (_lp7339_
                               _i17347_
                               _j7342_
                               _x7343_
                               _k7349_
                               (vector-ref _v27317_ _k7349_))
                              (_vblit7325_
                               _v17316_
                               _j7342_
                               _i17347_
                               _end17321_)))
                        (let ((_j7351_ (+ _j7342_ '1)))
                          (vector-set! _v7315_ _i7341_ _x7343_)
                          (if (< _j7351_ _end17321_)
                              (_vblit7325_
                               _v27317_
                               _k7344_
                               _i17347_
                               _end27323_)
                              (_lp7339_
                               _i17347_
                               _j7351_
                               (vector-ref _v17316_ _j7351_)
                               _k7344_
                               _y7345_)))))))))))
  (define std/sort#%vector-merge-sort!
    (lambda (_v07269_ _elt<7270_ _l7271_ _r7272_ _temp07273_)
      (letrec ((_xor7275_
                (lambda (_a7312_ _b7313_) (not (eq? _a7312_ _b7313_)))))
        (if (< _l7271_ _r7272_)
            (let ((_g281486_
                   (let _recur7277_ ((_l7279_ _l7271_)
                                     (_want7280_ (- _r7272_ _l7271_)))
                     (let ((_len7282_ (- _r7272_ _l7279_)))
                       (let _lp7284_ ((_pfxlen7286_
                                       (std/sort#getrun
                                        _v07269_
                                        _l7279_
                                        _r7272_
                                        _elt<7270_))
                                      (_pfxlen27287_ '1)
                                      (_v7288_ _v07269_)
                                      (_temp7289_ _temp07273_)
                                      (_v=v0?7290_ '#t))
                         (if (or (>= _pfxlen7286_ _want7280_)
                                 (= _pfxlen7286_ _len7282_))
                             (values _pfxlen7286_ _v7288_ _v=v0?7290_)
                             (let ((_pfxlen27301_
                                    (let _lp7295_ ((_j7297_ _pfxlen27287_))
                                      (let ((_j*27299_ (+ _j7297_ _j7297_)))
                                        (if (<= _j7297_ _pfxlen7286_)
                                            (_lp7295_ _j*27299_)
                                            _j7297_))))
                                   (_tail-len7302_ (- _len7282_ _pfxlen7286_)))
                               (let ((_g281488_
                                      (_recur7277_
                                       (+ _pfxlen7286_ _l7279_)
                                       _pfxlen27301_)))
                                 (begin
                                   (let ((_g281489_
                                          (if (##values? _g281488_)
                                              (##vector-length _g281488_)
                                              1)))
                                     (if (not (##fx= _g281489_ 3))
                                         (error "Context expects 3 values"
                                                _g281489_)))
                                   (let ((_nr-len7304_
                                          (##vector-ref _g281488_ 0))
                                         (_nr-vec7305_
                                          (##vector-ref _g281488_ 1))
                                         (_nrvec=v0?7306_
                                          (##vector-ref _g281488_ 2)))
                                     (begin
                                       (std/sort#%vmerge
                                        _temp7289_
                                        _v7288_
                                        _nr-vec7305_
                                        _l7279_
                                        _pfxlen7286_
                                        _nr-len7304_
                                        (_xor7275_ _nrvec=v0?7306_ _v=v0?7290_)
                                        _elt<7270_)
                                       (_lp7284_
                                        (+ _pfxlen7286_ _nr-len7304_)
                                        (+ _pfxlen27301_ _pfxlen27301_)
                                        _temp7289_
                                        _v7288_
                                        (not _v=v0?7290_)))))))))))))
              (begin
                (let ((_g281487_
                       (if (##values? _g281486_)
                           (##vector-length _g281486_)
                           1)))
                  (if (not (##fx= _g281487_ 3))
                      (error "Context expects 3 values" _g281487_)))
                (let ((_ignored-len7308_ (##vector-ref _g281486_ 0))
                      (_ignored-ansvec7309_ (##vector-ref _g281486_ 1))
                      (_ansvec=v0?7310_ (##vector-ref _g281486_ 2)))
                  (if (not _ansvec=v0?7310_)
                      (std/sort#vector-copy!
                       _v07269_
                       _temp07273_
                       _l7271_
                       _r7272_)
                      '#!void))))
            '#!void))))
  (define std/sort#%vmerge
    (lambda (_target7227_
             _v17228_
             _v27229_
             _l7230_
             _len17231_
             _len27232_
             _v2=target?7233_
             _elt<7234_)
      (letrec ((_vblit7236_
                (lambda (_fromv7238_ _j7239_ _i7240_ _end7241_)
                  (let _lp7243_ ((_j7245_ _j7239_) (_i7246_ _i7240_))
                    (vector-set!
                     _target7227_
                     _i7246_
                     (vector-ref _fromv7238_ _j7245_))
                    (let ((_j7248_ (+ _j7245_ '1)))
                      (if (< _j7248_ _end7241_)
                          (_lp7243_ _j7248_ (+ _i7246_ '1))
                          '#!void))))))
        (let* ((_r17250_ (+ _l7230_ _len17231_))
               (_r27252_ (+ _r17250_ _len27232_)))
          (let _lp7255_ ((_i7257_ _l7230_)
                         (_j7258_ _l7230_)
                         (_x7259_ (vector-ref _v17228_ _l7230_))
                         (_k7260_ _r17250_)
                         (_y7261_ (vector-ref _v27229_ _r17250_)))
            (let ((_i17263_ (+ _i7257_ '1)))
              (if (_elt<7234_ _y7261_ _x7259_)
                  (let ((_k7265_ (+ _k7260_ '1)))
                    (vector-set! _target7227_ _i7257_ _y7261_)
                    (if (< _k7265_ _r27252_)
                        (_lp7255_
                         _i17263_
                         _j7258_
                         _x7259_
                         _k7265_
                         (vector-ref _v27229_ _k7265_))
                        (_vblit7236_ _v17228_ _j7258_ _i17263_ _r17250_)))
                  (let ((_j7267_ (+ _j7258_ '1)))
                    (vector-set! _target7227_ _i7257_ _x7259_)
                    (if (< _j7267_ _r17250_)
                        (_lp7255_
                         _i17263_
                         _j7267_
                         (vector-ref _v17228_ _j7267_)
                         _k7260_
                         _y7261_)
                        (if (not _v2=target?7233_)
                            (_vblit7236_ _v27229_ _k7260_ _i17263_ _r27252_)
                            '#!void))))))))))
  (define std/sort#getrun
    (lambda (_v7215_ _l7216_ _r7217_ _elt<7218_)
      (let _lp7220_ ((_i7222_ (+ _l7216_ '1))
                     (_x7223_ (vector-ref _v7215_ _l7216_)))
        (if (>= _i7222_ _r7217_)
            (- _i7222_ _l7216_)
            (let ((_y7225_ (vector-ref _v7215_ _i7222_)))
              (if (_elt<7218_ _y7225_ _x7223_)
                  (- _i7222_ _l7216_)
                  (_lp7220_ (+ _i7222_ '1) _y7225_)))))))
  (define std/sort#list-sorted?
    (lambda (_list7199_ _<7200_)
      (let ((_$e7202_ (not (pair? _list7199_))))
        (if _$e7202_
            _$e7202_
            (let _lp7205_ ((_prev7207_ (car _list7199_))
                           (_tail7208_ (cdr _list7199_)))
              (let ((_$e7210_ (not (pair? _tail7208_))))
                (if _$e7210_
                    _$e7210_
                    (let ((_next7213_ (car _tail7208_)))
                      (if (not (_<7200_ _next7213_ _prev7207_))
                          (_lp7205_ _next7213_ (cdr _tail7208_))
                          '#f)))))))))
  (define std/sort#vector-sorted?
    (lambda (_v7179_ _elt<7180_ . _maybe-start+end7181_)
      (if (vector? _v7179_) '#!void (error '"Expected vector" _v7179_))
      (let ((_g281490_
             (std/sort#parse-vector-final-start+end
              std/sort#vector-sorted?
              _v7179_
              _maybe-start+end7181_)))
        (begin
          (let ((_g281491_
                 (if (##values? _g281490_) (##vector-length _g281490_) 1)))
            (if (not (##fx= _g281491_ 2))
                (error "Context expects 2 values" _g281491_)))
          (let ((_start7183_ (##vector-ref _g281490_ 0))
                (_end7184_ (##vector-ref _g281490_ 1)))
            (let ((_$e7186_ (>= _start7183_ _end7184_)))
              (if _$e7186_
                  _$e7186_
                  (let _lp7189_ ((_i7191_ (+ _start7183_ '1))
                                 (_vi-17192_ (vector-ref _v7179_ _start7183_)))
                    (let ((_$e7194_ (>= _i7191_ _end7184_)))
                      (if _$e7194_
                          _$e7194_
                          (let ((_vi7197_ (vector-ref _v7179_ _i7191_)))
                            (if (not (_elt<7180_ _vi7197_ _vi-17192_))
                                (_lp7189_ (+ _i7191_ '1) _vi7197_)
                                '#f)))))))))))))
