(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/43#nonneg-int?
    (lambda (_x88744_)
      (if (integer? _x88744_) (not (negative? _x88744_)) '#f)))
  (define std/srfi/43#between?
    (lambda (_x88740_ _y88741_ _z88742_)
      (if (< _x88740_ _y88741_) (<= _y88741_ _z88742_) '#f)))
  (define std/srfi/43#unspecified-value (lambda () (if '#f '#f '#!void)))
  (define std/srfi/43#vectors-ref
    (lambda (_vectors88734_ _i88735_)
      (map (lambda (_v88737_) (vector-ref _v88737_ _i88735_)) _vectors88734_)))
  (define std/srfi/43#check-type
    (lambda (_pred?88730_ _value88731_ _callee88732_)
      (if (_pred?88730_ _value88731_)
          _value88731_
          (std/srfi/43#check-type
           _pred?88730_
           (error '"erroneous value"
                  (list _pred?88730_ _value88731_)
                  (cons 'while (cons 'calling (cons _callee88732_ '()))))
           _callee88732_))))
  (define std/srfi/43#check-index
    (lambda (_vec88724_ _index88725_ _callee88726_)
      (let ((_index88728_
             (std/srfi/43#check-type integer? _index88725_ _callee88726_)))
        (if (< _index88728_ '0)
            (std/srfi/43#check-index
             _vec88724_
             (error '"vector index too low"
                    _index88728_
                    (cons 'into (cons 'vector (cons _vec88724_ '())))
                    (cons 'while (cons 'calling (cons _callee88726_ '()))))
             _callee88726_)
            (if (>= _index88728_ (vector-length _vec88724_))
                (std/srfi/43#check-index
                 _vec88724_
                 (error '"vector index too high"
                        _index88728_
                        (cons 'into (cons 'vector (cons _vec88724_ '())))
                        (cons 'while (cons 'calling (cons _callee88726_ '()))))
                 _callee88726_)
                _index88728_)))))
  (define std/srfi/43#check-indices
    (lambda (_vec88708_
             _start88709_
             _start-name88710_
             _end88711_
             _end-name88712_
             _callee88713_)
      (let ((_lose88717_
             (lambda _things88715_
               (apply error
                      '"vector range out of bounds"
                      (append _things88715_
                              (cons 'vector (cons 'was (cons _vec88708_ '())))
                              (cons _start-name88710_
                                    (cons 'was (cons _start88709_ '())))
                              (cons _end-name88712_
                                    (cons 'was (cons _end88711_ '())))
                              (cons 'while
                                    (cons 'calling
                                          (cons _callee88713_ '())))))))
            (_start88718_
             (std/srfi/43#check-type integer? _start88709_ _callee88713_))
            (_end88719_
             (std/srfi/43#check-type integer? _end88711_ _callee88713_)))
        (if (> _start88718_ _end88719_)
            (let ((_g288619_
                   (_lose88717_
                    (cons _end-name88712_
                          (cons '< (cons _start-name88710_ '()))))))
              (begin
                (let ((_g288620_
                       (let ()
                         (declare (not safe))
                         (if (##values? _g288619_)
                             (##vector-length _g288619_)
                             1))))
                  (if (not (let () (declare (not safe)) (##fx= _g288620_ 2)))
                      (error "Context expects 2 values" _g288620_)))
                (let ((_new-start88721_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g288619_ 0)))
                      (_new-end88722_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g288619_ 1))))
                  (std/srfi/43#check-indices
                   _vec88708_
                   _new-start88721_
                   _start-name88710_
                   _new-end88722_
                   _end-name88712_
                   _callee88713_))))
            (if (< _start88718_ '0)
                (std/srfi/43#check-indices
                 _vec88708_
                 (_lose88717_ (cons _start-name88710_ (cons '< (cons '0 '()))))
                 _start-name88710_
                 _end88719_
                 _end-name88712_
                 _callee88713_)
                (if (>= _start88718_ (vector-length _vec88708_))
                    (std/srfi/43#check-indices
                     _vec88708_
                     (_lose88717_
                      (cons _start-name88710_ (cons '> (cons 'len '())))
                      (cons 'len
                            (cons 'was (cons (vector-length _vec88708_) '()))))
                     _start-name88710_
                     _end88719_
                     _end-name88712_
                     _callee88713_)
                    (if (> _end88719_ (vector-length _vec88708_))
                        (std/srfi/43#check-indices
                         _vec88708_
                         _start88718_
                         _start-name88710_
                         (_lose88717_
                          (cons _end-name88712_ (cons '> (cons 'len '())))
                          (cons 'len
                                (cons 'was
                                      (cons (vector-length _vec88708_) '()))))
                         _end-name88712_
                         _callee88713_)
                        (values _start88718_ _end88719_))))))))
  (define std/srfi/43#vector-parse-start+end
    (lambda (_vec88700_
             _args88701_
             _start-name88702_
             _end-name88703_
             _callee88704_)
      (let ((_len88706_ (vector-length _vec88700_)))
        (if (null? _args88701_)
            (values '0 _len88706_)
            (if (null? (cdr _args88701_))
                (std/srfi/43#check-indices
                 _vec88700_
                 (car _args88701_)
                 _start-name88702_
                 _len88706_
                 _end-name88703_
                 _callee88704_)
                (if (null? (cddr _args88701_))
                    (std/srfi/43#check-indices
                     _vec88700_
                     (car _args88701_)
                     _start-name88702_
                     (cadr _args88701_)
                     _end-name88703_
                     _callee88704_)
                    (error '"too many arguments"
                           (cons 'extra
                                 (cons 'args
                                       (cons 'were
                                             (cons (cddr _args88701_) '()))))
                           (cons 'while
                                 (cons 'calling
                                       (cons _callee88704_ '()))))))))))
  (define std/srfi/43#%smallest-length
    (letrec ((_loop88694_
              (lambda (_vector-list88696_ _length88697_ _callee88698_)
                (if (null? _vector-list88696_)
                    _length88697_
                    (_loop88694_
                     (cdr _vector-list88696_)
                     (min (vector-length
                           (std/srfi/43#check-type
                            vector?
                            (car _vector-list88696_)
                            _callee88698_))
                          _length88697_)
                     _callee88698_)))))
      _loop88694_))
  (define std/srfi/43#%vector-copy!
    (letrec ((_loop/l->r88673_
              (lambda (_target88676_
                       _source88677_
                       _send88678_
                       _i88679_
                       _j88680_)
                (if (< _i88679_ _send88678_)
                    (begin
                      (vector-set!
                       _target88676_
                       _j88680_
                       (vector-ref _source88677_ _i88679_))
                      (_loop/l->r88673_
                       _target88676_
                       _source88677_
                       _send88678_
                       (+ _i88679_ '1)
                       (+ _j88680_ '1)))
                    '#!void)))
             (_loop/r->l88674_
              (lambda (_target88682_
                       _source88683_
                       _sstart88684_
                       _i88685_
                       _j88686_)
                (if (>= _i88685_ _sstart88684_)
                    (begin
                      (vector-set!
                       _target88682_
                       _j88686_
                       (vector-ref _source88683_ _i88685_))
                      (_loop/r->l88674_
                       _target88682_
                       _source88683_
                       _sstart88684_
                       (- _i88685_ '1)
                       (- _j88686_ '1)))
                    '#!void))))
      (lambda (_target88688_
               _tstart88689_
               _source88690_
               _sstart88691_
               _send88692_)
        (if (> _sstart88691_ _tstart88689_)
            (_loop/l->r88673_
             _target88688_
             _source88690_
             _send88692_
             _sstart88691_
             _tstart88689_)
            (_loop/r->l88674_
             _target88688_
             _source88690_
             _sstart88691_
             (- _send88692_ '1)
             (+ '-1 _tstart88689_ _send88692_ (- _sstart88691_)))))))
  (define std/srfi/43#%vector-reverse-copy!
    (letrec ((_loop88659_
              (lambda (_target88661_
                       _source88662_
                       _sstart88663_
                       _i88664_
                       _j88665_)
                (if (>= _i88664_ _sstart88663_)
                    (begin
                      (vector-set!
                       _target88661_
                       _j88665_
                       (vector-ref _source88662_ _i88664_))
                      (_loop88659_
                       _target88661_
                       _source88662_
                       _sstart88663_
                       (- _i88664_ '1)
                       (+ _j88665_ '1)))
                    '#!void))))
      (lambda (_target88667_
               _tstart88668_
               _source88669_
               _sstart88670_
               _send88671_)
        (_loop88659_
         _target88667_
         _source88669_
         _sstart88670_
         (- _send88671_ '1)
         _tstart88668_))))
  (define std/srfi/43#%vector-reverse!
    (letrec ((_loop88647_
              (lambda (_vec88649_ _i88650_ _j88651_)
                (if (<= _i88650_ _j88651_)
                    (let ((_v88653_ (vector-ref _vec88649_ _i88650_)))
                      (vector-set!
                       _vec88649_
                       _i88650_
                       (vector-ref _vec88649_ _j88651_))
                      (vector-set! _vec88649_ _j88651_ _v88653_)
                      (_loop88647_ _vec88649_ (+ _i88650_ '1) (- _j88651_ '1)))
                    '#!void))))
      (lambda (_vec88655_ _start88656_ _end88657_)
        (_loop88647_ _vec88655_ _start88656_ (- _end88657_ '1)))))
  (define std/srfi/43#%vector-fold1
    (letrec ((_loop88634_
              (lambda (_kons88636_ _knil88637_ _len88638_ _vec88639_ _i88640_)
                (if (= _i88640_ _len88638_)
                    _knil88637_
                    (_loop88634_
                     _kons88636_
                     (_kons88636_
                      _i88640_
                      _knil88637_
                      (vector-ref _vec88639_ _i88640_))
                     _len88638_
                     _vec88639_
                     (+ _i88640_ '1))))))
      (lambda (_kons88642_ _knil88643_ _len88644_ _vec88645_)
        (_loop88634_ _kons88642_ _knil88643_ _len88644_ _vec88645_ '0))))
  (define std/srfi/43#%vector-fold2+
    (letrec ((_loop88621_
              (lambda (_kons88623_
                       _knil88624_
                       _len88625_
                       _vectors88626_
                       _i88627_)
                (if (= _i88627_ _len88625_)
                    _knil88624_
                    (_loop88621_
                     _kons88623_
                     (apply _kons88623_
                            _i88627_
                            _knil88624_
                            (std/srfi/43#vectors-ref _vectors88626_ _i88627_))
                     _len88625_
                     _vectors88626_
                     (+ _i88627_ '1))))))
      (lambda (_kons88629_ _knil88630_ _len88631_ _vectors88632_)
        (_loop88621_ _kons88629_ _knil88630_ _len88631_ _vectors88632_ '0))))
  (define std/srfi/43#%vector-map1!
    (letrec ((_loop88607_
              (lambda (_f88609_ _target88610_ _vec88611_ _i88612_)
                (if (zero? _i88612_)
                    _target88610_
                    (let ((_j88614_ (- _i88612_ '1)))
                      (vector-set!
                       _target88610_
                       _j88614_
                       (_f88609_ _j88614_ (vector-ref _vec88611_ _j88614_)))
                      (_loop88607_
                       _f88609_
                       _target88610_
                       _vec88611_
                       _j88614_))))))
      (lambda (_f88616_ _target88617_ _vec88618_ _len88619_)
        (_loop88607_ _f88616_ _target88617_ _vec88618_ _len88619_))))
  (define std/srfi/43#%vector-map2+!
    (letrec ((_loop88593_
              (lambda (_f88595_ _target88596_ _vectors88597_ _i88598_)
                (if (zero? _i88598_)
                    _target88596_
                    (let ((_j88600_ (- _i88598_ '1)))
                      (vector-set!
                       _target88596_
                       _j88600_
                       (apply _f88595_
                              _j88600_
                              (std/srfi/43#vectors-ref
                               _vectors88597_
                               _j88600_)))
                      (_loop88593_
                       _f88595_
                       _target88596_
                       _vectors88597_
                       _j88600_))))))
      (lambda (_f88602_ _target88603_ _vectors88604_ _len88605_)
        (_loop88593_ _f88602_ _target88603_ _vectors88604_ _len88605_))))
  (define std/srfi/43#vector-unfold
    (letrec ((_tabulate!88557_
              (lambda (_f88561_ _vec88562_ _i88563_ _len88564_)
                (if (< _i88563_ _len88564_)
                    (begin
                      (vector-set! _vec88562_ _i88563_ (_f88561_ _i88563_))
                      (_tabulate!88557_
                       _f88561_
                       _vec88562_
                       (+ _i88563_ '1)
                       _len88564_))
                    '#!void)))
             (_unfold1!88558_
              (lambda (_f88566_ _vec88567_ _i88568_ _len88569_ _seed88570_)
                (if (< _i88568_ _len88569_)
                    (let ((_g288621_ (_f88566_ _i88568_ _seed88570_)))
                      (begin
                        (let ((_g288622_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g288621_)
                                     (##vector-length _g288621_)
                                     1))))
                          (if (not (let ()
                                     (declare (not safe))
                                     (##fx= _g288622_ 2)))
                              (error "Context expects 2 values" _g288622_)))
                        (let ((_elt88572_
                               (let ()
                                 (declare (not safe))
                                 (##vector-ref _g288621_ 0)))
                              (_new-seed88573_
                               (let ()
                                 (declare (not safe))
                                 (##vector-ref _g288621_ 1))))
                          (begin
                            (vector-set! _vec88567_ _i88568_ _elt88572_)
                            (_unfold1!88558_
                             _f88566_
                             _vec88567_
                             (+ _i88568_ '1)
                             _len88569_
                             _new-seed88573_)))))
                    '#!void)))
             (_unfold2+!88559_
              (lambda (_f88575_ _vec88576_ _i88577_ _len88578_ _seeds88579_)
                (if (< _i88577_ _len88578_)
                    (let ((_g288623_ (apply _f88575_ _i88577_ _seeds88579_)))
                      (begin
                        (let ((_g288624_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g288623_)
                                     (##vector-length _g288623_)
                                     1))))
                          (if (not (let ()
                                     (declare (not safe))
                                     (##fx>= _g288624_ 1)))
                              (error "Context expects at least 1 values"
                                     _g288624_)))
                        (let ((_elt88581_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g288623_)
                                     (##vector-ref _g288623_ 0)
                                     _g288623_)))
                              (_new-seeds88582_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g288623_)
                                     (##cdr (##vector->list _g288623_))
                                     '()))))
                          (begin
                            (vector-set! _vec88576_ _i88577_ _elt88581_)
                            (_unfold2+!88559_
                             _f88575_
                             _vec88576_
                             (+ _i88577_ '1)
                             _len88578_
                             _new-seeds88582_)))))
                    '#!void))))
      (lambda (_f88584_ _len88585_ . _initial-seeds88586_)
        (let ((_f88588_
               (std/srfi/43#check-type
                procedure?
                _f88584_
                std/srfi/43#vector-unfold))
              (_len88589_
               (std/srfi/43#check-type
                std/srfi/43#nonneg-int?
                _len88585_
                std/srfi/43#vector-unfold)))
          (let ((_vec88591_ (make-vector _len88589_)))
            (if (null? _initial-seeds88586_)
                (_tabulate!88557_ _f88588_ _vec88591_ '0 _len88589_)
                (if (null? (cdr _initial-seeds88586_))
                    (_unfold1!88558_
                     _f88588_
                     _vec88591_
                     '0
                     _len88589_
                     (car _initial-seeds88586_))
                    (_unfold2+!88559_
                     _f88588_
                     _vec88591_
                     '0
                     _len88589_
                     _initial-seeds88586_)))
            _vec88591_)))))
  (define std/srfi/43#vector-unfold-right
    (letrec ((_tabulate!88523_
              (lambda (_f88527_ _vec88528_ _i88529_)
                (if (>= _i88529_ '0)
                    (begin
                      (vector-set! _vec88528_ _i88529_ (_f88527_ _i88529_))
                      (_tabulate!88523_ _f88527_ _vec88528_ (- _i88529_ '1)))
                    '#!void)))
             (_unfold1!88524_
              (lambda (_f88531_ _vec88532_ _i88533_ _seed88534_)
                (if (>= _i88533_ '0)
                    (let ((_g288625_ (_f88531_ _i88533_ _seed88534_)))
                      (begin
                        (let ((_g288626_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g288625_)
                                     (##vector-length _g288625_)
                                     1))))
                          (if (not (let ()
                                     (declare (not safe))
                                     (##fx= _g288626_ 2)))
                              (error "Context expects 2 values" _g288626_)))
                        (let ((_elt88536_
                               (let ()
                                 (declare (not safe))
                                 (##vector-ref _g288625_ 0)))
                              (_new-seed88537_
                               (let ()
                                 (declare (not safe))
                                 (##vector-ref _g288625_ 1))))
                          (begin
                            (vector-set! _vec88532_ _i88533_ _elt88536_)
                            (_unfold1!88524_
                             _f88531_
                             _vec88532_
                             (- _i88533_ '1)
                             _new-seed88537_)))))
                    '#!void)))
             (_unfold2+!88525_
              (lambda (_f88539_ _vec88540_ _i88541_ _seeds88542_)
                (if (>= _i88541_ '0)
                    (let ((_g288627_ (apply _f88539_ _i88541_ _seeds88542_)))
                      (begin
                        (let ((_g288628_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g288627_)
                                     (##vector-length _g288627_)
                                     1))))
                          (if (not (let ()
                                     (declare (not safe))
                                     (##fx>= _g288628_ 1)))
                              (error "Context expects at least 1 values"
                                     _g288628_)))
                        (let ((_elt88544_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g288627_)
                                     (##vector-ref _g288627_ 0)
                                     _g288627_)))
                              (_new-seeds88545_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g288627_)
                                     (##cdr (##vector->list _g288627_))
                                     '()))))
                          (begin
                            (vector-set! _vec88540_ _i88541_ _elt88544_)
                            (_unfold2+!88525_
                             _f88539_
                             _vec88540_
                             (- _i88541_ '1)
                             _new-seeds88545_)))))
                    '#!void))))
      (lambda (_f88547_ _len88548_ . _initial-seeds88549_)
        (let ((_f88551_
               (std/srfi/43#check-type
                procedure?
                _f88547_
                std/srfi/43#vector-unfold-right))
              (_len88552_
               (std/srfi/43#check-type
                std/srfi/43#nonneg-int?
                _len88548_
                std/srfi/43#vector-unfold-right)))
          (let ((_vec88554_ (make-vector _len88552_))
                (_i88555_ (- _len88552_ '1)))
            (if (null? _initial-seeds88549_)
                (_tabulate!88523_ _f88551_ _vec88554_ _i88555_)
                (if (null? (cdr _initial-seeds88549_))
                    (_unfold1!88524_
                     _f88551_
                     _vec88554_
                     _i88555_
                     (car _initial-seeds88549_))
                    (_unfold2+!88525_
                     _f88551_
                     _vec88554_
                     _i88555_
                     _initial-seeds88549_)))
            _vec88554_)))))
  (define std/srfi/43#vector-copy
    (lambda (_vec88512_ . _args88513_)
      (let* ((_vec88515_
              (std/srfi/43#check-type
               vector?
               _vec88512_
               std/srfi/43#vector-copy))
             (_g288629_
              (std/srfi/43#vector-copy:parse-args _vec88515_ _args88513_)))
        (begin
          (let ((_g288630_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g288629_) (##vector-length _g288629_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g288630_ 3)))
                (error "Context expects 3 values" _g288630_)))
          (let ((_start88517_
                 (let () (declare (not safe)) (##vector-ref _g288629_ 0)))
                (_end88518_
                 (let () (declare (not safe)) (##vector-ref _g288629_ 1)))
                (_fill88519_
                 (let () (declare (not safe)) (##vector-ref _g288629_ 2))))
            (let ((_new-vector88521_
                   (make-vector (- _end88518_ _start88517_) _fill88519_)))
              (std/srfi/43#%vector-copy!
               _new-vector88521_
               '0
               _vec88515_
               _start88517_
               (if (> _end88518_ (vector-length _vec88515_))
                   (vector-length _vec88515_)
                   _end88518_))
              _new-vector88521_))))))
  (define std/srfi/43#vector-copy:parse-args
    (lambda (_vec88497_ _args88498_)
      (letrec ((_parse-args88500_
                (lambda (_start88504_ _end88505_ _n88506_ _fill88507_)
                  (let ((_start88509_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _start88504_
                          std/srfi/43#vector-copy))
                        (_end88510_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _end88505_
                          std/srfi/43#vector-copy)))
                    (if (and (<= '0 _start88509_ _end88510_)
                             (<= _start88509_ _n88506_))
                        (values _start88509_ _end88510_ _fill88507_)
                        (error '"illegal arguments"
                               (cons 'while
                                     (cons 'calling
                                           (cons std/srfi/43#vector-copy '())))
                               (cons 'start
                                     (cons 'was (cons _start88509_ '())))
                               (cons 'end (cons 'was (cons _end88510_ '())))
                               (cons 'vector
                                     (cons 'was (cons _vec88497_ '())))))))))
        (let ((_n88502_ (vector-length _vec88497_)))
          (if (null? _args88498_)
              (_parse-args88500_
               '0
               _n88502_
               _n88502_
               (std/srfi/43#unspecified-value))
              (if (null? (cdr _args88498_))
                  (_parse-args88500_
                   (car _args88498_)
                   _n88502_
                   _n88502_
                   (std/srfi/43#unspecified-value))
                  (if (null? (cddr _args88498_))
                      (_parse-args88500_
                       (car _args88498_)
                       (cadr _args88498_)
                       _n88502_
                       (std/srfi/43#unspecified-value))
                      (if (null? (cdddr _args88498_))
                          (_parse-args88500_
                           (car _args88498_)
                           (cadr _args88498_)
                           _n88502_
                           (caddr _args88498_))
                          (error '"too many arguments"
                                 std/srfi/43#vector-copy
                                 (cdddr _args88498_))))))))))
  (define std/srfi/43#vector-reverse-copy
    (lambda (_vec88487_ . _maybe-start+end88488_)
      (let* ((_vec88490_
              (std/srfi/43#check-type
               vector?
               _vec88487_
               std/srfi/43#vector-reverse-copy))
             (_g288631_
              (std/srfi/43#vector-parse-start+end
               _vec88490_
               _maybe-start+end88488_
               'start
               'end
               std/srfi/43#vector-reverse-copy)))
        (begin
          (let ((_g288632_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g288631_) (##vector-length _g288631_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g288632_ 2)))
                (error "Context expects 2 values" _g288632_)))
          (let ((_start88492_
                 (let () (declare (not safe)) (##vector-ref _g288631_ 0)))
                (_end88493_
                 (let () (declare (not safe)) (##vector-ref _g288631_ 1))))
            (let ((_new88495_ (make-vector (- _end88493_ _start88492_))))
              (std/srfi/43#%vector-reverse-copy!
               _new88495_
               '0
               _vec88490_
               _start88492_
               _end88493_)
              _new88495_))))))
  (define std/srfi/43#vector-append
    (lambda _vectors88485_
      (std/srfi/43#vector-concatenate:aux
       _vectors88485_
       std/srfi/43#vector-append)))
  (define std/srfi/43#vector-concatenate
    (lambda (_vector-list88483_)
      (std/srfi/43#vector-concatenate:aux
       _vector-list88483_
       std/srfi/43#vector-concatenate)))
  (define std/srfi/43#vector-concatenate:aux
    (letrec ((_compute-length88453_
              (lambda (_vectors88456_ _len88457_ _callee88458_)
                (if (null? _vectors88456_)
                    _len88457_
                    (let ((_vec88460_
                           (std/srfi/43#check-type
                            vector?
                            (car _vectors88456_)
                            _callee88458_)))
                      (_compute-length88453_
                       (cdr _vectors88456_)
                       (+ (vector-length _vec88460_) _len88457_)
                       _callee88458_)))))
             (_concatenate!88454_
              (lambda (_vectors88462_ _target88463_ _to88464_)
                (if (null? _vectors88462_)
                    _target88463_
                    (let* ((_vec188466_ (car _vectors88462_))
                           (_len88468_ (vector-length _vec188466_)))
                      (std/srfi/43#%vector-copy!
                       _target88463_
                       _to88464_
                       _vec188466_
                       '0
                       _len88468_)
                      (_concatenate!88454_
                       (cdr _vectors88462_)
                       _target88463_
                       (+ _to88464_ _len88468_)))))))
      (lambda (_vectors88471_ _callee88472_)
        (if (null? _vectors88471_)
            (make-vector '0)
            (if (null? (cdr _vectors88471_))
                (let* ((_vec88474_
                        (std/srfi/43#check-type
                         vector?
                         (car _vectors88471_)
                         _callee88472_))
                       (_len88476_ (vector-length _vec88474_))
                       (_new88478_ (make-vector _len88476_)))
                  (std/srfi/43#%vector-copy!
                   _new88478_
                   '0
                   _vec88474_
                   '0
                   _len88476_)
                  _new88478_)
                (let ((_new-vector88481_
                       (make-vector
                        (_compute-length88453_
                         _vectors88471_
                         '0
                         _callee88472_))))
                  (_concatenate!88454_ _vectors88471_ _new-vector88481_ '0)
                  _new-vector88481_))))))
  (define std/srfi/43#vector-empty?
    (lambda (_vec88449_)
      (let ((_vec88451_
             (std/srfi/43#check-type
              vector?
              _vec88449_
              std/srfi/43#vector-empty?)))
        (zero? (vector-length _vec88451_)))))
  (define std/srfi/43#vector=
    (lambda (_elt=?88434_ . _vectors88435_)
      (let ((_elt=?88437_
             (std/srfi/43#check-type
              procedure?
              _elt=?88434_
              std/srfi/43#vector=)))
        (if (null? _vectors88435_)
            '#t
            (if (null? (cdr _vectors88435_))
                (begin
                  (std/srfi/43#check-type
                   vector?
                   (car _vectors88435_)
                   std/srfi/43#vector=)
                  '#t)
                (let _loop88439_ ((_vecs88441_ _vectors88435_))
                  (let ((_vec188443_
                         (std/srfi/43#check-type
                          vector?
                          (car _vecs88441_)
                          std/srfi/43#vector=))
                        (_vec2+88444_ (cdr _vecs88441_)))
                    (let ((_$e88446_ (null? _vec2+88444_)))
                      (if _$e88446_
                          _$e88446_
                          (if (std/srfi/43#binary-vector=
                               _elt=?88437_
                               _vec188443_
                               (car _vec2+88444_))
                              (_loop88439_ _vec2+88444_)
                              '#f))))))))))
  (define std/srfi/43#binary-vector=
    (lambda (_elt=?88409_ _vector-a88410_ _vector-b88411_)
      (let ((_$e88413_ (eq? _vector-a88410_ _vector-b88411_)))
        (if _$e88413_
            _$e88413_
            (let ((_length-a88416_ (vector-length _vector-a88410_))
                  (_length-b88417_ (vector-length _vector-b88411_)))
              (letrec ((_loop88419_
                        (lambda (_i88422_)
                          (let ((_$e88424_ (= _i88422_ _length-a88416_)))
                            (if _$e88424_
                                _$e88424_
                                (if (< _i88422_ _length-b88417_)
                                    (_test88420_
                                     (vector-ref _vector-a88410_ _i88422_)
                                     (vector-ref _vector-b88411_ _i88422_)
                                     _i88422_)
                                    '#f)))))
                       (_test88420_
                        (lambda (_elt-a88427_ _elt-b88428_ _i88429_)
                          (if (or (eq? _elt-a88427_ _elt-b88428_)
                                  (_elt=?88409_ _elt-a88427_ _elt-b88428_))
                              (_loop88419_ (+ _i88429_ '1))
                              '#f))))
                (if (= _length-a88416_ _length-b88417_)
                    (_loop88419_ '0)
                    '#f)))))))
  (define std/srfi/43#vector-fold
    (lambda (_kons88401_ _knil88402_ _vec88403_ . _vectors88404_)
      (let ((_kons88406_
             (std/srfi/43#check-type
              procedure?
              _kons88401_
              std/srfi/43#vector-fold))
            (_vec88407_
             (std/srfi/43#check-type
              vector?
              _vec88403_
              std/srfi/43#vector-fold)))
        (if (null? _vectors88404_)
            (std/srfi/43#%vector-fold1
             _kons88406_
             _knil88402_
             (vector-length _vec88407_)
             _vec88407_)
            (std/srfi/43#%vector-fold2+
             _kons88406_
             _knil88402_
             (std/srfi/43#%smallest-length
              _vectors88404_
              (vector-length _vec88407_)
              std/srfi/43#vector-fold)
             (cons _vec88407_ _vectors88404_))))))
  (define std/srfi/43#vector-fold-right
    (letrec ((_loop188380_
              (lambda (_kons88383_ _knil88384_ _vec88385_ _i88386_)
                (if (negative? _i88386_)
                    _knil88384_
                    (_loop188380_
                     _kons88383_
                     (_kons88383_
                      _i88386_
                      _knil88384_
                      (vector-ref _vec88385_ _i88386_))
                     _vec88385_
                     (- _i88386_ '1)))))
             (_loop2+88381_
              (lambda (_kons88388_ _knil88389_ _vectors88390_ _i88391_)
                (if (negative? _i88391_)
                    _knil88389_
                    (_loop2+88381_
                     _kons88388_
                     (apply _kons88388_
                            _i88391_
                            _knil88389_
                            (std/srfi/43#vectors-ref _vectors88390_ _i88391_))
                     _vectors88390_
                     (- _i88391_ '1))))))
      (lambda (_kons88393_ _knil88394_ _vec88395_ . _vectors88396_)
        (let ((_kons88398_
               (std/srfi/43#check-type
                procedure?
                _kons88393_
                std/srfi/43#vector-fold-right))
              (_vec88399_
               (std/srfi/43#check-type
                vector?
                _vec88395_
                std/srfi/43#vector-fold-right)))
          (if (null? _vectors88396_)
              (_loop188380_
               _kons88398_
               _knil88394_
               _vec88399_
               (- (vector-length _vec88399_) '1))
              (_loop2+88381_
               _kons88398_
               _knil88394_
               (cons _vec88399_ _vectors88396_)
               (- (std/srfi/43#%smallest-length
                   _vectors88396_
                   (vector-length _vec88399_)
                   std/srfi/43#vector-fold-right)
                  '1)))))))
  (define std/srfi/43#vector-map
    (lambda (_f88369_ _vec88370_ . _vectors88371_)
      (let ((_f88373_
             (std/srfi/43#check-type
              procedure?
              _f88369_
              std/srfi/43#vector-map))
            (_vec88374_
             (std/srfi/43#check-type
              vector?
              _vec88370_
              std/srfi/43#vector-map)))
        (if (null? _vectors88371_)
            (let ((_len88376_ (vector-length _vec88374_)))
              (std/srfi/43#%vector-map1!
               _f88373_
               (make-vector _len88376_)
               _vec88374_
               _len88376_))
            (let ((_len88378_
                   (std/srfi/43#%smallest-length
                    _vectors88371_
                    (vector-length _vec88374_)
                    std/srfi/43#vector-map)))
              (std/srfi/43#%vector-map2+!
               _f88373_
               (make-vector _len88378_)
               (cons _vec88374_ _vectors88371_)
               _len88378_))))))
  (define std/srfi/43#vector-map!
    (lambda (_f88362_ _vec88363_ . _vectors88364_)
      (let ((_f88366_
             (std/srfi/43#check-type
              procedure?
              _f88362_
              std/srfi/43#vector-map!))
            (_vec88367_
             (std/srfi/43#check-type
              vector?
              _vec88363_
              std/srfi/43#vector-map!)))
        (if (null? _vectors88364_)
            (std/srfi/43#%vector-map1!
             _f88366_
             _vec88367_
             _vec88367_
             (vector-length _vec88367_))
            (std/srfi/43#%vector-map2+!
             _f88366_
             _vec88367_
             (cons _vec88367_ _vectors88364_)
             (std/srfi/43#%smallest-length
              _vectors88364_
              (vector-length _vec88367_)
              std/srfi/43#vector-map!)))
        (std/srfi/43#unspecified-value))))
  (define std/srfi/43#vector-for-each
    (letrec ((_for-each188342_
              (lambda (_f88345_ _vec88346_ _i88347_ _len88348_)
                (if (< _i88347_ _len88348_)
                    (begin
                      (_f88345_ _i88347_ (vector-ref _vec88346_ _i88347_))
                      (_for-each188342_
                       _f88345_
                       _vec88346_
                       (+ _i88347_ '1)
                       _len88348_))
                    '#!void)))
             (_for-each2+88343_
              (lambda (_f88350_ _vecs88351_ _i88352_ _len88353_)
                (if (< _i88352_ _len88353_)
                    (begin
                      (apply _f88350_
                             _i88352_
                             (std/srfi/43#vectors-ref _vecs88351_ _i88352_))
                      (_for-each2+88343_
                       _f88350_
                       _vecs88351_
                       (+ _i88352_ '1)
                       _len88353_))
                    '#!void))))
      (lambda (_f88355_ _vec88356_ . _vectors88357_)
        (let ((_f88359_
               (std/srfi/43#check-type
                procedure?
                _f88355_
                std/srfi/43#vector-for-each))
              (_vec88360_
               (std/srfi/43#check-type
                vector?
                _vec88356_
                std/srfi/43#vector-for-each)))
          (if (null? _vectors88357_)
              (_for-each188342_
               _f88359_
               _vec88360_
               '0
               (vector-length _vec88360_))
              (_for-each2+88343_
               _f88359_
               (cons _vec88360_ _vectors88357_)
               '0
               (std/srfi/43#%smallest-length
                _vectors88357_
                (vector-length _vec88360_)
                std/srfi/43#vector-for-each)))))))
  (define std/srfi/43#vector-count
    (lambda (_pred?88327_ _vec88328_ . _vectors88329_)
      (let ((_pred?88331_
             (std/srfi/43#check-type
              procedure?
              _pred?88327_
              std/srfi/43#vector-count))
            (_vec88332_
             (std/srfi/43#check-type
              vector?
              _vec88328_
              std/srfi/43#vector-count)))
        (if (null? _vectors88329_)
            (std/srfi/43#%vector-fold1
             (lambda (_index88334_ _count88335_ _elt88336_)
               (if (_pred?88331_ _index88334_ _elt88336_)
                   (+ _count88335_ '1)
                   _count88335_))
             '0
             (vector-length _vec88332_)
             _vec88332_)
            (std/srfi/43#%vector-fold2+
             (lambda (_index88338_ _count88339_ . _elts88340_)
               (if (apply _pred?88331_ _index88338_ _elts88340_)
                   (+ _count88339_ '1)
                   _count88339_))
             '0
             (std/srfi/43#%smallest-length
              _vectors88329_
              (vector-length _vec88332_)
              std/srfi/43#vector-count)
             (cons _vec88332_ _vectors88329_))))))
  (define std/srfi/43#vector-index
    (lambda (_pred?88323_ _vec88324_ . _vectors88325_)
      (std/srfi/43#vector-index/skip
       _pred?88323_
       _vec88324_
       _vectors88325_
       std/srfi/43#vector-index)))
  (define std/srfi/43#vector-skip
    (lambda (_pred?88317_ _vec88318_ . _vectors88319_)
      (std/srfi/43#vector-index/skip
       (lambda _elts88321_ (not (apply _pred?88317_ _elts88321_)))
       _vec88318_
       _vectors88319_
       std/srfi/43#vector-skip)))
  (define std/srfi/43#vector-index/skip
    (letrec ((_loop188296_
              (lambda (_pred?88299_ _vec88300_ _len88301_ _i88302_)
                (if (= _i88302_ _len88301_)
                    '#f
                    (if (_pred?88299_ (vector-ref _vec88300_ _i88302_))
                        _i88302_
                        (_loop188296_
                         _pred?88299_
                         _vec88300_
                         _len88301_
                         (+ _i88302_ '1))))))
             (_loop2+88297_
              (lambda (_pred?88304_ _vectors88305_ _len88306_ _i88307_)
                (if (= _i88307_ _len88306_)
                    '#f
                    (if (apply _pred?88304_
                               (std/srfi/43#vectors-ref
                                _vectors88305_
                                _i88307_))
                        _i88307_
                        (_loop2+88297_
                         _pred?88304_
                         _vectors88305_
                         _len88306_
                         (+ _i88307_ '1)))))))
      (lambda (_pred?88309_ _vec88310_ _vectors88311_ _callee88312_)
        (let ((_pred?88314_
               (std/srfi/43#check-type procedure? _pred?88309_ _callee88312_))
              (_vec88315_
               (std/srfi/43#check-type vector? _vec88310_ _callee88312_)))
          (if (null? _vectors88311_)
              (_loop188296_
               _pred?88314_
               _vec88315_
               (vector-length _vec88315_)
               '0)
              (_loop2+88297_
               _pred?88314_
               (cons _vec88315_ _vectors88311_)
               (std/srfi/43#%smallest-length
                _vectors88311_
                (vector-length _vec88315_)
                _callee88312_)
               '0))))))
  (define std/srfi/43#vector-index-right
    (lambda (_pred?88292_ _vec88293_ . _vectors88294_)
      (std/srfi/43#vector-index/skip-right
       _pred?88292_
       _vec88293_
       _vectors88294_
       std/srfi/43#vector-index-right)))
  (define std/srfi/43#vector-skip-right
    (lambda (_pred?88286_ _vec88287_ . _vectors88288_)
      (std/srfi/43#vector-index/skip-right
       (lambda _elts88290_ (not (apply _pred?88286_ _elts88290_)))
       _vec88287_
       _vectors88288_
       std/srfi/43#vector-index-right)))
  (define std/srfi/43#vector-index/skip-right
    (letrec ((_loop188267_
              (lambda (_pred?88270_ _vec88271_ _i88272_)
                (if (negative? _i88272_)
                    '#f
                    (if (_pred?88270_ (vector-ref _vec88271_ _i88272_))
                        _i88272_
                        (_loop188267_
                         _pred?88270_
                         _vec88271_
                         (- _i88272_ '1))))))
             (_loop2+88268_
              (lambda (_pred?88274_ _vectors88275_ _i88276_)
                (if (negative? _i88276_)
                    '#f
                    (if (apply _pred?88274_
                               (std/srfi/43#vectors-ref
                                _vectors88275_
                                _i88276_))
                        _i88276_
                        (_loop2+88268_
                         _pred?88274_
                         _vectors88275_
                         (- _i88276_ '1)))))))
      (lambda (_pred?88278_ _vec88279_ _vectors88280_ _callee88281_)
        (let ((_pred?88283_
               (std/srfi/43#check-type procedure? _pred?88278_ _callee88281_))
              (_vec88284_
               (std/srfi/43#check-type vector? _vec88279_ _callee88281_)))
          (if (null? _vectors88280_)
              (_loop188267_
               _pred?88283_
               _vec88284_
               (- (vector-length _vec88284_) '1))
              (_loop2+88268_
               _pred?88283_
               (cons _vec88284_ _vectors88280_)
               (- (std/srfi/43#%smallest-length
                   _vectors88280_
                   (vector-length _vec88284_)
                   _callee88281_)
                  '1)))))))
  (define std/srfi/43#vector-binary-search
    (lambda (_vec88242_ _value88243_ _cmp88244_ . _maybe-start+end88245_)
      (let* ((_cmp88247_
              (std/srfi/43#check-type
               procedure?
               _cmp88244_
               std/srfi/43#vector-binary-search))
             (_vec88249_
              (std/srfi/43#check-type
               vector?
               _vec88242_
               std/srfi/43#vector-binary-search))
             (_g288633_
              (std/srfi/43#vector-parse-start+end
               _vec88249_
               _maybe-start+end88245_
               'start
               'end
               std/srfi/43#vector-binary-search)))
        (begin
          (let ((_g288634_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g288633_) (##vector-length _g288633_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g288634_ 2)))
                (error "Context expects 2 values" _g288634_)))
          (let ((_start88251_
                 (let () (declare (not safe)) (##vector-ref _g288633_ 0)))
                (_end88252_
                 (let () (declare (not safe)) (##vector-ref _g288633_ 1))))
            (let _loop88254_ ((_start88256_ _start88251_)
                              (_end88257_ _end88252_)
                              (_j88258_ '#f))
              (let ((_i88260_ (quotient (+ _start88256_ _end88257_) '2)))
                (if (or (= _start88256_ _end88257_)
                        (and _j88258_ (= _i88260_ _j88258_)))
                    '#f
                    (let ((_comparison88265_
                           (std/srfi/43#check-type
                            integer?
                            (_cmp88247_
                             (vector-ref _vec88249_ _i88260_)
                             _value88243_)
                            (cons _cmp88247_
                                  (cons 'for
                                        (cons std/srfi/43#vector-binary-search
                                              '()))))))
                      (if (zero? _comparison88265_)
                          _i88260_
                          (if (positive? _comparison88265_)
                              (_loop88254_ _start88256_ _i88260_ _i88260_)
                              (_loop88254_
                               _i88260_
                               _end88257_
                               _i88260_))))))))))))
  (define std/srfi/43#vector-any
    (letrec ((_loop188210_
              (lambda (_pred?88213_
                       _vec88214_
                       _i88215_
                       _len88216_
                       _len-188217_)
                (if (not (= _i88215_ _len88216_))
                    (if (= _i88215_ _len-188217_)
                        (_pred?88213_ (vector-ref _vec88214_ _i88215_))
                        (let ((_$e88219_
                               (_pred?88213_
                                (vector-ref _vec88214_ _i88215_))))
                          (if _$e88219_
                              _$e88219_
                              (_loop188210_
                               _pred?88213_
                               _vec88214_
                               (+ _i88215_ '1)
                               _len88216_
                               _len-188217_))))
                    '#f)))
             (_loop2+88211_
              (lambda (_pred?88222_
                       _vectors88223_
                       _i88224_
                       _len88225_
                       _len-188226_)
                (if (not (= _i88224_ _len88225_))
                    (if (= _i88224_ _len-188226_)
                        (apply _pred?88222_
                               (std/srfi/43#vectors-ref
                                _vectors88223_
                                _i88224_))
                        (let ((_$e88228_
                               (apply _pred?88222_
                                      (std/srfi/43#vectors-ref
                                       _vectors88223_
                                       _i88224_))))
                          (if _$e88228_
                              _$e88228_
                              (_loop2+88211_
                               _pred?88222_
                               _vectors88223_
                               (+ _i88224_ '1)
                               _len88225_
                               _len-188226_))))
                    '#f))))
      (lambda (_pred?88231_ _vec88232_ . _vectors88233_)
        (let ((_pred?88235_
               (std/srfi/43#check-type
                procedure?
                _pred?88231_
                std/srfi/43#vector-any))
              (_vec88236_
               (std/srfi/43#check-type
                vector?
                _vec88232_
                std/srfi/43#vector-any)))
          (if (null? _vectors88233_)
              (let ((_len88238_ (vector-length _vec88236_)))
                (_loop188210_
                 _pred?88235_
                 _vec88236_
                 '0
                 _len88238_
                 (- _len88238_ '1)))
              (let ((_len88240_
                     (std/srfi/43#%smallest-length
                      _vectors88233_
                      (vector-length _vec88236_)
                      std/srfi/43#vector-any)))
                (_loop2+88211_
                 _pred?88235_
                 (cons _vec88236_ _vectors88233_)
                 '0
                 _len88240_
                 (- _len88240_ '1))))))))
  (define std/srfi/43#vector-every
    (letrec ((_loop188178_
              (lambda (_pred?88181_
                       _vec88182_
                       _i88183_
                       _len88184_
                       _len-188185_)
                (let ((_$e88187_ (= _i88183_ _len88184_)))
                  (if _$e88187_
                      _$e88187_
                      (if (= _i88183_ _len-188185_)
                          (_pred?88181_ (vector-ref _vec88182_ _i88183_))
                          (if (_pred?88181_ (vector-ref _vec88182_ _i88183_))
                              (_loop188178_
                               _pred?88181_
                               _vec88182_
                               (+ _i88183_ '1)
                               _len88184_
                               _len-188185_)
                              '#f))))))
             (_loop2+88179_
              (lambda (_pred?88190_
                       _vectors88191_
                       _i88192_
                       _len88193_
                       _len-188194_)
                (let ((_$e88196_ (= _i88192_ _len88193_)))
                  (if _$e88196_
                      _$e88196_
                      (if (= _i88192_ _len-188194_)
                          (apply _pred?88190_
                                 (std/srfi/43#vectors-ref
                                  _vectors88191_
                                  _i88192_))
                          (if (apply _pred?88190_
                                     (std/srfi/43#vectors-ref
                                      _vectors88191_
                                      _i88192_))
                              (_loop2+88179_
                               _pred?88190_
                               _vectors88191_
                               (+ _i88192_ '1)
                               _len88193_
                               _len-188194_)
                              '#f)))))))
      (lambda (_pred?88199_ _vec88200_ . _vectors88201_)
        (let ((_pred?88203_
               (std/srfi/43#check-type
                procedure?
                _pred?88199_
                std/srfi/43#vector-every))
              (_vec88204_
               (std/srfi/43#check-type
                vector?
                _vec88200_
                std/srfi/43#vector-every)))
          (if (null? _vectors88201_)
              (let ((_len88206_ (vector-length _vec88204_)))
                (_loop188178_
                 _pred?88203_
                 _vec88204_
                 '0
                 _len88206_
                 (- _len88206_ '1)))
              (let ((_len88208_
                     (std/srfi/43#%smallest-length
                      _vectors88201_
                      (vector-length _vec88204_)
                      std/srfi/43#vector-every)))
                (_loop2+88179_
                 _pred?88203_
                 (cons _vec88204_ _vectors88201_)
                 '0
                 _len88208_
                 (- _len88208_ '1))))))))
  (define std/srfi/43#vector-swap!
    (lambda (_vec88167_ _i88168_ _j88169_)
      (let ((_vec88171_
             (std/srfi/43#check-type
              vector?
              _vec88167_
              std/srfi/43#vector-swap!)))
        (let ((_i88173_
               (std/srfi/43#check-index
                _vec88171_
                _i88168_
                std/srfi/43#vector-swap!))
              (_j88174_
               (std/srfi/43#check-index
                _vec88171_
                _j88169_
                std/srfi/43#vector-swap!)))
          (let ((_x88176_ (vector-ref _vec88171_ _i88173_)))
            (vector-set! _vec88171_ _i88173_ (vector-ref _vec88171_ _j88174_))
            (vector-set! _vec88171_ _j88174_ _x88176_))))))
  (define std/srfi/43#%%vector-fill!
    (let ((_%vector-fill!88151_ vector-fill!))
      (lambda (_vec88153_ _value88154_ . _maybe-start+end88155_)
        (if (null? _maybe-start+end88155_)
            (_%vector-fill!88151_ _vec88153_ _value88154_)
            (let* ((_vec88157_
                    (std/srfi/43#check-type vector? _vec88153_ vector-fill!))
                   (_g288635_
                    (std/srfi/43#vector-parse-start+end
                     _vec88157_
                     _maybe-start+end88155_
                     'start
                     'end
                     vector-fill!)))
              (begin
                (let ((_g288636_
                       (let ()
                         (declare (not safe))
                         (if (##values? _g288635_)
                             (##vector-length _g288635_)
                             1))))
                  (if (not (let () (declare (not safe)) (##fx= _g288636_ 2)))
                      (error "Context expects 2 values" _g288636_)))
                (let ((_start88159_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g288635_ 0)))
                      (_end88160_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g288635_ 1))))
                  (let _$loop88162_ ((_i88165_ _start88159_))
                    (if (= _i88165_ _end88160_)
                        '#!void
                        (begin
                          (vector-set! _vec88157_ _i88165_ _value88154_)
                          (_$loop88162_ (+ _i88165_ '1))))))))))))
  (define std/srfi/43#vector-copy!
    (lambda (_target88134_
             _tstart88135_
             _source88136_
             .
             _maybe-sstart+send88137_)
      (letrec ((_doit!88139_
                (lambda (_sstart88143_ _send88144_ _source-length88145_)
                  (let ((_tstart88147_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _tstart88135_
                          std/srfi/43#vector-copy!))
                        (_sstart88148_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _sstart88143_
                          std/srfi/43#vector-copy!))
                        (_send88149_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _send88144_
                          std/srfi/43#vector-copy!)))
                    (if (and (<= '0
                                 _sstart88148_
                                 _send88149_
                                 _source-length88145_)
                             (<= (+ _tstart88147_
                                    (- _send88149_ _sstart88148_))
                                 (vector-length _target88134_)))
                        (std/srfi/43#%vector-copy!
                         _target88134_
                         _tstart88147_
                         _source88136_
                         _sstart88148_
                         _send88149_)
                        (error '"illegal arguments"
                               (cons 'while
                                     (cons 'calling
                                           (cons std/srfi/43#vector-copy!
                                                 '())))
                               (cons 'target
                                     (cons 'was (cons _target88134_ '())))
                               (cons 'target-length
                                     (cons 'was
                                           (cons (vector-length _target88134_)
                                                 '())))
                               (cons 'tstart
                                     (cons 'was (cons _tstart88147_ '())))
                               (cons 'source
                                     (cons 'was (cons _source88136_ '())))
                               (cons 'source-length
                                     (cons 'was
                                           (cons _source-length88145_ '())))
                               (cons 'sstart
                                     (cons 'was (cons _sstart88148_ '())))
                               (cons 'send
                                     (cons 'was (cons _send88149_ '())))))))))
        (let ((_n88141_ (vector-length _source88136_)))
          (if (null? _maybe-sstart+send88137_)
              (_doit!88139_ '0 _n88141_ _n88141_)
              (if (null? (cdr _maybe-sstart+send88137_))
                  (_doit!88139_
                   (car _maybe-sstart+send88137_)
                   _n88141_
                   _n88141_)
                  (if (null? (cddr _maybe-sstart+send88137_))
                      (_doit!88139_
                       (car _maybe-sstart+send88137_)
                       (cadr _maybe-sstart+send88137_)
                       _n88141_)
                      (error '"too many arguments"
                             std/srfi/43#vector-copy!
                             (cddr _maybe-sstart+send88137_)))))))))
  (define std/srfi/43#vector-reverse-copy!
    (lambda (_target88114_
             _tstart88115_
             _source88116_
             .
             _maybe-sstart+send88117_)
      (letrec ((_doit!88119_
                (lambda (_sstart88123_ _send88124_ _source-length88125_)
                  (let ((_tstart88127_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _tstart88115_
                          std/srfi/43#vector-reverse-copy!))
                        (_sstart88128_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _sstart88123_
                          std/srfi/43#vector-reverse-copy!))
                        (_send88129_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _send88124_
                          std/srfi/43#vector-reverse-copy!)))
                    (if (and (eq? _target88114_ _source88116_)
                             (or (std/srfi/43#between?
                                  _sstart88128_
                                  _tstart88127_
                                  _send88129_)
                                 (std/srfi/43#between?
                                  _tstart88127_
                                  _sstart88128_
                                  (+ _tstart88127_
                                     (- _send88129_ _sstart88128_)))))
                        (error '"vector range for self-copying overlaps"
                               std/srfi/43#vector-reverse-copy!
                               (cons 'vector
                                     (cons 'was (cons _target88114_ '())))
                               (cons 'tstart
                                     (cons 'was (cons _tstart88127_ '())))
                               (cons 'sstart
                                     (cons 'was (cons _sstart88128_ '())))
                               (cons 'send (cons 'was (cons _send88129_ '()))))
                        (if (and (<= '0
                                     _sstart88128_
                                     _send88129_
                                     _source-length88125_)
                                 (<= (+ _tstart88127_
                                        (- _send88129_ _sstart88128_))
                                     (vector-length _target88114_)))
                            (std/srfi/43#%vector-reverse-copy!
                             _target88114_
                             _tstart88127_
                             _source88116_
                             _sstart88128_
                             _send88129_)
                            (error '"illegal arguments"
                                   (cons 'while
                                         (cons 'calling
                                               (cons std/srfi/43#vector-reverse-copy!
                                                     '())))
                                   (cons 'target
                                         (cons 'was (cons _target88114_ '())))
                                   (cons 'target-length
                                         (cons 'was
                                               (cons (vector-length
                                                      _target88114_)
                                                     '())))
                                   (cons 'tstart
                                         (cons 'was (cons _tstart88127_ '())))
                                   (cons 'source
                                         (cons 'was (cons _source88116_ '())))
                                   (cons 'source-length
                                         (cons 'was
                                               (cons _source-length88125_
                                                     '())))
                                   (cons 'sstart
                                         (cons 'was (cons _sstart88128_ '())))
                                   (cons 'send
                                         (cons 'was
                                               (cons _send88129_ '()))))))))))
        (let ((_n88121_ (vector-length _source88116_)))
          (if (null? _maybe-sstart+send88117_)
              (_doit!88119_ '0 _n88121_ _n88121_)
              (if (null? (cdr _maybe-sstart+send88117_))
                  (_doit!88119_
                   (car _maybe-sstart+send88117_)
                   _n88121_
                   _n88121_)
                  (if (null? (cddr _maybe-sstart+send88117_))
                      (_doit!88119_
                       (car _maybe-sstart+send88117_)
                       (cadr _maybe-sstart+send88117_)
                       _n88121_)
                      (error '"too many arguments"
                             std/srfi/43#vector-reverse-copy!
                             (cddr _maybe-sstart+send88117_)))))))))
  (define std/srfi/43#vector-reverse!
    (lambda (_vec88106_ . _start+end88107_)
      (let* ((_vec88109_
              (std/srfi/43#check-type
               vector?
               _vec88106_
               std/srfi/43#vector-reverse!))
             (_g288637_
              (std/srfi/43#vector-parse-start+end
               _vec88109_
               _start+end88107_
               'start
               'end
               std/srfi/43#vector-reverse!)))
        (begin
          (let ((_g288638_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g288637_) (##vector-length _g288637_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g288638_ 2)))
                (error "Context expects 2 values" _g288638_)))
          (let ((_start88111_
                 (let () (declare (not safe)) (##vector-ref _g288637_ 0)))
                (_end88112_
                 (let () (declare (not safe)) (##vector-ref _g288637_ 1))))
            (std/srfi/43#%vector-reverse!
             _vec88109_
             _start88111_
             _end88112_))))))
  (define std/srfi/43#%%vector->list
    (let ((_%vector->list88090_ vector->list))
      (lambda (_vec88092_ . _maybe-start+end88093_)
        (if (null? _maybe-start+end88093_)
            (_%vector->list88090_ _vec88092_)
            (let* ((_vec88095_
                    (std/srfi/43#check-type vector? _vec88092_ vector->list))
                   (_g288639_
                    (std/srfi/43#vector-parse-start+end
                     _vec88095_
                     _maybe-start+end88093_
                     'start
                     'end
                     vector->list)))
              (begin
                (let ((_g288640_
                       (let ()
                         (declare (not safe))
                         (if (##values? _g288639_)
                             (##vector-length _g288639_)
                             1))))
                  (if (not (let () (declare (not safe)) (##fx= _g288640_ 2)))
                      (error "Context expects 2 values" _g288640_)))
                (let ((_start88097_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g288639_ 0)))
                      (_end88098_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g288639_ 1))))
                  (let _$loop88100_ ((_i88103_ (- _end88098_ '1))
                                     (_result88104_ '()))
                    (if (< _i88103_ _start88097_)
                        _result88104_
                        (_$loop88100_
                         (- _i88103_ '1)
                         (cons (vector-ref _vec88095_ _i88103_)
                               _result88104_)))))))))))
  (define std/srfi/43#reverse-vector->list
    (lambda (_vec88076_ . _maybe-start+end88077_)
      (let* ((_vec88079_
              (std/srfi/43#check-type
               vector?
               _vec88076_
               std/srfi/43#reverse-vector->list))
             (_g288641_
              (std/srfi/43#vector-parse-start+end
               _vec88079_
               _maybe-start+end88077_
               'start
               'end
               std/srfi/43#reverse-vector->list)))
        (begin
          (let ((_g288642_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g288641_) (##vector-length _g288641_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g288642_ 2)))
                (error "Context expects 2 values" _g288642_)))
          (let ((_start88081_
                 (let () (declare (not safe)) (##vector-ref _g288641_ 0)))
                (_end88082_
                 (let () (declare (not safe)) (##vector-ref _g288641_ 1))))
            (let _$loop88084_ ((_i88087_ _start88081_) (_result88088_ '()))
              (if (= _i88087_ _end88082_)
                  _result88088_
                  (_$loop88084_
                   (+ _i88087_ '1)
                   (cons (vector-ref _vec88079_ _i88087_)
                         _result88088_)))))))))
  (define std/srfi/43#%%list->vector
    (let ((_%list->vector88030_ list->vector))
      (lambda (_lst88032_ . _maybe-start+end88033_)
        (if (null? _maybe-start+end88033_)
            (_%list->vector88030_ _lst88032_)
            (if (null? _maybe-start+end88033_)
                (let* ((_start88035_ '0) (_end88037_ (length _lst88032_)))
                  (let ((_start88040_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _start88035_
                          list->vector))
                        (_end88041_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _end88037_
                          list->vector)))
                    ((lambda (_f88043_)
                       (std/srfi/43#vector-unfold
                        _f88043_
                        (- _end88041_ _start88040_)
                        (list-tail _lst88032_ _start88040_)))
                     (lambda (_index88045_ _l88046_)
                       (if (null? _l88046_)
                           (error '"list was too short"
                                  (cons 'list
                                        (cons 'was (cons _lst88032_ '())))
                                  (cons 'attempted
                                        (cons 'end
                                              (cons 'was
                                                    (cons _end88041_ '()))))
                                  (cons 'while
                                        (cons 'calling
                                              (cons std/srfi/43#%%list->vector
                                                    '()))))
                           (if (pair? _l88046_)
                               (values (car _l88046_) (cdr _l88046_))
                               (error '"erroneous value"
                                      (list list? _lst88032_)
                                      (cons 'while
                                            (cons 'calling
                                                  (cons std/srfi/43#%%list->vector
                                                        '()))))))))))
                (let ((_start88048_ (car _maybe-start+end88033_))
                      (_new-args88049_ (cdr _maybe-start+end88033_)))
                  (if (null? _new-args88049_)
                      (let ((_end88052_ (length _lst88032_)))
                        (let ((_start88055_
                               (std/srfi/43#check-type
                                std/srfi/43#nonneg-int?
                                _start88048_
                                list->vector))
                              (_end88056_
                               (std/srfi/43#check-type
                                std/srfi/43#nonneg-int?
                                _end88052_
                                list->vector)))
                          ((lambda (_f88058_)
                             (std/srfi/43#vector-unfold
                              _f88058_
                              (- _end88056_ _start88055_)
                              (list-tail _lst88032_ _start88055_)))
                           (lambda (_index88060_ _l88061_)
                             (if (null? _l88061_)
                                 (error '"list was too short"
                                        (cons 'list
                                              (cons 'was
                                                    (cons _lst88032_ '())))
                                        (cons 'attempted
                                              (cons 'end
                                                    (cons 'was
                                                          (cons _end88056_
                                                                '()))))
                                        (cons 'while
                                              (cons 'calling
                                                    (cons std/srfi/43#%%list->vector
                                                          '()))))
                                 (if (pair? _l88061_)
                                     (values (car _l88061_) (cdr _l88061_))
                                     (error '"erroneous value"
                                            (list list? _lst88032_)
                                            (cons 'while
                                                  (cons 'calling
                                                        (cons std/srfi/43#%%list->vector
                                                              '()))))))))))
                      (let ((_end88063_ (car _new-args88049_))
                            (_new-args88064_ (cdr _new-args88049_)))
                        (if (null? _new-args88064_)
                            (let ()
                              (let ((_start88068_
                                     (std/srfi/43#check-type
                                      std/srfi/43#nonneg-int?
                                      _start88048_
                                      list->vector))
                                    (_end88069_
                                     (std/srfi/43#check-type
                                      std/srfi/43#nonneg-int?
                                      _end88063_
                                      list->vector)))
                                ((lambda (_f88071_)
                                   (std/srfi/43#vector-unfold
                                    _f88071_
                                    (- _end88069_ _start88068_)
                                    (list-tail _lst88032_ _start88068_)))
                                 (lambda (_index88073_ _l88074_)
                                   (if (null? _l88074_)
                                       (error '"list was too short"
                                              (cons 'list
                                                    (cons 'was
                                                          (cons _lst88032_
                                                                '())))
                                              (cons 'attempted
                                                    (cons 'end
                                                          (cons 'was
                                                                (cons _end88069_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              '()))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (cons 'while
                                                    (cons 'calling
                                                          (cons std/srfi/43#%%list->vector
                                                                '()))))
                                       (if (pair? _l88074_)
                                           (values (car _l88074_)
                                                   (cdr _l88074_))
                                           (error '"erroneous value"
                                                  (list list? _lst88032_)
                                                  (cons 'while
                                                        (cons 'calling
                                                              (cons std/srfi/43#%%list->vector
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            '()))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                            (error '"too many arguments"
                                   (length _maybe-start+end88033_)
                                   _maybe-start+end88033_))))))))))
  (define std/srfi/43#reverse-list->vector
    (lambda (_lst87986_ . _maybe-start+end87987_)
      (if (null? _maybe-start+end87987_)
          (let* ((_start87989_ '0) (_end87991_ (length _lst87986_)))
            (let ((_start87994_
                   (std/srfi/43#check-type
                    std/srfi/43#nonneg-int?
                    _start87989_
                    std/srfi/43#reverse-list->vector))
                  (_end87995_
                   (std/srfi/43#check-type
                    std/srfi/43#nonneg-int?
                    _end87991_
                    std/srfi/43#reverse-list->vector)))
              ((lambda (_f87997_)
                 (std/srfi/43#vector-unfold-right
                  _f87997_
                  (- _end87995_ _start87994_)
                  (list-tail _lst87986_ _start87994_)))
               (lambda (_index87999_ _l88000_)
                 (if (null? _l88000_)
                     (error '"list too short"
                            (cons 'list (cons 'was (cons _lst87986_ '())))
                            (cons 'attempted
                                  (cons 'end
                                        (cons 'was (cons _end87995_ '()))))
                            (cons 'while
                                  (cons 'calling
                                        (cons std/srfi/43#reverse-list->vector
                                              '()))))
                     (if (pair? _l88000_)
                         (values (car _l88000_) (cdr _l88000_))
                         (error '"erroneous value"
                                (list list? _lst87986_)
                                (cons 'while
                                      (cons 'calling
                                            (cons std/srfi/43#reverse-list->vector
                                                  '()))))))))))
          (let ((_start88002_ (car _maybe-start+end87987_))
                (_new-args88003_ (cdr _maybe-start+end87987_)))
            (if (null? _new-args88003_)
                (let ((_end88006_ (length _lst87986_)))
                  (let ((_start88009_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _start88002_
                          std/srfi/43#reverse-list->vector))
                        (_end88010_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _end88006_
                          std/srfi/43#reverse-list->vector)))
                    ((lambda (_f88012_)
                       (std/srfi/43#vector-unfold-right
                        _f88012_
                        (- _end88010_ _start88009_)
                        (list-tail _lst87986_ _start88009_)))
                     (lambda (_index88014_ _l88015_)
                       (if (null? _l88015_)
                           (error '"list too short"
                                  (cons 'list
                                        (cons 'was (cons _lst87986_ '())))
                                  (cons 'attempted
                                        (cons 'end
                                              (cons 'was
                                                    (cons _end88010_ '()))))
                                  (cons 'while
                                        (cons 'calling
                                              (cons std/srfi/43#reverse-list->vector
                                                    '()))))
                           (if (pair? _l88015_)
                               (values (car _l88015_) (cdr _l88015_))
                               (error '"erroneous value"
                                      (list list? _lst87986_)
                                      (cons 'while
                                            (cons 'calling
                                                  (cons std/srfi/43#reverse-list->vector
                                                        '()))))))))))
                (let ((_end88017_ (car _new-args88003_))
                      (_new-args88018_ (cdr _new-args88003_)))
                  (if (null? _new-args88018_)
                      (let ()
                        (let ((_start88022_
                               (std/srfi/43#check-type
                                std/srfi/43#nonneg-int?
                                _start88002_
                                std/srfi/43#reverse-list->vector))
                              (_end88023_
                               (std/srfi/43#check-type
                                std/srfi/43#nonneg-int?
                                _end88017_
                                std/srfi/43#reverse-list->vector)))
                          ((lambda (_f88025_)
                             (std/srfi/43#vector-unfold-right
                              _f88025_
                              (- _end88023_ _start88022_)
                              (list-tail _lst87986_ _start88022_)))
                           (lambda (_index88027_ _l88028_)
                             (if (null? _l88028_)
                                 (error '"list too short"
                                        (cons 'list
                                              (cons 'was
                                                    (cons _lst87986_ '())))
                                        (cons 'attempted
                                              (cons 'end
                                                    (cons 'was
                                                          (cons _end88023_
                                                                '()))))
                                        (cons 'while
                                              (cons 'calling
                                                    (cons std/srfi/43#reverse-list->vector
                                                          '()))))
                                 (if (pair? _l88028_)
                                     (values (car _l88028_) (cdr _l88028_))
                                     (error '"erroneous value"
                                            (list list? _lst87986_)
                                            (cons 'while
                                                  (cons 'calling
                                                        (cons std/srfi/43#reverse-list->vector
                                                              '()))))))))))
                      (error '"too many arguments"
                             (length _maybe-start+end87987_)
                             _maybe-start+end87987_)))))))))
