(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/text/zlib#compress__%
    (lambda (_data170801_ _level170802_)
      (if (u8vector? _data170801_)
          (std/text/zlib#compress-bytes _data170801_ _level170802_)
          (if (string? _data170801_)
              (std/text/zlib#compress-bytes
               (std/text/utf8#string->utf8__0 _data170801_)
               _level170802_)
              (if (input-port? _data170801_)
                  (std/text/zlib#compress-port _data170801_ _level170802_)
                  (error '"Bad input source" _data170801_))))))
  (define std/text/zlib#compress__0
    (lambda (_data170807_)
      (let ((_level170809_ std/text/_zlib#Z_DEFAULT_COMPRESSION))
        (std/text/zlib#compress__% _data170807_ _level170809_))))
  (define std/text/zlib#compress
    (lambda _g290341_
      (let ((_g290340_ (let () (declare (not safe)) (##length _g290341_))))
        (cond ((let () (declare (not safe)) (##fx= _g290340_ 1))
               (apply std/text/zlib#compress__0 _g290341_))
              ((let () (declare (not safe)) (##fx= _g290340_ 2))
               (apply std/text/zlib#compress__% _g290341_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/zlib#compress
                _g290341_))))))
  (define std/text/zlib#compress-bytes
    (lambda (_data170792_ _level170793_)
      (let* ((_buf170795_
              (make-u8vector
               (std/text/_zlib#compressBound (u8vector-length _data170792_))))
             (_res170797_
              (std/text/_zlib#compress2
               _buf170795_
               _data170792_
               _level170793_)))
        (if (let () (declare (not safe)) (##fxnegative? _res170797_))
            (std/error#raise-io-error 'compress '"zlib error" _res170797_)
            (begin (u8vector-shrink! _buf170795_ _res170797_) _buf170795_)))))
  (define std/text/zlib#compress-port
    (lambda (_inp170789_ _level170790_)
      (std/text/zlib#deflate-port
       _inp170789_
       _level170790_
       std/text/_zlib#deflateInit)))
  (define std/text/zlib#compress-gz__%
    (lambda (_data170776_ _level170777_)
      (if (u8vector? _data170776_)
          (std/text/zlib#compress-gz-bytes _data170776_ _level170777_)
          (if (string? _data170776_)
              (std/text/zlib#compress-gz-bytes
               (std/text/utf8#string->utf8__0 _data170776_)
               _level170777_)
              (if (input-port? _data170776_)
                  (std/text/zlib#compress-gz-port _data170776_ _level170777_)
                  (error '"Bad input source" _data170776_))))))
  (define std/text/zlib#compress-gz__0
    (lambda (_data170782_)
      (let ((_level170784_ std/text/_zlib#Z_DEFAULT_COMPRESSION))
        (std/text/zlib#compress-gz__% _data170782_ _level170784_))))
  (define std/text/zlib#compress-gz
    (lambda _g290343_
      (let ((_g290342_ (let () (declare (not safe)) (##length _g290343_))))
        (cond ((let () (declare (not safe)) (##fx= _g290342_ 1))
               (apply std/text/zlib#compress-gz__0 _g290343_))
              ((let () (declare (not safe)) (##fx= _g290342_ 2))
               (apply std/text/zlib#compress-gz__% _g290343_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/zlib#compress-gz
                _g290343_))))))
  (define std/text/zlib#compress-gz-bytes
    (lambda (_data170764_ _level170765_)
      (let* ((_zs170767_ (std/text/_zlib#make_z_stream))
             (_res170769_
              (std/text/_zlib#deflateInit_gz _zs170767_ _level170765_)))
        (if (eq? _res170769_ std/text/_zlib#Z_OK)
            '#!void
            (std/error#raise-io-error
             'compress
             '"zlib stream initialization error"
             _res170769_))
        (with-unwind-protect
         (lambda () (std/text/zlib#compress-gz-data _zs170767_ _data170764_))
         (lambda () (std/text/_zlib#deflateEnd _zs170767_))))))
  (define std/text/zlib#compress-gz-data
    (lambda (_zs170756_ _data170757_)
      (let* ((_buf170759_
              (make-u8vector
               (std/text/_zlib#deflateBound
                _zs170756_
                (u8vector-length _data170757_))))
             (_res170761_
              (std/text/_zlib#deflate
               _zs170756_
               _buf170759_
               _data170757_
               '0
               std/text/_zlib#Z_FINISH)))
        (if (eq? _res170761_ std/text/_zlib#Z_STREAM_END)
            '#!void
            (std/error#raise-io-error
             'compress-gz
             '"incomplete deflate"
             (std/text/_zlib#z_stream_msg _zs170756_)
             _res170761_))
        (u8vector-shrink!
         _buf170759_
         (std/text/_zlib#z_stream_total_out _zs170756_))
        _buf170759_)))
  (define std/text/zlib#compress-gz-port
    (lambda (_inp170753_ _level170754_)
      (std/text/zlib#deflate-port
       _inp170753_
       _level170754_
       std/text/_zlib#deflateInit_gz)))
  (define std/text/zlib#deflate-port
    (lambda (_inp170741_ _level170742_ _init-e170743_)
      (let* ((_zs170745_ (std/text/_zlib#make_z_stream))
             (_res170747_ (_init-e170743_ _zs170745_ _level170742_)))
        (if (eq? _res170747_ std/text/_zlib#Z_OK)
            '#!void
            (std/error#raise-io-error
             'compress
             '"zlib stream initialization error"
             _res170747_))
        (with-unwind-protect
         (lambda () (std/text/zlib#do-deflate-port _zs170745_ _inp170741_))
         (lambda () (std/text/_zlib#deflateEnd _zs170745_))))))
  (define std/text/zlib#do-deflate-port
    (lambda (_zs170699_ _inp170700_)
      (letrec* ((_buflen170702_ '1024)
                (_fini170703_
                 (lambda (_r170739_)
                   (u8vector-concatenate (reverse _r170739_))))
                (_deflate-next170704_
                 (lambda (_ibuf170716_ _r170717_ _flush170718_)
                   (let _lp170720_ ((_obuf170722_
                                     (make-u8vector _buflen170702_))
                                    (_start170723_ '0)
                                    (_r170724_ _r170717_))
                     (let* ((_icount170726_
                             (std/text/_zlib#z_stream_total_in _zs170699_))
                            (_ocount170728_
                             (std/text/_zlib#z_stream_total_out _zs170699_))
                            (_res170730_
                             (std/text/_zlib#deflate
                              _zs170699_
                              _obuf170722_
                              _ibuf170716_
                              _start170723_
                              _flush170718_))
                            (_ocount170732_
                             (let ((__tmp290344
                                    (std/text/_zlib#z_stream_total_out
                                     _zs170699_)))
                               (declare (not safe))
                               (##fx- __tmp290344 _ocount170728_))))
                       (if (eq? _res170730_ std/text/_zlib#Z_OK)
                           (let ((_acount170735_
                                  (std/text/_zlib#z_stream_avail_out
                                   _zs170699_)))
                             (if (let ()
                                   (declare (not safe))
                                   (##fxzero? _acount170735_))
                                 (let ((_icount170737_
                                        (let ((__tmp290345
                                               (std/text/_zlib#z_stream_total_in
                                                _zs170699_)))
                                          (declare (not safe))
                                          (##fx- __tmp290345 _icount170726_))))
                                   (u8vector-shrink!
                                    _obuf170722_
                                    _ocount170732_)
                                   (_lp170720_
                                    (make-u8vector _buflen170702_)
                                    (let ()
                                      (declare (not safe))
                                      (##fx+ _start170723_ _icount170737_))
                                    (cons _obuf170722_ _r170724_)))
                                 (if (let ()
                                       (declare (not safe))
                                       (##fx> _ocount170732_ '0))
                                     (begin
                                       (u8vector-shrink!
                                        _obuf170722_
                                        _ocount170732_)
                                       (cons _obuf170722_ _r170724_))
                                     _r170724_)))
                           (if (eq? _res170730_ std/text/_zlib#Z_STREAM_END)
                               (if (let ()
                                     (declare (not safe))
                                     (##fx> _ocount170732_ '0))
                                   (begin
                                     (u8vector-shrink!
                                      _obuf170722_
                                      _ocount170732_)
                                     (cons _obuf170722_ _r170724_))
                                   _r170724_)
                               (std/error#raise-io-error
                                'deflate-port
                                '"deflate: zlib error"
                                (std/text/_zlib#z_stream_msg _zs170699_)
                                _res170730_))))))))
        (let ((_ibuf170706_ (make-u8vector _buflen170702_)))
          (let _lp170708_ ((_r170710_ '()))
            (let ((_rd170712_
                   (read-subu8vector
                    _ibuf170706_
                    '0
                    _buflen170702_
                    _inp170700_)))
              (if (let () (declare (not safe)) (##fxzero? _rd170712_))
                  (_fini170703_
                   (_deflate-next170704_
                    '#f
                    _r170710_
                    std/text/_zlib#Z_FINISH))
                  (if (let ()
                        (declare (not safe))
                        (##fx< _rd170712_ _buflen170702_))
                      (begin
                        (u8vector-shrink! _ibuf170706_ _rd170712_)
                        (_fini170703_
                         (_deflate-next170704_
                          _ibuf170706_
                          _r170710_
                          std/text/_zlib#Z_FINISH)))
                      (let ((_r170714_
                             (_deflate-next170704_
                              _ibuf170706_
                              _r170710_
                              std/text/_zlib#Z_NO_FLUSH)))
                        (_lp170708_ _r170714_))))))))))
  (define std/text/zlib#uncompress
    (lambda (_data170697_)
      (if (u8vector? _data170697_)
          (std/text/zlib#uncompress-bytes _data170697_)
          (if (input-port? _data170697_)
              (std/text/zlib#uncompress-port _data170697_)
              (error '"Bad input source" _data170697_)))))
  (define std/text/zlib#uncompress-bytes
    (lambda (_data170695_)
      (std/text/zlib#do-inflate _data170695_ std/text/zlib#uncompress-data)))
  (define std/text/zlib#do-inflate
    (lambda (_data170684_ _inflate-e170685_)
      (let* ((_zs170687_ (std/text/_zlib#make_z_stream))
             (_res170689_ (std/text/_zlib#inflateInit _zs170687_)))
        (if (eq? _res170689_ std/text/_zlib#Z_OK)
            '#!void
            (std/error#raise-io-error
             'uncompress
             '"zlib stream initialization error"
             _res170689_))
        (with-unwind-protect
         (lambda () (_inflate-e170685_ _zs170687_ _data170684_))
         (lambda () (std/text/_zlib#inflateEnd _zs170687_))))))
  (define std/text/zlib#uncompress-data
    (lambda (_zs170661_ _data170662_)
      (letrec* ((_buflen170664_ '1024))
        (let _lp170666_ ((_start170668_ '0) (_r170669_ '()))
          (let* ((_buf170671_ (make-u8vector _buflen170664_))
                 (_icount170673_ (std/text/_zlib#z_stream_total_in _zs170661_))
                 (_ocount170675_
                  (std/text/_zlib#z_stream_total_out _zs170661_))
                 (_res170677_
                  (std/text/_zlib#inflate
                   _zs170661_
                   _buf170671_
                   _data170662_
                   _start170668_))
                 (_ocount170679_
                  (let ((__tmp290346
                         (std/text/_zlib#z_stream_total_out _zs170661_)))
                    (declare (not safe))
                    (##fx- __tmp290346 _ocount170675_))))
            (if (eq? _res170677_ std/text/_zlib#Z_OK)
                (let ((_icount170682_
                       (let ((__tmp290347
                              (std/text/_zlib#z_stream_total_in _zs170661_)))
                         (declare (not safe))
                         (##fx- __tmp290347 _icount170673_))))
                  (u8vector-shrink! _buf170671_ _ocount170679_)
                  (_lp170666_
                   (let ()
                     (declare (not safe))
                     (##fx+ _start170668_ _icount170682_))
                   (cons _buf170671_ _r170669_)))
                (if (eq? _res170677_ std/text/_zlib#Z_STREAM_END)
                    (begin
                      (u8vector-shrink! _buf170671_ _ocount170679_)
                      (u8vector-concatenate
                       (reverse (cons _buf170671_ _r170669_))))
                    (std/error#raise-io-error
                     'uncompress
                     '"zlib error"
                     (std/text/_zlib#z_stream_msg _zs170661_)
                     _res170677_))))))))
  (define std/text/zlib#uncompress-port
    (lambda (_inp170659_)
      (std/text/zlib#do-inflate _inp170659_ std/text/zlib#do-inflate-port)))
  (define std/text/zlib#do-inflate-port
    (lambda (_zs170619_ _inp170620_)
      (letrec* ((_buflen170622_ '1024)
                (_fini170623_
                 (lambda (_r170657_)
                   (u8vector-concatenate (reverse _r170657_))))
                (_inflate-next170624_
                 (lambda (_ibuf170634_ _r170635_)
                   (let _lp170637_ ((_obuf170639_
                                     (make-u8vector _buflen170622_))
                                    (_start170640_ '0)
                                    (_r170641_ _r170635_))
                     (let* ((_icount170643_
                             (std/text/_zlib#z_stream_total_in _zs170619_))
                            (_ocount170645_
                             (std/text/_zlib#z_stream_total_out _zs170619_))
                            (_res170647_
                             (std/text/_zlib#inflate
                              _zs170619_
                              _obuf170639_
                              _ibuf170634_
                              _start170640_))
                            (_ocount170649_
                             (let ((__tmp290348
                                    (std/text/_zlib#z_stream_total_out
                                     _zs170619_)))
                               (declare (not safe))
                               (##fx- __tmp290348 _ocount170645_))))
                       (if (eq? _res170647_ std/text/_zlib#Z_OK)
                           (let* ((_icount170652_
                                   (let ((__tmp290349
                                          (std/text/_zlib#z_stream_total_in
                                           _zs170619_)))
                                     (declare (not safe))
                                     (##fx- __tmp290349 _icount170643_)))
                                  (_start170654_
                                   (let ()
                                     (declare (not safe))
                                     (##fx+ _start170640_ _icount170652_))))
                             (u8vector-shrink! _obuf170639_ _ocount170649_)
                             (if (let ()
                                   (declare (not safe))
                                   (##fx< _start170654_ _buflen170622_))
                                 (_lp170637_
                                  (make-u8vector _buflen170622_)
                                  _start170654_
                                  (cons _obuf170639_ _r170641_))
                                 (cons _obuf170639_ _r170641_)))
                           (if (eq? _res170647_ std/text/_zlib#Z_STREAM_END)
                               (begin
                                 (u8vector-shrink! _obuf170639_ _ocount170649_)
                                 (cons _obuf170639_ _r170641_))
                               (std/error#raise-io-error
                                'inflate-port
                                '"zlib error"
                                (std/text/_zlib#z_stream_msg _zs170619_)
                                _res170647_))))))))
        (let ((_ibuf170626_ (make-u8vector _buflen170622_)))
          (let _lp170628_ ((_r170630_ '()))
            (let ((_rd170632_
                   (read-subu8vector
                    _ibuf170626_
                    '0
                    _buflen170622_
                    _inp170620_)))
              (if (let () (declare (not safe)) (##fxzero? _rd170632_))
                  (_fini170623_ _r170630_)
                  (if (let ()
                        (declare (not safe))
                        (##fx< _rd170632_ _buflen170622_))
                      (begin
                        (u8vector-shrink! _ibuf170626_ _rd170632_)
                        (_fini170623_
                         (_inflate-next170624_ _ibuf170626_ _r170630_)))
                      (_lp170628_
                       (_inflate-next170624_ _ibuf170626_ _r170630_)))))))))))
